/*******************************************************************************
*
*  CodecInit.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.module/RAM                                 modCodecInit;

#include ".\chicsys\hdr\chichdr.h"
#include ".\comsys\hdr\comhdr.h"
#include ".\gen_fx\hdr\GenFX.h"

.ENTRY      InitAD1885;

InitAD1885:

/*
 *  nb!  reset and warmup codec code was here, but we can't do this
 *       due to different h/w config.  cycle times were:
 *
 *			reset:   34
 *			warmup:  7000
 *
 *		 we could put some delay loop here, but can't reset, unless
 *       it can be done by writing a control word to codec
 */

Enable_SPORT0_Transfers:
    AR = DM(SYSTEM_CONTROL);
    AR = setbit SPORT0_ENABLE of AR;
    DM(SYSTEM_CONTROL) = AR;
    IMASK = SPORT0TX_IRQ;
   
    /* Prime the transmit reg to kick off tx autobuffering */
    AX0 = DM(i1, m1);                    
    TX0 = AX0;

/*
 *  wait for bit15 of TAG_PHASE slot to go high.  indicates codec ready to
 *  receive comamnds from DSP.
 */

Wait_Codec_Ready:           
    AX0 = DM(a_rxBuf + TAG_PHASE);
    AY0 = 0x8000;           
    AF = AX0 and AY0;       
    if EQ jump Wait_Codec_Ready;
            
    idle;
    idle;        

    /* stop transmitting data to codec */
    DM(a_txBuf+TAG_PHASE)=M0;  
    DM(a_txBuf+COMMAND_ADDRESS_SLOT) = M0;
    DM(a_txBuf+COMMAND_DATA_SLOT) = M0;
    
    idle;
    idle;

Initialize_1885_Registers:
    I4 = ^a_InitCodecRegisters;
    L4 = 0;
    
    AR = ENABLE_VFbit_SLOT1_SLOT2;
    
    CNTR = 19;
    do CI until CE;
      DM(a_txBuf + TAG_PHASE) = ar;
      SI = DM(I4, M7);
      DM(a_txBuf + COMMAND_ADDRESS_SLOT) = si;
      SI = DM(I4, M7);
      DM(a_txBuf + COMMAND_DATA_SLOT) = si;
      idle;
      nop;                                  /* keep nops at end of loop! */ 
CI:   nop;
     
    DM(a_txBuf+TAG_PHASE) = M0;
    idle;

    IFC = 0xff;                             /* Clear pending interupts */
    nop;
   
    /* codec initialized, unmute outputs! */
    DM(b_CodecInitialized) = M1;
    DM(b_AllMute) = M0;
    
    rts;
     
.ENDMOD;
