/*******************************************************************************
*
*  SysVars.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.module                                     modSysVars;

#include ".\chicsys\hdr\codechdr.h"
#include ".\comsys\hdr\comhdr.h"
#include ".\gen_fx\hdr\GenFX.h"


.VAR/DM/CIRC        a_rxBuf[16];
.GLOBAL             a_rxBuf;

.VAR/DM/CIRC        a_txBuf[16];
.GLOBAL             a_txBuf;

.INIT a_txBuf:
		ENABLE_VFbit_SLOT1_SLOT2,   
        SERIAL_CONFIGURATION,       
        ENA_SLOT16_Mode_RegMx_DRQEN,    
        0x0000,             
        0x0000, 
        0x0000, 
        0x0000,
        0x0000,
        0x0000, 
        0x0000, 
        0x0000,
        0x0000,
        0x0000,
        0x0000,
        0x0000,         
        0x0000;             
 
.VAR/DM             b_CodecInitialized;
.GLOBAL             b_CodecInitialized;

/*
 *  codec register initializations:
 *    refer to AD1885 Data Sheet for register bit assignments
 */

.VAR/DM/CIRC        a_InitCodecRegisters[42];
.INIT               a_InitCodecRegisters:

        MASTER_VOLUME,            	0x0000,
        MASTER_VOLUME_MONO,    		0x0000,  
        PC_BEEP_Volume,        		0x8000,
        PHONE_Volume,             	0x0000,
        MIC_Volume,              	0x0000,
        LINE_IN_Volume,        		0x8f0f,
        CD_Volume,               	0x0008,
        VIDEO_Volume,             	0x0808,
        AUX_Volume,              	0x0808,
        PCM_OUT_Volume,        		0x0808,
        RECORD_SELECT,            	0x0404,
        RECORD_GAIN,              	0x0000,
        GENERAL_PURPOSE,          	0x8000,
        THREE_D_CONTROL_REG,       	0x000a,
      	EXTENDED_AUDIO_CTRL,    	0x0000,
        PCM_DAC_RATE,           	48000,
    	PCM_ADC_RATE,           	48000,
	    MISC_CONTROL_BITS,     		0x0404,
      	SAMPLE_RATE_GENERATE_0,   	48000,
        SAMPLE_RATE_GENERATE_1, 	48000;

.GLOBAL a_InitCodecRegisters;

/* muted outputs: */
/*
        MASTER_VOLUME,              0x8000,
        MASTER_VOLUME_MONO,         0x8000,  
        PC_BEEP_Volume,             0x8000,
        PHONE_Volume,               0x8008,
        MIC_Volume,                 0x8008,
        LINE_IN_Volume,             0x8808,
        CD_Volume,                  0x8008,
        VIDEO_Volume,               0x8808,
        AUX_Volume,                 0x8808,
        PCM_OUT_Volume,             0x8000,
        RECORD_SELECT,              0x0401,
        RECORD_GAIN,                0x0000,
        GENERAL_PURPOSE,            0x8000,
        THREE_D_CONTROL_REG,        0x000a,
        EXTENDED_AUDIO_CTRL,        0x0001,
        PCM_DAC_RATE,               36864,
        PCM_ADC_RATE,               36864,
        MISC_CONTROL_BITS,          0x0404,
        SAMPLE_RATE_GENERATE_0,     36864,
        SAMPLE_RATE_GENERATE_1,     36864;
*/

#ifdef CODEC_DEBUG
.VAR/DM/ram     a_CodecRegisterContents[42];
.INIT a_CodecRegisterContents: 
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0;
#endif

.ENDMOD;
