/*******************************************************************************
*
*  codechdr.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

/*
 *  AD1885 Codec Register Address Definitions
 */
 
#define     REGISTER_RESET              0x0000
#define     MASTER_VOLUME               0x0200
#define     RESERVED_REG_1              0x0400
#define     MASTER_VOLUME_MONO          0x0600  
#define     RESERVED_REG_2              0x0800
#define     PC_BEEP_Volume              0x0A00
#define     PHONE_Volume                0x0C00
#define     MIC_Volume                  0x0E00
#define     LINE_IN_Volume              0x1000
#define     CD_Volume                   0x1200
#define     VIDEO_Volume                0x1400
#define     AUX_Volume                  0x1600
#define     PCM_OUT_Volume              0x1800
#define     RECORD_SELECT               0x1A00
#define     RECORD_GAIN                 0x1C00
#define     RESERVED_REG_3              0x1E00
#define     GENERAL_PURPOSE             0x2000
#define     THREE_D_CONTROL_REG         0x2200
#define     RESERVED_REG_4              0x2400
#define     POWERDOWN_CTRL_STAT         0x2600
#define     EXTENDED_AUDIO_ID           0x2800
#define     EXTENDED_AUDIO_CTRL         0x2a00
#define     PCM_DAC_RATE                0x2c00
#define     PCM_ADC_RATE                0x3200
#define     SERIAL_CONFIGURATION        0x7400
#define     MISC_CONTROL_BITS           0x7600
#define     SAMPLE_RATE_GENERATE_0      0x7800
#define     SAMPLE_RATE_GENERATE_1      0x7A00
#define     VENDOR_ID_1                 0x7C00
#define     VENDOR_ID_2                 0x7E00

/*
 *  Left and Right ADC valid Bits used for testing of valid audio data in
 *  current TDM frame
 */

#define     M_LEFT_ADC                  12
#define     M_RIGHT_ADC                 11
#define     S1_LEFT_ADC                 10
#define     S1_RIGHT_ADC                9
#define     S2_LEFT_ADC                 8
#define     S2_RIGHT_ADC                7

/*
 *  Macro for setting Bits 15, 14 and 13 in Slot 0 Tag Phase to program the
 *  codec registers
 */

#define     ENABLE_VFbit_SLOT1_SLOT2    0xF000
/*#define     ENABLE_VFbit_SLOT1_SLOT2    0xE000*/

/*
 *  Data for Serial Config Reg - SLOT16 Mode, DAC request enable, set master &
 *  slave mask bits.  Note: 1st 4 bits (0xF) are dummy bits that transmit in
 *  previous 20-bit slot
 */

#define     ENA_SLOT16_Mode_RegMx_DRQEN 0xFF80

/*
 *  Timeslot labels for transmit and receive buffers
 */
 
#define     TAG_PHASE                   0
#define     COMMAND_ADDRESS_SLOT        1
#define     STATUS_ADDRESS_SLOT         1
#define     COMMAND_DATA_SLOT           2
#define     STATUS_DATA_SLOT            2
#define     MASTER_LEFT                 3
#define     MASTER_RIGHT                4
#define     SLAVE1_LEFT                 5
#define     SLAVE1_RIGHT                6
#define     SLAVE2_LEFT                 7
#define     SLAVE2_RIGHT                8

/*
 *  Mask bit selections in Serial Configuration Register for accessing registers
 *  on any of the 3 codecs
 */

#define     MASTER_Reg_Mask             0x1000
#define     SLAVE1_Reg_Mask             0x2000
#define     SLAVE2_Reg_Mask             0x4000
#define     MASTER_SLAVE1               0x3000
#define     MASTER_SLAVE2               0x5000
#define     MASTER_SLAVE1_SLAVE2        0x7000

#define     MASTER_TAG_MASK             0x1800
#define     ALL_TAG_MASK                0x1f80
#define     VALID_FRAME                 15
#define     RIGHT_DAC_READY             0
#define     LEFT_DAC_READY              8
