/*******************************************************************************
*
*  ComVars.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.MODULE                                     modComVars;

/*
 *  indicates if a seed is captured for random number generation.  this value
 *  is set in the IRQE ISR.
 */

.VAR/DM             b_SeedCaptured;
.GLOBAL             b_SeedCaptured;
.INIT               b_SeedCaptured:         0;

/*
 *  indicates which buffer should be written to SPORT TX.  this value flipflops
 *  inside the RX ISR (when a buffer has been totally emptied).  also note that
 *  the init value of 1 corresponds to the BuffToTX pointer initialization.
 */

.VAR/DM             v_TXBuff0or1;
.GLOBAL             v_TXBuff0or1;
.INIT               v_TXBuff0or1:           1;

/*
 *  used as a semaphore to indicate when it's safe to start writing new data
 *  into an audio buffer.  it is set inside the RX ISR once a TX buffer has
 *  been totally emptied and immediately cleared once the FillAudioBuffer
 *  loop acknowledges it.  if this didn't exist, FillAudioBuffer would run
 *  faster than SPORT TX and data would be corrupted.
 */
 
.VAR/DM             b_FillNewBuffer;
.GLOBAL             b_FillNewBuffer;
.INIT               b_FillNewBuffer:        0;

/*
 *  forces mute on L/R channels.  happens in serial port TX ISR, safest way
 *  to mute output.  if zero, output is muted.  variable is inited in reset
 *  routine.
 */

.VAR/DM             b_AllMute;
.GLOBAL             b_AllMute;

/*
 *  total number of songs in .exe - filled automatically in main code.
 */

.VAR/DM             v_NumSongs;
.GLOBAL             v_NumSongs;

.VAR/DM             b_EndSong;
.GLOBAL             b_EndSong;

.ENDMOD;
