/******************************************************************************
*
*  FRLUT.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modFRLUT;

/*
 *  include files for all functions
 */

#include    ".\comsys\hdr\comhdr.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      FillRandLUT;

FillRandLUT:
    I2 = ^a_RandLUT;
    L2 = %a_RandLUT;
    AY1 = 0x7fff;
    CNTR = %a_RandLUT;

/*
 *  when filling the random LUT, watch out for 0x0000, 0x7fff, and 0x8000.
 *  they are filtered out of the array to make certain comparisons within
 *  arate functions easier to make.
 */
    
    do FRL1 until CE;
      call NoiseGen;
      AR = pass SR0;
      if EQ AR = AR + 128;                  /* check for 0x0000 */
      NONE = SR0 - AY1;
      if EQ AR = AR - 256;                  /* check for 0x7fff */
      NONE = AR + AY1;
      if EQ AR = AR + 1024;                 /* check for 0x8001 */
FRL1: DM(I2, M1) = AR;

    L2 = 0;
    rts;
    
.ENDMOD;