/******************************************************************************
*
*  GFPInit.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                 modPtrInits;

/*
 *  include files
 */

#include    ".\comsys\hdr\comhdr.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */
 
.ENTRY      GenFXPtrInits;

GenFXPtrInits:

/*
 *  I4/I7 used in env function to write to L/R arrays.  however, I7 is first
 *  used for filling the a_GenData array during gen/fx functions so no reason
 *  to init it to a_RSampOut here
 */
 
    I4 = ^a_LSampOut;
    L4 = %a_LSampOut;
    !I7 = ^a_RSampOut;
    !L7 = %a_RSampOut;

    I7 = ^a_GenData;
    L7 = 0;

/*
 *  a_GenFXPtrInits[0]:  number of different sig gens
 *  a_GenFXPtrInits[1]:  start address of gen_fx param array
 *  a_GenFXPtrInits[2]:  address of ptr into specified gen_fx array
 *
 *  for example, if only KSGen is being used in a song, a_GenFXPtrInits would
 *  look like:
 *
 *    a_GenFXPtrInits[0] = 1
 *    a_GenFXPtrInits[1] = ^a_KSGen
 *    a_GenFXPtrInits[2] = ^p_KSGen
 *
 *  the idea is to reset the address in DM(p_KSGen) such that it points to the
 *  start of the a_KSGen buffer every time a new sample needs to be generated.
 */

    I2 = ^a_GenFXPtrInits + 1;
    CNTR = DM(a_GenFXPtrInits+0);
    do GPI until CE;
      AR = DM(I2, M1);
      AY0 = DM(I2, M1);
      I3 = AY0;
GPI:  DM(I3, M0) = AR;
    
    rts;
    
.ENDMOD;