/******************************************************************************
*
*  InitFunc.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  general useful init functions
*
******************************************************************************/

.MODULE                                     modInitFunc;

#include    ".\comsys\hdr\comhdr.h"
#include    ".\gen_fx\hdr\GenFX.h"

.ENTRY      FillKS0Buff;
.ENTRY      FillKS1Buff;
.ENTRY      FillKS2Buff;
.ENTRY      FillKS3Buff;
.ENTRY      FillKS4Buff;
.ENTRY      FillKS5Buff;
.ENTRY      FillKS6Buff;
.ENTRY      FillKS7Buff;
.ENTRY      FillKS_JT;
.ENTRY      FillDB0;
.ENTRY      FillDB1;
.ENTRY      InitOutBuffs;
.ENTRY      GenFXIniPostProc;
.ENTRY      Seq2PostProc;
.ENTRY      FillGenFXPtrInits;

/*
 *  FillKSBuff0-FillKSBuff7:  refill a_KSBuff0-a_KSBuff7 with random data.
 *  often called in TrigInit via RESET_KSGEN() macro.
 */

FillKS_JT:
    jump FillKS0Buff;
    jump FillKS1Buff;
    jump FillKS2Buff;
    jump FillKS3Buff;
    jump FillKS4Buff;
    jump FillKS5Buff;
    jump FillKS6Buff;
    jump FillKS7Buff;

FillKS0Buff:
    I2 = ^a_KSBuff0;
    L2 = %a_KSBuff0;
    CNTR = %a_KSBuff0;
    do FKS0 until CE;
      AR = DM(I6, M7);
FKS0: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS1Buff:
    I2 = ^a_KSBuff1;
    L2 = %a_KSBuff1;
    CNTR = %a_KSBuff1;
    do FKS1 until CE;
      AR = DM(I6, M7);
FKS1: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS2Buff:
    I2 = ^a_KSBuff2;
    L2 = %a_KSBuff2;
    CNTR = %a_KSBuff2;
    do FKS2 until CE;
      AR = DM(I6, M7);
FKS2: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS3Buff:
    I2 = ^a_KSBuff3;
    L2 = %a_KSBuff3;
    CNTR = %a_KSBuff3;
    do FKS3 until CE;
      AR = DM(I6, M7);
FKS3: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS4Buff:
    I2 = ^a_KSBuff4;
    L2 = %a_KSBuff4;
    CNTR = %a_KSBuff4;
    do FKS4 until CE;
      AR = DM(I6, M7);
FKS4: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS5Buff:
    I2 = ^a_KSBuff5;
    L2 = %a_KSBuff5;
    CNTR = %a_KSBuff5;
    do FKS5 until CE;
      AR = DM(I6, M7);
FKS5: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS6Buff:
    I2 = ^a_KSBuff6;
    L2 = %a_KSBuff6;
    CNTR = %a_KSBuff6;
    do FKS6 until CE;
      AR = DM(I6, M7);
FKS6: DM(I2, M1) = AR;

    L2 = 0;

    rts;

FillKS7Buff:
    I2 = ^a_KSBuff7;
    L2 = %a_KSBuff7;
    CNTR = %a_KSBuff7;
    do FKS7 until CE;
      AR = DM(I6, M7);
FKS7: DM(I2, M1) = AR;

    L2 = 0;

    rts;

/*
 *  FillDB1-FillDB2:  refill a_DelayBuff0-a_DelayBuff1 with random data.  used
 *  inside TrigInit.
 */

FillDB0:
    I5 = ^a_DelayBuff0;
    L5 = %a_DelayBuff0;
    CNTR = %a_DelayBuff0;
    do FDB0 until CE;
      AR = DM(I6, M7);
FDB0: PM(I5, M7) = AR;

    L5 = 0;
    rts;
    
FillDB1:
    I5 = ^a_DelayBuff1;
    L5 = %a_DelayBuff1;
    CNTR = %a_DelayBuff1;
    do FDB1 until CE;
      AR = DM(I6, M7);
FDB1: PM(I5, M7) = AR;

    L5 = 0;
    rts;

/*******************************************************************************
*
*  called just before GenFXIni - cleans out sequencer buffers, filter outputs,
*  system output buffers.  sets LFO3 and MemEnv3 to default values (since they
*  must be called at least once).  sets up pointer into array of gen/fx data
*  arrays needed in GFPInit.  determines the number of measures in a song
*  (by analyzing SongCTRL).  creates a dummy control track and init's variables
*  used in song control.  lots of stuff!
*
*******************************************************************************/

InitOutBuffs:
    I2 = ^a_GenData;
    I3 = ^a_LSampOut;
    I5 = ^a_RSampOut;
    CNTR = MAXTRACKS;
    do IOB1 until CE;
      DM(I3, M1) = 0;
      DM(I5, M7) = 0;
IOB1: DM(I2, M1) = 0;

    I2 = ^a_LOutBuff0;
    I3 = ^a_ROutBuff0;
    CNTR = OUTBUFFLEN;
    do IOB2 until CE;
      DM(I2, M1) = 0;
IOB2: DM(I3, M1) = 0;

    I2 = ^a_LOutBuff1;
    I3 = ^a_ROutBuff1;
    CNTR = OUTBUFFLEN;
    do IOB3 until CE;
      DM(I2, M1) = 0;
IOB3: DM(I3, M1) = 0;

    call InitGenFXBuffs;

    rts;

/*
 *  internal function, clear seq trigtrack & voltrack buffers
 */
    
ClearTTBuffs:
    I2 = ^a_TrigTrack00;
    CNTR = %a_TrigTrack00;
    call ClearBuffer;
    I2 = ^a_TrigTrack01;
    CNTR = %a_TrigTrack01;
    call ClearBuffer;
    I2 = ^a_TrigTrack02;
    CNTR = %a_TrigTrack02;
    call ClearBuffer;
    I2 = ^a_TrigTrack03;
    CNTR = %a_TrigTrack03;
    call ClearBuffer;
    I2 = ^a_TrigTrack04;
    CNTR = %a_TrigTrack04;
    call ClearBuffer;
    I2 = ^a_TrigTrack05;
    CNTR = %a_TrigTrack06;
    call ClearBuffer;
    I2 = ^a_TrigTrack06;
    CNTR = %a_TrigTrack06;
    call ClearBuffer;
    I2 = ^a_TrigTrack07;
    CNTR = %a_TrigTrack07;
    call ClearBuffer;
    I2 = ^a_TrigTrack08;
    CNTR = %a_TrigTrack08;
    call ClearBuffer;
    I2 = ^a_TrigTrack09;
    CNTR = %a_TrigTrack09;
    call ClearBuffer;
    I2 = ^a_TrigTrack10;
    CNTR = %a_TrigTrack10;
    call ClearBuffer;
    I2 = ^a_TrigTrack11;
    CNTR = %a_TrigTrack11;
    call ClearBuffer;
    I2 = ^a_TrigTrack12;
    CNTR = %a_TrigTrack12;
    call ClearBuffer;
    I2 = ^a_TrigTrack13;
    CNTR = %a_TrigTrack13;
    call ClearBuffer;
    I2 = ^a_TrigTrack14;
    CNTR = %a_TrigTrack14;
    call ClearBuffer;
    I2 = ^a_TrigTrack15;
    CNTR = %a_TrigTrack15;
    call ClearBuffer;
    I2 = ^a_TrigTrack16;
    CNTR = %a_TrigTrack16;
    call ClearBuffer;
    I2 = ^a_TrigTrack17;
    CNTR = %a_TrigTrack17;
    call ClearBuffer;
    I2 = ^a_TrigTrack18;
    CNTR = %a_TrigTrack18;
    call ClearBuffer;
    I2 = ^a_TrigTrack19;
    CNTR = %a_TrigTrack19;
    call ClearBuffer;
    I2 = ^a_TrigTrack20;
    CNTR = %a_TrigTrack20;
    call ClearBuffer;
    I2 = ^a_TrigTrack21;
    CNTR = %a_TrigTrack21;
    call ClearBuffer;
    I2 = ^a_TrigTrack22;
    CNTR = %a_TrigTrack22;
    call ClearBuffer;
    I2 = ^a_TrigTrack23;
    CNTR = %a_TrigTrack23;
    call ClearBuffer;
    I2 = ^a_TrigTrack24;
    CNTR = %a_TrigTrack24;
    call ClearBuffer;
    I2 = ^a_TrigTrack25;
    CNTR = %a_TrigTrack25;
    call ClearBuffer;
    I2 = ^a_TrigTrack26;
    CNTR = %a_TrigTrack26;
    call ClearBuffer;
    I2 = ^a_TrigTrack27;
    CNTR = %a_TrigTrack27;
    call ClearBuffer;
    I2 = ^a_TrigTrack28;
    CNTR = %a_TrigTrack28;
    call ClearBuffer;
    I2 = ^a_TrigTrack29;
    CNTR = %a_TrigTrack29;
    call ClearBuffer;
    I2 = ^a_TrigTrack30;
    CNTR = %a_TrigTrack30;
    call ClearBuffer;
    I2 = ^a_TrigTrack31;
    CNTR = %a_TrigTrack31;
    call ClearBuffer;
    
    I2 = ^a_VolTrack00;
    CNTR = %a_VolTrack00;
    call ClearBuffer;
    I2 = ^a_VolTrack01;
    CNTR = %a_TrigTrack01;
    call ClearBuffer;
    I2 = ^a_VolTrack02;
    CNTR = %a_VolTrack02;
    call ClearBuffer;
    I2 = ^a_VolTrack03;
    CNTR = %a_VolTrack03;
    call ClearBuffer;
    I2 = ^a_VolTrack04;
    CNTR = %a_VolTrack04;
    call ClearBuffer;
    I2 = ^a_VolTrack05;
    CNTR = %a_VolTrack05;
    call ClearBuffer;
    I2 = ^a_VolTrack06;
    CNTR = %a_VolTrack06;
    call ClearBuffer;
    I2 = ^a_VolTrack07;
    CNTR = %a_VolTrack07;
    call ClearBuffer;
    I2 = ^a_VolTrack08;
    CNTR = %a_VolTrack08;
    call ClearBuffer;
    I2 = ^a_VolTrack09;
    CNTR = %a_VolTrack09;
    call ClearBuffer;
    I2 = ^a_VolTrack10;
    CNTR = %a_VolTrack10;
    call ClearBuffer;
    I2 = ^a_VolTrack11;
    CNTR = %a_VolTrack11;
    call ClearBuffer;
    I2 = ^a_VolTrack12;
    CNTR = %a_VolTrack12;
    call ClearBuffer;
    I2 = ^a_VolTrack13;
    CNTR = %a_VolTrack13;
    call ClearBuffer;
    I2 = ^a_VolTrack14;
    CNTR = %a_VolTrack14;
    call ClearBuffer;
    I2 = ^a_VolTrack15;
    CNTR = %a_VolTrack15;
    call ClearBuffer;
    I2 = ^a_VolTrack16;
    CNTR = %a_VolTrack16;
    call ClearBuffer;
    I2 = ^a_VolTrack17;
    CNTR = %a_VolTrack17;
    call ClearBuffer;
    I2 = ^a_VolTrack18;
    CNTR = %a_VolTrack18;
    call ClearBuffer;
    I2 = ^a_VolTrack19;
    CNTR = %a_VolTrack19;
    call ClearBuffer;
    I2 = ^a_VolTrack20;
    CNTR = %a_VolTrack20;
    call ClearBuffer;
    I2 = ^a_VolTrack21;
    CNTR = %a_VolTrack21;
    call ClearBuffer;
    I2 = ^a_VolTrack22;
    CNTR = %a_VolTrack22;
    call ClearBuffer;
    I2 = ^a_VolTrack23;
    CNTR = %a_VolTrack23;
    call ClearBuffer;
    I2 = ^a_VolTrack24;
    CNTR = %a_VolTrack24;
    call ClearBuffer;
    I2 = ^a_VolTrack25;
    CNTR = %a_VolTrack25;
    call ClearBuffer;
    I2 = ^a_VolTrack26;
    CNTR = %a_VolTrack26;
    call ClearBuffer;
    I2 = ^a_VolTrack27;
    CNTR = %a_VolTrack27;
    call ClearBuffer;
    I2 = ^a_VolTrack28;
    CNTR = %a_VolTrack28;
    call ClearBuffer;
    I2 = ^a_VolTrack29;
    CNTR = %a_VolTrack29;
    call ClearBuffer;
    I2 = ^a_VolTrack30;
    CNTR = %a_VolTrack30;
    call ClearBuffer;
    I2 = ^a_VolTrack31;
    CNTR = %a_VolTrack31;
    call ClearBuffer;
    
    rts;

ClearBuffer:
    do CB until CE;
CB:  DM(I2, M1) = 0;

    rts;

/*
 *  internal function, clear all KS buffers to avoid spurious output.
 */

ClearKSBuffs:
    I2 = ^a_KSBuff0;
    CNTR = %a_KSBuff0;
    call ClearBuffer;
    
    I2 = ^a_KSBuff1;
    CNTR = %a_KSBuff1;
    call ClearBuffer;

    I2 = ^a_KSBuff2;
    CNTR = %a_KSBuff2;
    call ClearBuffer;

    I2 = ^a_KSBuff3;
    CNTR = %a_KSBuff3;
    call ClearBuffer;

    I2 = ^a_KSBuff4;
    CNTR = %a_KSBuff4;
    call ClearBuffer;

    I2 = ^a_KSBuff5;
    CNTR = %a_KSBuff5;
    call ClearBuffer;

    I2 = ^a_KSBuff6;
    CNTR = %a_KSBuff6;
    call ClearBuffer;

    I2 = ^a_KSBuff7;
    CNTR = %a_KSBuff7;
    call ClearBuffer;

    rts;

/*
 *  internal function, clear SVF filter state
 */

ClearSVFFiltOut:
    I2 = ^a_SVFFiltOut;
    CNTR = SVFFILTOUTCALLS*SVFFILTOUTVARS;
    call ClearBuffer;

    rts;

/*
 *  internal function, must protect LFO call due to fact it is altomatically
 *  called once in ModFuncs_.dsp - must set to a known value.
 */
    
InitLFO3Buff:
    SETPTR(a_LFO);
    INIT_LFO(1, 1, ^a_WTSine, 0, 0, ^v_Dummy);
    DM(v_NumLFO3) = M1;
    rts;

/*
 *  internal function, must protect MemEnv1 call due to fact it is altomatically
 *  called once in ModFuncs_.dsp - must set to a known value.
 */
  
InitMemEnv1Buff:
    SETPTR(a_MemEnv1);
    INIT_MEMENV1(0, 0, 0, 0, 0, 0, ^v_Dummy);
    DM(v_NumMemEnv1) = M1;
    rts;

/*
 *  internal function, must protect MemEnv2 call due to fact it is altomatically
 *  called once in ModFuncs_.dsp - must set to a known value.
 */
     
InitMemEnv2Buff:
    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^v_Dummy, 0, 0, 0, 0, 0, 1, 0x7fff, 1, 0x7fff, 1, 0x7fff, 1, 0x7fff);
    DM(v_NumMemEnv2) = M1;
    rts;

/*
 *  internal function, must protect MemEnv3 call due to fact it is altomatically
 *  called once in ModFuncs_.dsp - must set to a known value.
 */
     
InitMemEnv3Buff:
    SETPTR(a_MemEnv3);
    INIT_MEMENV3(^v_Dummy, 100, 100, 1, 100, 1);
    DM(v_NumMemEnv3) = M1;
    rts;

/*
 *  internal function, set all tracks to full scale.
 */
 
InitVolEnv:
    I2 = ^a_VolEnv;
    AR = ^a_MixScalars;
    CNTR = 32;
    do IVE until CE;
      DM(I2, M1) = AR;
      DM(I2, M1) = 0;
      DM(I2, M1) = 0x7fff;
      DM(I2, M1) = 0x7fff;
      DM(I2, M1) = 1;
IVE:  AR = AR + 1;

    rts;
    
/*******************************************************************************
*
*  CalcSeq2Tracks
*
*  called immediately after using Seq2 macros for init, sets a_Seq+0 to the
*  total number of tracks (inferred from location of I2 ptr in relation to
*  the start of a_Seq.
*
*******************************************************************************/
 
CalcSeq2Tracks:
    AR = I2;
    AF = pass 0;
    AY0 = SEQ_VARS;
    AY1 = ^a_Seq;

CS2T:
    AR = AR - AY0;
    NONE = AR - AY1;
    if LT jump EndCS2T;
    AF = AF + 1;
    jump CS2T;

EndCS2T:
    AR = pass AF;
    DM(a_Seq + 0) = AR;
    rts;

/*******************************************************************************
*
*  functionPtrInit:
*
*  list of functions that write the starting address and a pointer address
*  into a_GenFXPtrInits.  this array is read in GFPInit.  these are called
*  by FillGenFXPtrInits.
*
*******************************************************************************/

ProbKSPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ProbKSGen;
    DM(I2, M1) = ^p_ProbKSGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
GenSHFXPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_GenSHFX;
    DM(I2, M1) = ^p_GenSHFX;
    DM(p_GenFXPtrInits) = I2;
    rts;

CopiedGenPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_CopiedGen;
    DM(I2, M1) = ^p_CopiedGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
WTGenSyncFXPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_WTGenSyncFX;
    DM(I2, M1) = ^p_WTGenSyncFX;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
WaveShapeFXPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_WaveShapeFX;
    DM(I2, M1) = ^p_WaveShapeFX;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
MultiGenPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_MultiGen;
    DM(I2, M1) = ^p_MultiGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
ExpImpulseGenPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ExpImpulseGen;
    DM(I2, M1) = ^p_ExpImpulseGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

FM2Op0PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_FM2Op0Gen;
    DM(I2, M1) = ^p_FM2Op0Gen;
    DM(p_GenFXPtrInits) = I2;
    rts;
  
KSPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_KSGen;
    DM(I2, M1) = ^p_KSGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

AlgoSinePtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_AlgoSineGen;
    DM(I2, M1) = ^p_AlgoSineGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
AlgoSineSatPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_AlgoSineSatGen;
    DM(I2, M1) = ^p_AlgoSineSatGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
RotSynthPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_RotSynthGen;
    DM(I2, M1) = ^p_RotSynthGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

TunedRotSynthPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_TunedRotSynthGen;
    DM(I2, M1) = ^p_TunedRotSynthGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

ME1PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_MemEnv1;
    DM(I2, M1) = ^p_MemEnv1;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
ME2PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_MemEnv2;
    DM(I2, M1) = ^p_MemEnv2;
    DM(p_GenFXPtrInits) = I2;
    rts;
       
WTGen2PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_WTGen2;
    DM(I2, M1) = ^p_WTGen2;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
HPWTGen2PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_HPWTGen2;
    DM(I2, M1) = ^p_HPWTGen2;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
WTGenPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_WTGen;
    DM(I2, M1) = ^p_WTGen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
KillTimePtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_KillTimeFX;
    DM(I2, M1) = ^p_KillTimeFX;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
ADSRPanEnvPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ADSRPanEnv;
    DM(I2, M1) = ^p_ADSRPanEnv;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
SVFCoeffPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_SVFFX;
    DM(I2, M1) = ^p_SVFFX;
    DM(p_GenFXPtrInits) = I2;
    rts;

SVFFiltOutPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_SVFFiltOut;
    DM(I2, M1) = ^p_SVFFiltOut;
    DM(p_GenFXPtrInits) = I2;
    rts;

OscCombPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_OscCombGen;
    DM(I2, M1) = ^p_OscCombGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

PerNoisePtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_PerNoiseGen;
    DM(I2, M1) = ^p_PerNoiseGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

ProbSynPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ProbSynthGen;
    DM(I2, M1) = ^p_ProbSynthGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

Exp1PtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_Exp1Gen;
    DM(I2, M1) = ^p_Exp1Gen;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
DelaySynPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_DelaySynthGen;
    DM(I2, M1) = ^p_DelaySynthGen;
    DM(p_GenFXPtrInits) = I2;
    rts;

ClampFXPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ClampFX;
    DM(I2, M1) = ^p_ClampFX;
    DM(p_GenFXPtrInits) = I2;
    rts;

ExpDecayPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ExpDecayEnv;
    DM(I2, M1) = ^p_ExpDecayEnv;
    DM(p_GenFXPtrInits) = I2;
    rts;

PrevCurrFiltPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_PrevCurrFiltFX;
    DM(I2, M1) = ^p_PrevCurrFiltFX;
    DM(p_GenFXPtrInits) = I2;
    rts;

ZeroSampsPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_ZeroSampsFX;
    DM(I2, M1) = ^p_ZeroSampsFX;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
BitmaskPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_BitMaskFX;
    DM(I2, M1) = ^p_BitMaskFX;
    DM(p_GenFXPtrInits) = I2;
    rts;
    
RectifyPtrInit:
    I2 = DM(p_GenFXPtrInits);
    DM(I2, M1) = ^a_RectifyFX;
    DM(I2, M1) = ^p_RectifyFX;
    DM(p_GenFXPtrInits) = I2;
    rts;

/*
 *  determine total number of functions that must be init'ed (and therefore set
 *  a_GenFXPtrInits+0) by looking at difference between start and current
 *  position of p_GenFXPtrInits.
 */
    
CalcNumPtrInits:
    AR = DM(p_GenFXPtrInits);
    AY0 = ^a_GenFXPtrInits;
    AR = AR - AY0;
    SR = lshift AR by -1 (LO);
    DM(a_GenFXPtrInits+0) = SR0;
    rts;

InitGenFXPtrBuff:
    AR = ^a_GenFXPtrInits+1;
    DM(p_GenFXPtrInits) = AR;
    rts;

/*
 *  only called in InitFunc, handles clearing of gen/fx buffers, and other
 *  general system buffers.
 */

InitGenFXBuffs:
    call ClearTTBuffs;                      /* seq trigtrack buffers */
    call ClearKSBuffs;                      /* ks buffers */
    call ClearSVFFiltOut;                   /* output state of SVF filters */
    
    call InitLFO3Buff;                      /* init because always called */
    call InitMemEnv1Buff;                   /* init because always called */
    call InitMemEnv2Buff;                   /* init because always called */
    call InitMemEnv3Buff;                   /* init because always called */
    call InitGenFXPtrBuff;                  /* where gen/fx ptrs are stored */
        
    call InitSongCTRLBuffs;                 /* seq song control buffers */
    
    DM(v_CurrMeasure) = M0;                 /* song control, at measure 0 */
    
    /* force measure 0 to be called on first entry to SongCTRL_.dsp */
    AR = 0x7ffe;
    DM(v_TicCNTR) = AR;
    
    /* array where seq control data is written */
    AR = ^a_CTRLData;
    DM(p_CTRLData) = AR;
    
    call InitVolEnv;                        /* init all outputs at full scale */
     
    rts;

/*
 *  internal function, must init ap_CTRLTrack because they are always accessed
 *  in sequencer processing.
 */

InitSongCTRLBuffs:
    SETPTR(ap_CTRLTrack00);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack00_0);
    SETPTR(ap_CTRLTrack01);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack01_0);
    SETPTR(ap_CTRLTrack02);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack02_0);
    SETPTR(ap_CTRLTrack03);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack03_0);
    SETPTR(ap_CTRLTrack04);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack04_0);
    SETPTR(ap_CTRLTrack05);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack05_0);
    SETPTR(ap_CTRLTrack06);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack06_0);
    SETPTR(ap_CTRLTrack07);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack07_0);
    SETPTR(ap_CTRLTrack08);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack08_0);
    SETPTR(ap_CTRLTrack09);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack09_0);
    SETPTR(ap_CTRLTrack10);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack10_0);
    SETPTR(ap_CTRLTrack11);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack11_0);
    SETPTR(ap_CTRLTrack12);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack12_0);
    SETPTR(ap_CTRLTrack13);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack13_0);
    SETPTR(ap_CTRLTrack14);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack14_0);
    SETPTR(ap_CTRLTrack15);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack15_0);
    SETPTR(ap_CTRLTrack16);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack16_0);
    SETPTR(ap_CTRLTrack17);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack17_0);
    SETPTR(ap_CTRLTrack18);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack18_0);
    SETPTR(ap_CTRLTrack19);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack19_0);
    SETPTR(ap_CTRLTrack20);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack20_0);
    SETPTR(ap_CTRLTrack21);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack21_0);
    SETPTR(ap_CTRLTrack22);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack22_0);
    SETPTR(ap_CTRLTrack23);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack23_0);
    SETPTR(ap_CTRLTrack24);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack24_0);
    SETPTR(ap_CTRLTrack25);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack25_0);
    SETPTR(ap_CTRLTrack26);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack26_0);
    SETPTR(ap_CTRLTrack27);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack27_0);
    SETPTR(ap_CTRLTrack28);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack28_0);
    SETPTR(ap_CTRLTrack29);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack29_0);
    SETPTR(ap_CTRLTrack30);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack30_0);
    SETPTR(ap_CTRLTrack31);
    NUMCTRLTRACKS(1);
    CONTROLTRACKSTEP(ALWAYSSTEP);
    INIT_AP_CTRLTRACK(1, ^a_CTRLTrack31_0);
    
    rts;

/*
 *  internal function, when SVFFX found need to call 2 ptr init funcs
 */

SVFPtrInit:
    call SVFFiltOutPtrInit;
    call SVFCoeffPtrInit;
    
    rts;

/*
 *  internal function, need to calculate envelope type offsets for sequencer
 *  handling.  function finds init'ed type, adds 1 to tally, writes number back
 *  to seq array.
 */

SetEnvNums:
    CNTR = NUMENVTYPES;
    I2 = ^a_EnvTypes;
    do IET until CE;
IET:  DM(I2, M1) = 0;
        
    I2 = ^a_Seq+1+SEQ_ENVTYPE;
    I3 = ^a_Seq+1+SEQ_ENVNUM;
    M2 = SEQ_VARS;
    
    CNTR = DM(a_Seq+0);
    do SEN until CE;
      AR = DM(I2, M2);                  /* read ENVTYPE (ADSR, EXPDECAY, etc) */
      I5 = ^a_EnvTypes;
      M5 = AR;
      modify(I5, M5);
      AR = DM(I5, M6);
      DM(I3, M2) = AR;
      AR = AR + 1;
SEN:  DM(I5, M6) = AR;

    rts;

/*
 *  called at end of genfxini initializations, find, count, and initialize
 *  various system variables based on number of different gen/fx/env requested.
 *  also used to initialize calls to envelopes from GenFX_.dsp
 */

GenFXIniPostProc:
    call CalcNumPtrInits;
    call InitEnvCalls;

    rts;

/*******************************************************************************
*
*  InitEnvCalls
*
*  analyzes the envelope types in the Seq2 array (ex - ADSRPanEnv) and writes
*  appropriate opcode into PM, starting at ^Env.  if the NUMTRACKS increases,
*  more space must be reserved at ^Env for the additional envelop calls
*
*******************************************************************************/

InitEnvCalls:
    AR = DM(EnvProcPtr);
    AF = pass AR;

    I2 = ^a_Seq+1+SEQ_ENVTYPE;
    M2 = SEQ_VARS;
    CNTR = DM(a_Seq+0);
    do IEC1 until CE;
      AR = DM(I2, M2);
      M5 = AR;
      I5 = ^IEC1_JT;
      modify(I5, M5);
      jump (I5);
IEC1_JT:
      jump SetNOOUTPUT;
      jump SetADSRENV;
      jump SetEXPDECAYENV;
      jump SetMEMENV3;

SetNOOUTPUT:
      jump EndIEC1;
SetADSRENV:
      AR = pass AF;
      I5 = ^ADSRPanEnvOpcode;
      AX0 = PM(I5, M6);
      I5 = AR;
      PM(I5, M6) = AX0;
      AF = AF + 1;
      jump EndIEC1;
SetEXPDECAYENV:
      AR = pass AF;
      I5 = ^ExpDecayOpcode;
      AX0 = PM(I5, M6);
      I5 = AR;
      PM(I5, M6) = AX0;
      AF = AF + 1;
      jump EndIEC1;
SetMEMENV3:
      jump EndIEC1;
EndIEC1:
      nop;
IEC1: nop;

    /* load rts into next ^Env slot */
    I5 = ^RTSOpcode;
    AX0 = PM(I5, M6);
    AR = pass AF;
    I5 = AR;
    PM(I5, M6) = AX0;
    
RTSOpcode:
    rts;

/*
 *  determines the number of tracks init'ed in sequencer, writes to a_Seq+0.
 *  sets the envelope number based on the envelope type (must update if new
 *  envelopes are added!).  saves track types in case a track is muted and then
 *  unmuted.
 */

Seq2PostProc:
    call CalcSeq2Tracks;
    call SetEnvNums;
    
    call InitTrigVolCTRLPtrs;
    
    rts;

/*
 *  internal function, init control track and other arrays for each track in
 *  sequencer.
 */

InitTrigVolCTRLPtrs:
    I2 = ^a_Seq+1+SEQ_CTRLTRACKPTR;
    M2 = SEQ_VARS;
    DM(I2, M2) = ^ap_CTRLTrack00;
    DM(I2, M2) = ^ap_CTRLTrack01;
    DM(I2, M2) = ^ap_CTRLTrack02;
    DM(I2, M2) = ^ap_CTRLTrack03;
    DM(I2, M2) = ^ap_CTRLTrack04;
    DM(I2, M2) = ^ap_CTRLTrack05;
    DM(I2, M2) = ^ap_CTRLTrack06;
    DM(I2, M2) = ^ap_CTRLTrack07;
    DM(I2, M2) = ^ap_CTRLTrack08;
    DM(I2, M2) = ^ap_CTRLTrack09;
    DM(I2, M2) = ^ap_CTRLTrack10;
    DM(I2, M2) = ^ap_CTRLTrack11;
    DM(I2, M2) = ^ap_CTRLTrack12;
    DM(I2, M2) = ^ap_CTRLTrack13;
    DM(I2, M2) = ^ap_CTRLTrack14;
    DM(I2, M2) = ^ap_CTRLTrack15;
    DM(I2, M2) = ^ap_CTRLTrack16;
    DM(I2, M2) = ^ap_CTRLTrack17;
    DM(I2, M2) = ^ap_CTRLTrack18;
    DM(I2, M2) = ^ap_CTRLTrack19;
    DM(I2, M2) = ^ap_CTRLTrack20;
    DM(I2, M2) = ^ap_CTRLTrack21;
    DM(I2, M2) = ^ap_CTRLTrack22;
    DM(I2, M2) = ^ap_CTRLTrack23;
    DM(I2, M2) = ^ap_CTRLTrack24;
    DM(I2, M2) = ^ap_CTRLTrack25;
    DM(I2, M2) = ^ap_CTRLTrack26;
    DM(I2, M2) = ^ap_CTRLTrack27;
    DM(I2, M2) = ^ap_CTRLTrack28;
    DM(I2, M2) = ^ap_CTRLTrack29;
    DM(I2, M2) = ^ap_CTRLTrack30;
    DM(I2, M2) = ^ap_CTRLTrack31;

    I2 = ^a_Seq+1+SEQ_BASETRIGPTR;
    M2 = SEQ_VARS;
    DM(I2, M2) = ^a_TrigTrack00;
    DM(I2, M2) = ^a_TrigTrack01;
    DM(I2, M2) = ^a_TrigTrack02;
    DM(I2, M2) = ^a_TrigTrack03;
    DM(I2, M2) = ^a_TrigTrack04;
    DM(I2, M2) = ^a_TrigTrack05;
    DM(I2, M2) = ^a_TrigTrack06;
    DM(I2, M2) = ^a_TrigTrack07;
    DM(I2, M2) = ^a_TrigTrack08;
    DM(I2, M2) = ^a_TrigTrack09;
    DM(I2, M2) = ^a_TrigTrack10;
    DM(I2, M2) = ^a_TrigTrack11;
    DM(I2, M2) = ^a_TrigTrack12;
    DM(I2, M2) = ^a_TrigTrack13;
    DM(I2, M2) = ^a_TrigTrack14;
    DM(I2, M2) = ^a_TrigTrack15;
    DM(I2, M2) = ^a_TrigTrack16;
    DM(I2, M2) = ^a_TrigTrack17;
    DM(I2, M2) = ^a_TrigTrack18;
    DM(I2, M2) = ^a_TrigTrack19;
    DM(I2, M2) = ^a_TrigTrack20;
    DM(I2, M2) = ^a_TrigTrack21;
    DM(I2, M2) = ^a_TrigTrack22;
    DM(I2, M2) = ^a_TrigTrack23;
    DM(I2, M2) = ^a_TrigTrack24;
    DM(I2, M2) = ^a_TrigTrack25;
    DM(I2, M2) = ^a_TrigTrack26;
    DM(I2, M2) = ^a_TrigTrack27;
    DM(I2, M2) = ^a_TrigTrack28;
    DM(I2, M2) = ^a_TrigTrack29;
    DM(I2, M2) = ^a_TrigTrack30;
    DM(I2, M2) = ^a_TrigTrack31;

    I2 = ^a_Seq+1+SEQ_CURRTRIGPTR;
    M2 = SEQ_VARS;
    DM(I2, M2) = ^a_TrigTrack00;
    DM(I2, M2) = ^a_TrigTrack01;
    DM(I2, M2) = ^a_TrigTrack02;
    DM(I2, M2) = ^a_TrigTrack03;
    DM(I2, M2) = ^a_TrigTrack04;
    DM(I2, M2) = ^a_TrigTrack05;
    DM(I2, M2) = ^a_TrigTrack06;
    DM(I2, M2) = ^a_TrigTrack07;
    DM(I2, M2) = ^a_TrigTrack08;
    DM(I2, M2) = ^a_TrigTrack09;
    DM(I2, M2) = ^a_TrigTrack10;
    DM(I2, M2) = ^a_TrigTrack11;
    DM(I2, M2) = ^a_TrigTrack12;
    DM(I2, M2) = ^a_TrigTrack13;
    DM(I2, M2) = ^a_TrigTrack14;
    DM(I2, M2) = ^a_TrigTrack15;
    DM(I2, M2) = ^a_TrigTrack16;
    DM(I2, M2) = ^a_TrigTrack17;
    DM(I2, M2) = ^a_TrigTrack18;
    DM(I2, M2) = ^a_TrigTrack19;
    DM(I2, M2) = ^a_TrigTrack20;
    DM(I2, M2) = ^a_TrigTrack21;
    DM(I2, M2) = ^a_TrigTrack22;
    DM(I2, M2) = ^a_TrigTrack23;
    DM(I2, M2) = ^a_TrigTrack24;
    DM(I2, M2) = ^a_TrigTrack25;
    DM(I2, M2) = ^a_TrigTrack26;
    DM(I2, M2) = ^a_TrigTrack27;
    DM(I2, M2) = ^a_TrigTrack28;
    DM(I2, M2) = ^a_TrigTrack29;
    DM(I2, M2) = ^a_TrigTrack30;
    DM(I2, M2) = ^a_TrigTrack31;

    I2 = ^a_Seq+1+SEQ_VOLPTR;
    M2 = SEQ_VARS;
    DM(I2, M2) = ^a_VolTrack00;
    DM(I2, M2) = ^a_VolTrack01;
    DM(I2, M2) = ^a_VolTrack02;
    DM(I2, M2) = ^a_VolTrack03;
    DM(I2, M2) = ^a_VolTrack04;
    DM(I2, M2) = ^a_VolTrack05;
    DM(I2, M2) = ^a_VolTrack06;
    DM(I2, M2) = ^a_VolTrack07;
    DM(I2, M2) = ^a_VolTrack08;
    DM(I2, M2) = ^a_VolTrack09;
    DM(I2, M2) = ^a_VolTrack10;
    DM(I2, M2) = ^a_VolTrack11;
    DM(I2, M2) = ^a_VolTrack12;
    DM(I2, M2) = ^a_VolTrack13;
    DM(I2, M2) = ^a_VolTrack14;
    DM(I2, M2) = ^a_VolTrack15;
    DM(I2, M2) = ^a_VolTrack16;
    DM(I2, M2) = ^a_VolTrack17;
    DM(I2, M2) = ^a_VolTrack18;
    DM(I2, M2) = ^a_VolTrack19;
    DM(I2, M2) = ^a_VolTrack20;
    DM(I2, M2) = ^a_VolTrack21;
    DM(I2, M2) = ^a_VolTrack22;
    DM(I2, M2) = ^a_VolTrack23;
    DM(I2, M2) = ^a_VolTrack24;
    DM(I2, M2) = ^a_VolTrack25;
    DM(I2, M2) = ^a_VolTrack26;
    DM(I2, M2) = ^a_VolTrack27;
    DM(I2, M2) = ^a_VolTrack28;
    DM(I2, M2) = ^a_VolTrack29;
    DM(I2, M2) = ^a_VolTrack30;
    DM(I2, M2) = ^a_VolTrack31;

    I2 = ^a_Seq+1+SEQ_INITFUNC;
    M2 = SEQ_VARS;
    DM(I2, M2) = ^InitTrack00;
    DM(I2, M2) = ^InitTrack01;
    DM(I2, M2) = ^InitTrack02;
    DM(I2, M2) = ^InitTrack03;
    DM(I2, M2) = ^InitTrack04;
    DM(I2, M2) = ^InitTrack05;
    DM(I2, M2) = ^InitTrack06;
    DM(I2, M2) = ^InitTrack07;
    DM(I2, M2) = ^InitTrack08;
    DM(I2, M2) = ^InitTrack09;
    DM(I2, M2) = ^InitTrack10;
    DM(I2, M2) = ^InitTrack11;
    DM(I2, M2) = ^InitTrack12;
    DM(I2, M2) = ^InitTrack13;
    DM(I2, M2) = ^InitTrack14;
    DM(I2, M2) = ^InitTrack15;
    DM(I2, M2) = ^InitTrack16;
    DM(I2, M2) = ^InitTrack17;
    DM(I2, M2) = ^InitTrack18;
    DM(I2, M2) = ^InitTrack19;
    DM(I2, M2) = ^InitTrack20;
    DM(I2, M2) = ^InitTrack21;
    DM(I2, M2) = ^InitTrack22;
    DM(I2, M2) = ^InitTrack23;
    DM(I2, M2) = ^InitTrack24;
    DM(I2, M2) = ^InitTrack25;
    DM(I2, M2) = ^InitTrack26;
    DM(I2, M2) = ^InitTrack27;
    DM(I2, M2) = ^InitTrack28;
    DM(I2, M2) = ^InitTrack29;
    DM(I2, M2) = ^InitTrack30;
    DM(I2, M2) = ^InitTrack31;
    
    rts;

/*
 *  analyze GenFXIni, determine which functions are init'ed and hang the
 *  appropriate pointers into a_GenFXPtrInits.  the LFOs and MemEnvs are
 *  always called, so they need to be in here no matter what.
 */

FillGenFXPtrInits:
    I2 = DM(p_GenFXPtrInits);
    DM(p_GenFXPtrInits) = I2;
    
    AY0 = AR;                               /* AR=startaddr, AX0=endaddr */
    AR = AX0 - AY0;                         /* endaddr-startaddr */
    I5 = AY0;                               /* start of GenFXIni */
    L6 = 0;
    CNTR = AR;
    do FGP1 until CE;
      I6 = ^SetPtrOpcodes;                  /* reset opcode check addr */
      AR = PM(I5, M7);                      /* read GenFX opcode */
      AY0 = PX;
      CNTR = ALLGENFX;
      do FGP2 until CE;
        AY1 = PM(I6, M7);                   /* read from SetPtrOpcodes */
        NONE = AR - AY1;
        if NE jump NoMatch;
        AX0 = PX;
        NONE = AX0 - AY0;
        if NE jump NoMatch;
Match:
        call (I6);
NoMatch:
        modify(I6, M7);
FGP2:   nop;
FGP1:   nop;

    /* rest I6/L6 to a_RandLUT, where they belong */
    I6 = ^a_RandLUT;
    L6 = %a_RandLUT;

    rts;

/*******************************************************************************
 *  determine the total number of MemEmv3 calls, write to v_NumMemEnv3
 ******************************************************************************/

MEMENV3_CALLSInit:
    SR0 = I5;                               /* save I5 */
    SR1 = AY0;                              /* save AY0 */
    SI = AR;                                /* save AR */

    AY1 = 0x8000;
    AR = 0;
StartMCL:
    AX0 = PM(I5, M7);
    NONE = AX0 and AY1;
    if EQ jump EndMCL;
    AR = AR + 1;
    jump StartMCL;

EndMCL:
    AF = pass 0;
    AY0 = MEMENV3_VARS;
    AR = I5;                                /* get end address */
    AY1 = SR0;                              /* get starting address */
StartMCL2:
    AR = AR - AY0;
    NONE = AR - AY1;
    if LT jump EndMCL2;
    AF = AF + 1;
    jump StartMCL2;

EndMCL2:
    AR = pass AF;
    DM(v_NumMemEnv3) = AR;

    I5 = SR0;                               /* restore I5 */
    AY0 = SR1;                              /* restore AY0 */
    AR = SI;                                /* restore AR */
    
    rts;


/*******************************************************************************
 *  determine the total number of MemEmv1 calls, write to v_NumMemEnv1
 ******************************************************************************/

MEMENV1_CALLSInit:
    SR0 = I5;                               /* save I5 */
    SR1 = AY0;                              /* save AY0 */
    SI = AR;                                /* save AR */

    AY1 = 0x8000;
    AR = 0;
StartMCL_1:
    AX0 = PM(I5, M7);                       /* bit15 set in DM(I2... */
    NONE = AX0 and AY1;
    if EQ jump EndMCL_1;
    AR = AR + 1;
    jump StartMCL_1;

EndMCL_1:
    AF = pass 0;
    AY0 = MEMENV1_VARS;
    AR = I5;                                /* get end address */
    AY1 = SR0;                              /* get starting address */
StartMCL2_1:
    AR = AR - AY0;
    NONE = AR - AY1;
    if LT jump EndMCL2_1;
    AF = AF + 1;
    jump StartMCL2_1;

EndMCL2_1:
    AR = pass AF;
    DM(v_NumMemEnv1) = AR;

    I5 = SR0;                               /* restore I5 */
    AY0 = SR1;                              /* restore AY0 */
    AR = SI;                                /* restore AR */
    
    rts;

/*******************************************************************************
 *  determine the total number of MemEnv2 calls, write to v_NumMemEnv2
 ******************************************************************************/

MEMENV2_CALLSInit:
    SR0 = I5;                               /* save I5 */
    SR1 = AY0;                              /* save AY0 */
    SI = AR;                                /* save AR */

    AY1 = 0x8000;
    AR = 0;
StartMCL_2:
    AX0 = PM(I5, M7);                       /* bit15 set in DM(I2... */
    NONE = AX0 and AY1;
    if EQ jump EndMCL_2;
    AR = AR + 1;
    jump StartMCL_2;

EndMCL_2:
    AF = pass 0;
    AY0 = MEMENV2_VARS;
    AR = I5;                                /* get end address */
    AY1 = SR0;                              /* get starting address */
StartMCL2_2:
    AR = AR - AY0;
    NONE = AR - AY1;
    if LT jump EndMCL2_2;
    AF = AF + 1;
    jump StartMCL2_2;

EndMCL2_2:
    AR = pass AF;
    DM(v_NumMemEnv2) = AR;

    I5 = SR0;                               /* restore I5 */
    AY0 = SR1;                              /* restore AY0 */
    AR = SI;                                /* restore AR */
    
    rts;

/*******************************************************************************
 *  determine the total number of LFO3 calls, write to v_NumLFO3
 ******************************************************************************/
 
LFO_CALLSInit:
    SR0 = I5;                               /* save I5 */
    SR1 = AY0;                              /* save AY0 */
    SI = AR;                                /* save AR */

    AY1 = 0x8000;
    AR = 0;
StartL3CL:
    AX0 = PM(I5, M7);
    NONE = AX0 and AY1;                     /* bit15 set in DM(I2... */
    if EQ jump EndL3CL;
    AR = AR + 1;
    jump StartL3CL;

EndL3CL:
    AF = pass 0;
    AY0 = LFO_VARS;
    AR = I5;                                /* get end address */
    AY1 = SR0;                              /* get starting address */
StartL3CL2:
    AR = AR - AY0;
    NONE = AR - AY1;
    if LT jump EndL3CL2;
    AF = AF + 1;
    jump StartL3CL2;

EndL3CL2:
    AR = pass AF;
    DM(v_NumLFO3) = AR;

    I5 = SR0;                               /* restore I5 */
    AY0 = SR1;                              /* restore AY0 */
    AR = SI;                                /* restore AR */
    
    rts;

/*
 *  jumptable for a_GenFXPtrInits initializations
 */

SetPtrOpcodes:
    SETPTR(a_AlgoSineGen);          jump AlgoSinePtrInit;           
    SETPTR(a_AlgoSineSatGen);       jump AlgoSineSatPtrInit;        
    SETPTR(a_WTGen2);               jump WTGen2PtrInit;             
    SETPTR(a_HPWTGen2);             jump HPWTGen2PtrInit;             
    SETPTR(a_WTGen);                jump WTGenPtrInit;
    SETPTR(a_WTGenSyncFX);          jump WTGenSyncFXPtrInit;
    SETPTR(a_ADSRPanEnv);           jump ADSRPanEnvPtrInit;         
    SETPTR(a_FM2Op0Gen);            jump FM2Op0PtrInit;             
    
    /* these don't do a ptr init, they always are called and are auto inc'ed */
    SETPTR(a_MemEnv3);              jump MEMENV3_CALLSInit;             
    SETPTR(a_LFO);                 jump LFO_CALLSInit;            
    SETPTR(a_MemEnv1);              jump MEMENV1_CALLSInit;            
    SETPTR(a_MemEnv2);              jump MEMENV2_CALLSInit;
    
    SETPTR(a_ExpDecayEnv);          jump ExpDecayPtrInit;           
    SETPTR(a_RotSynthGen);          jump RotSynthPtrInit;           
    SETPTR(a_TunedRotSynthGen);     jump TunedRotSynthPtrInit;
    SETPTR(a_SVFFX);                jump SVFPtrInit;                
    SETPTR(a_ProbKSGen);            jump ProbKSPtrInit;             
    SETPTR(a_GenSHFX);              jump GenSHFXPtrInit;
    SETPTR(a_OscCombGen);           jump OscCombPtrInit;            
    SETPTR(a_PerNoiseGen);          jump PerNoisePtrInit;           
    SETPTR(a_ProbSynthGen);         jump ProbSynPtrInit;            
    SETPTR(a_KSGen);                jump KSPtrInit;                 
    SETPTR(a_ClampFX);              jump ClampFXPtrInit;            
    SETPTR(a_DelaySynthGen);        jump DelaySynPtrInit;           
    SETPTR(a_Exp1Gen);              jump Exp1PtrInit;               
    SETPTR(a_KillTimeFX);           jump KillTimePtrInit;           
    SETPTR(a_PrevCurrFiltFX);       jump PrevCurrFiltPtrInit;       
    SETPTR(a_ZeroSampsFX);          jump ZeroSampsPtrInit;          
    SETPTR(a_RectifyFX);            jump RectifyPtrInit;            
    SETPTR(a_BitMaskFX);            jump BitmaskPtrInit;
    SETPTR(a_WaveShapeFX);          jump WaveShapeFXPtrInit;
    SETPTR(a_MultiGen);             jump MultiGenPtrInit;
    SETPTR(a_ExpImpulseGen);        jump ExpImpulseGenPtrInit;
    SETPTR(a_CopiedGen);            jump CopiedGenPtrInit;
EndSetPtrOpcodes:

/*
 *  opcodes used in GenFX_.dsp initializations
 */

ADSRPanEnvOpcode:
    call ADSRPanEnv;
ExpDecayOpcode:
    call ExpDecayEnv;
    
    
.ENDMOD;
                                         