/*****************************************************************************
*
*  gmInitVr.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*****************************************************************************/

.MODULE                                     modgmInitVars;

/*
 *  create a transmit buffer for commands + L/R channel data.  the first
 *  command forces the 1847 into command mode by setting the MCE bit
 */

.VAR/DM/CIRC        a_TXbuffer[3];
.GLOBAL             a_TXbuffer;
.INIT               a_TXbuffer:
                        0xc000, 0x0000, 0x0000;

.VAR/DM/CIRC        a_RXbuffer[3];
.GLOBAL             a_RXbuffer;
.INIT               a_RXbuffer:
                        0xc000;

/*
 *  create an init buffer for the commands sent to the 1847.  the basic
 *  structure of the command words is as follows:
 *
 *  bit 15:     overrange status bit
 *  bit 14:     mode change enable bit - set when changing index regs
 *  bit 13:     readback mode bit
 *  bit 12:
 *  bits 8-11:  IA0-3 index reg address bits
 *  bits 0-7:   1847 configuration data
 */
  
.VAR/DM/CIRC        a_1847Params[13];
.GLOBAL             a_1847Params;
.INIT               a_1847Params:  	    /*0xc04f,*/
                                        0xc002,
            
            /*  CLOR set, MCE set, Index reg address=0, data=0x2
		     *  Left input control reg
		     *  b7-6: 0=left line 1
		     *        1=left aux 1
		     *        2=left line 2
		     *        3=left line 1 post-mixed loopback
		     *  b5-4: res
		     *  b3-0: left input gain x 1.5 dB */
								 
	                                    /*0xc14f,*/
	                                    0xc102,
            
            /*  CLOR set, MCE set, Index reg address=1, data=0x2
             *  Right input control reg
		     *  b7-6:  0=right line 1
		     *         1=right aux 1
		     *         2=right line 2
		     *         3=right line 1 post-mixed loopback
		     *  b5-4:  res
		     *  b3-0:  right input gain x 1.5 db               */

	                                    0xc288,
            
            /*  CLOR set, MCE set, Index reg address=2, data=0x88
		     *   Left aux 1 control reg
		     *   b7  :    1=left aux 1 mute
		     *   b6-5:    res
		     *   b4-0:    gain/atten x 1.5, 08= 0dB, 00= 12dB */
		    
	                                    0xc388,
            
            /* CLOR set, MCE set, Index reg address=3, data=0x88
		     *   Right aux 1 control reg
		     *   b7  :   1=right aux 1 mute
		     *   b6-5:   res
		     *   b4-0:   gain/atten x 1.5, 08= 0dB, 00= 12dB */
		    
	                                    0xc488,
            
            /* CLOR set, MCE set, Index reg address=4, data=0x88
		     *   left aux 2 control reg
		     *   b7  :   1=left aux 2 mute
		     *   b6-5:   res
		     *   b4-0:   gain/atten x 1.5, 08= 0dB, 00= 12dB */
		    
	                                    0xc588,
	                                
            /* CLOR set, MCE set, Index reg address=5, data=0x88
		     *   right aux 2 control reg
		     *   b7  :   1=right aux 2 mute
		     *   b6-5:   res
		     *   b4-0:   gain/atten x 1.5, 08= 0dB, 00= 12dB */
		    
	                                    0xc680,     
            
            /* CLOR set, MCE set, Index reg address=6, data=0x80
		     *   left DAC control reg
		     *   b7  :   1=left DAC mute
		     *   b6  :   res
		     *   b5-0:   attenuation x 1.5 dB */

	                                    0xc780,
            
            /* CLOR set, MCE set, Index reg address=7, data=0x80
		     *   right DAC control reg
		     *   b7  :   1 = right DAC mute
		     *   b6  :   res
		     *   b5-0:   attenuation x 1.5 dB */
		    
	                                    0xc85b,
            
            /* CLOR set, MCE set, Index reg address=8, data=0x5c
		     *   data format register
		     *   b7  :   res
		     *   b5-6:   0 = 8-bit unsigned linear PCM
		     *           1 = 8-bit u-law companded
		     *           2 = 16-bit signed linear PCM
		     *           3 = 8-bit A-law companded
		     *   b4  :   0 = mono, 1 =  stereo
		     *   b0-3:   0 =   8.00000 Khz
		     *           1 =   5.51250 Khz
		     *           2 = 16.00000 Khz
		     *           3 = 11.02500 Khz
		     *           4 = 27.42857 Khz
		     *           5 = 18.90000 Khz
		     *           6 = 32.00000 Khz
		     *           7 = 22.05000 Khz
		     *           8 =   .
		     *           9 = 37.80000 Khz
		     *           a =   .
		     *           b = 44.10000 Khz
		     *           c = 48.00000 Khz
		     *           d = 33.07500 Khz
		     *           e =   9.60000 Khz
		     *           f =   6.61500 Khz
		     *  (b0) :   0 = XTAL1 24.576 Mhz; 1 = XTAL2 16.9344 Mhz */
		    
	                                    0xc909,
	                                
            /* CLOR set, MCE set, Index reg address=9, data=0x09
		     *   interface configuration reg
		     *   b7-4:   res
		     *   b3  :   1 = autocalibrate
		     *   b2-1:   res
		     *   b0  :   1 = playback enabled */
		     
	                                    0xca00,
	                                
            /* CLOR set, MCE set, Index reg address=0xa, data=0
		     *   pin control reg
		     *   b7  :   logic state of pin XCTL1
		     *   b6  :   logic state of pin XCTL0
		     *   b5  :   master - 1 = tri-state CLKOUT
		     *           slave  - x = tri-state CLKOUT
		     *   b4-0:   res */

        	                            0xcc40,
        	                        
            /* CLOR set, MCE set, Index reg address=0xc, data=0x40
		     *   miscellaneous information reg
		     *   b7  :   1 = 16 slots per frame
		     *           0 = 32 slots per frame
		     *   b6  :   1 = 2-wire system
		     *           0 = 1-wire system
		     *   b5-0:   res */

	                                    0xcd00;
	                                
            /* CLOR set, MCE set, Index reg address=0xd, data=0
		     *   digital mix control reg
		     *   b7-2:   attenuation x 1.5 dB
		     *   b1  :   res
		     *   b0  :   1 = digital mix enabled */

/*
 *  boolean value indicating if the 1847 has been initialized
 */

.VAR/DM             b_Init1847;
.GLOBAL             b_Init1847;
.INIT               b_Init1847:             1;

.ENDMOD;