/******************************************************************************
*
*  Clamp.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modClamp;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      ClampFX;

ClampFX:
    I2 = DM(p_ClampFX);
    AY0 = DM(I2, M1);                       /* clamp max */
    MY0 = DM(I2, M1);                       /* mix */
    DM(p_ClampFX) = I2;
    
    SR0 = DM(I7, M6);                       /* SR0 = input */
    AR = pass SR0;                          /* AR = input */
    if LT jump NegClampFX;
    NONE = SR0 - AY0;                       /* check for pos clamp */
    if LT rts;                              /* no need to calc mix, in=out */
    
ClampPosOutput:
    MX1 = AY0;
    MR = MX1 * MY0 (SS);                /* get mixed out, AY0=calced out */
    AX0 = 0x7fff;
    AY0 = MY0;                              /* MY0=mix */
    AR=AX0-AY0, AY1=MR1;                    /* AR=1-mix, AY1=scaled caled out */
    MY1 = AR;
    MR = SR0 * MY1 (SS);
    AR = MR1 + AY1;
    DM(I7, M6) = AR;
    rts;

NegClampFX:
    AR = -AR;
    NONE = AR - AY0;
    if LT rts;
    
ClampNegOutput:
    AR = -AY0;
    
    MX1 = AR;
    MR = MX1 * MY0 (SS);              /* get mixed out, AR = calced_out */
    AX0 = 0x7fff;
    AY0 = MY0;
    AR = AX0 - AY0, AY1=MR1;                /* 1-mix */
    MY1 = AR;
    MR = SR0 * MY1 (SS);
    AR = MR1 + AY1;
    
    DM(I7, M6) = AR;
    rts;

.ENDMOD;
