/******************************************************************************
*
*  GenSHFX.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modGenSHFX;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      GenSHFX;

GenSHFX:
    I2 = DM(p_GenSHFX);
    AY0 = DM(I2, M1);                   /* get holdper */
        
    AR = DM(I2, M0);                    /* get holdcnt */
    AR = AR + 1;
    DM(I2, M0) = AR;
    NONE = AR - AY0;
    if LE jump Hold;

/*
 *  do not modify output.  load output into holdval.  reset holdcnt.
 */

Resample:
    DM(I2, M1) = 0;                     /* holdcnt=0 */
    AR = DM(I7, M6);                    /* get current output */
    DM(I2, M1) = AR;                    /* update holdval */
    modify(I2, M1);                     /* do not calculate new mixed val */
    DM(p_GenSHFX) = I2;
    rts;

/*
 *  get holdval.  overwrite old output.
 */
 
Hold:
    modify(I2, M1);                     /* skip holdcnt */
    AR = DM(I2, M1);                    /* get holdval */

    MY0 = DM(I2, M1);                   /* get mix amount */
    MR=AR*MY0 (SS), AY0=MY0;            /* mix*calced_out */
    AX0 = 0x7fff;
    AR=AX0-AY0, MY1=DM(I7,M6);
    MR = MR + AR * MY1 (SS);
    
    DM(I7, M6) = AR;                    /* overwrite old output */
    DM(p_GenSHFX) = I2;
    rts;
    
.ENDMOD;
