/******************************************************************************
*
*  Rectify.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modRectifier;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      RectifyFX;

RectifyFX:
    I2 = DM(p_RectifyFX);
    AX1 = DM(I2, M1);                       /* get rectify direction */
    MY1 = DM(I2, M1);                       /* MY1=mix */
    DM(p_RectifyFX) = I2;
    AR = DM(I7, M6);                        /* AR=orig */
    MY0 = AR;                               /* MY0=orig */
    AR = abs AR;                            /* AR=calced_out (for pos) */
    NONE = pass AX1;
    if EQ jump PosRectify;
    
NegRectify:
    AR = -AR;
    /* output = mix*calced_out + (1-mix)*orig_out */
    /* mix = MY1, AR=calced_out, orig_out=MX0 */

#if 0
    MR = AR * MY1 (SS);                     /* mix*calced_out=MR1 */
    AY0 = MY1;                              /* AY0=mix */
    AX1 = 0x7fff;
    AR = AX1 - AY0;                         /* AR=(1-mix) */
#endif

    DM(I7, M6) = AR;
    rts;
    
PosRectify:
    /* output = mix*calced_out + (1-mix)*orig_out */
    /* mix = MY1, AR=calced_out, orig_out=MX0 */
    MR = AR * MY1 (SS);                     /* mix*calced_out=MR1 */
    AY0 = MY1;                              /* AY0=mix */
    AX1 = 0x7fff;
    AR = AX1 - AY0;                         /* AR=(1-mix) */
    MR = MR + AR * MY0 (SS);
        
    DM(I7, M6) = MR1;
    rts;
        
.ENDMOD;
