/******************************************************************************
*
*  Seq2.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modSeq2;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  temporary variables
 */

.VAR        v_Temp1;
.VAR        v_Temp2;
.VAR        v_Temp3;
.VAR        v_Temp4;

/*
 *  entry points
 */
 
.ENTRY      Seq2;

Seq2:
    DM(v_Temp4) = M0;
    I3 = ^a_Seq + 1;
    CNTR = DM(a_Seq + 0);
        
    do SL2 until CE;
      
      AR = DM(I3, M0);                  /* curr trig count */
      AR = AR + 1;
      DM(I3, M1) = AR;
      AY0 = DM(I3, M1);                 /* trig rate (w/ swing) */
      AR = AR - AY0;
      if LT jump NT1;

      M2 = -2;
      modify(I3, M2);
      DM(I3, M1) = 0;
      modify(I3, M1);
      AX0 = DM(I3, M1);                 /* get base trig rate */
      
      /* start swing stuff */
      AY0 = DM(I3, M1);                 /* read swing period */
      AR = DM(I3, M0);                  /* read curr swing count */
      AR = AR + 1;
      DM(I3, M1) = AR;                  /* inc swing count */
      AY1 = DM(I3, M1);                 /* get swing amount */
      NONE = AR - AY0;
      if LT jump NoSwing;
      
      /* reset count, change period, flip direction */
      M2 = -5;
      modify(I3, M2);
      AR = AX0 + AY1;                    /* add/sub swing */
      DM(I3, M1) = AR;                  /* write new period */
      AR = -AY1;                        /* invert swing direction */
      M2 = 2;
      modify(I3, M2);
      DM(I3, M1) = 0;
      DM(I3, M1) = AR;
      
      
      
NoSwing:
      AR = DM(I3, M1);                  /* length of trigger array */
      L2 = AR;
      AY1 = DM(I3, M1);                 /* base addr of trig array */
            
      AX1 = DM(I3, M0);                 /* ptr to trigger array */
      AR = AX1 - AY1;
      DM(v_TrigOffset) = AR;
      AR = AR + AY1;                    /* AR=tic to read and compare */
     
      I2 = AX1;
      AY0 = DM(I2, M1);                 /* threshold */
      DM(v_Temp2) = AY0;
      L2 = 0;
      AX1 = I2;
      DM(I3, M1) = AX1;                 /* update ptr to trigger array */
      
      AX0 = DM(I3, M1);                 /* base addr of vol array */
      AY1 = DM(v_TrigOffset);
      AR = AX0 + AY1;
      DM(p_Vol) = AR;

      /* get control track step type */
      AR = DM(I3, M0);
      I5 = AR;                              /* I5=ap_CTRLTrack */
      !modify(I5, M7);
      AY0 = DM(I5, M7);                     /* AY0=NUMCTRLTRACK */
      AF = pass AY0;
      AX0 = DM(I5, M7);                     /* steptype */
      AY0 = ALWAYSSTEP;
      NONE = AX0 - AY0;
      if EQ call GetControlTrackData;
      
      AR = DM(I6, M7);
      MY0 = 50;
      MR = AR * MY0 (UU);
      AY0 = DM(v_Temp2);
      NONE = MR1 - AY0;
      if GE jump NT2;

      /* get control track step type */
      AR = DM(I3, M0);
      I5 = AR;                              /* I5=ap_CTRLTrack */
      !modify(I5, M7);
      AY0 = DM(I5, M7);                     /* AY0=NUMCTRLTRACK */
      AF = pass AY0;
      AX0 = DM(I5, M7);                     /* steptype */
      AY0 = STEPONRETRIG;
      NONE = AX0 - AY0;
      if EQ call GetControlTrackData;
      
      AR = DM(I3, M1);
      I5 = AR;
      
      /* only state that must be held in trigger call is I3 */
      DM(v_Temp3) = I3;
      call (I5);                        /* perform triggering */
      I3 = DM(v_Temp3);

/*
 *  write volume into appropriate envelope array.  in the case of NoOutput,
 *  nothing should be written.
 */

      I2 = DM(p_Vol);
      AX0 = DM(I2, M1);                 /* get volume */
      AR = DM(I3, M1);                  /* envelope type */
      M5 = AR;
      I5 = ^EnvJT;
      modify(I5, M5);
      jump (I5);
EnvJT:
      jump NoOutput;
      jump ADSREnv;
      jump ExpDecay;
      jump ME3Env;

NoOutput:
      modify(I3, M1);
      AR = DM(I3, M1);
      I5 = AR;
      
      DM(v_Temp3) = I3;
      call (I5);
      I3 = DM(v_Temp3);
      jump SL;

ME3Env:
      MY0 = DM(I3, M1);                 /* generator envelop applies to */
      MX0 = MEMENV3_VARS;
      MR = MX0 * MY0 (UU);
      SR = ashift MR0 by -1 (LO);       /* shift for int mults */
      AY1 = ^a_MemEnv3;
      AY0 = MEMENV3_STAGE;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      AY0 = MEMENV3_INTCNTR;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      AR = DM(I3, M1);
      I5 = AR;
      
      DM(v_Temp3) = I3;
      call (I5);                        /* misc processing during trigger */
      I3 = DM(v_Temp3);

      jump SL;    

ADSREnv:
      MY0 = DM(I3, M1);                 /* generator envelop applies to */
      MX0 = ADSRPANENV_VARS;
      MR = MX0 * MY0 (UU);
      SR = ashift MR0 by -1 (LO);       /* shift for int mults */
      
      AY1 = ^a_ADSRPanEnv;
      AY0 = ADSRPANENV_RC;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      AY0 = ADSRPANENV_INTSCALAR;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      AY0 = ADSRPANENV_STAGE;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      AY0 = ADSRPANENV_SUSTAINCNT;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0;
      
      I2 = ^a_ADSRPanEnv;
      AY0 = ADSRPANENV_SCALAR;
      AR = SR0 + AY0;                   /* calc offset into a_ADSRPanEnv */
      M2 = AR;
      modify(I2, M2);
      DM(I2, M0) = AX0;
      AR = DM(I3, M1);
      I5 = AR;
      
      DM(v_Temp3) = I3;
      call (I5);                        /* misc processing during trigger */
      I3 = DM(v_Temp3);
      
      jump SL;

ExpDecay:
      MY0 = DM(I3, M1);                 /* generator envelop applies to */
      MX0 = EXPDECAYENV_VARS;
      MR = MX0 * MY0 (UU);
      SR = ashift MR0 by -1 (LO);       /* shift for int mults */

      AY1 = ^a_ExpDecayEnv;
      AY0 = EXPDECAYENV_INTSCALAR;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0x7fff;

      AY1 = ^a_ExpDecayEnv;
      AY0 = EXPDECAYENV_INTCOUNT;
      AR = SR0 + AY0;
      AR = AR + AY1;
      I5 = AR;
      DM(I5, M6) = 0x0000;

      I2 = ^a_ExpDecayEnv;
      AY0 = EXPDECAYENV_SCALAR;
      AR = SR0 + AY0;                   /* calc offset into a_ExpDecayEnv */
      M2 = AR;
      modify(I2, M2);
      DM(I2, M0) = AX0;
      AR = DM(I3, M1);
      I5 = AR;
      
      DM(v_Temp3) = I3;
      call (I5);                        /* misc processing during trigger */
      I3 = DM(v_Temp3);
      
      jump SL;    

NT1:
      M3 = 13;
      modify(I3, M3);
      jump SL;

NT2:
      M3 = 4;
      modify(I3, M3);
      jump SL;

SL:   AX0 = ^a_CTRLData;
      AR = DM(v_Temp4);
      AR = AR + 1;
      DM(v_Temp4) = AR;
SL2:  DM(p_CTRLData) = AX0;

    rts;

GetControlTrackData:

      /* get CTRLTrack values */
      AR = DM(I3, M1);                  /* read base addr of ap_CTRLTrack */
      I5 = AR;                          /* I5 = ^ap_CTRLTrack */
      
      AR = DM(I5, M7);
      AY0 = 2;
      NONE = AR - AY0;
      AF = pass AR;                     /* get and set num ctrl track */
      modify(I5, M7);                   /* step past control track step type */
      
CT1:
      AY0 = DM(I5, M7);                 /* get len of a_CTRLTrack */
      AR = DM(I5, M6);                  /* get ptr into a_CTRLTrack */
      L5 = AY0;                         /* make a_CTRLTrack circ access */
      DM(v_Temp1) = I5;                 /* keep ptr into ap_CTRLTrack */
      I5 = AR;                          /* I5 = ^a_CTRLTrack */
      
      AR = DM(I5, M7);                  /* read CTRL value */
      L5 = 0;
      AY0 = I5;
      I5 = DM(v_Temp1);                 /* I5=^ap_CTRLTrack */
      DM(I5, M7) = AY0;
      DM(v_Temp1) = I5;                 /* I5 = ptr into ap_CTRLTrack */
      I5 = DM(p_CTRLData);
      DM(I5, M7) = AR;
      DM(p_CTRLData) = I5;
      AF = AF - 1;
      I5 = DM(v_Temp1);
      if GT jump CT1;

      rts;

.ENDMOD;
  