/*****************************************************************************
*
*  TunedRotSynth.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*****************************************************************************/

.MODULE                                     modTunedRotSynth;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      TunedRotSynthGen;

TunedRotSynthGen:
    I2 = DM(p_TunedRotSynthGen);
    AY1 = DM(I2, M1);
    AR = DM(I2, M0);                        /* current count */
    AR = AR + 1;
    DM(I2, M1) = AR;                        /* update current count */
    NONE = AR - AY1;
    if GT jump CalcNewOutput;

KeepOldValue:
    modify(I2, M1);
    M2 = 4;
    AR = DM(I2, M2);
    DM(I7, M6) = AR;
    DM(p_TunedRotSynthGen) = I2;
    rts;

CalcNewOutput:
    M2 = -1;
    modify(I2, M2);
    DM(I2, M1) = 1;
    SE = DM(I2, M1);
    AR = DM(I2, M0);
    SR1 = 0;
    SR = lshift AR (LO);
    AY0 = SR1;
    AR = SR0 or AY0;
    DM(I2, M1) = AR;
    DM(I7, M6) = AR;
    
    AR = DM(I2, M0);                        /* get samples before total rot */
    AR = AR - AY1;
    DM(I2, M1) = AR;
    AY0 = AR;
    AY1 = 0;
    AR = DM(I2, M0);
    AR = AR - 1;
    DM(I2, M1) = AR;
    if EQ jump InitTotSamps;
    AF=pass 0, AX0=AR;
    call USDivideNoRem;
    
    M2 = -6;
    modify(I2, M2);
    DM(I2, M0) = AY0;
    M2 = 7;
    modify(I2, M2);
    DM(p_TunedRotSynthGen) = I2;
    rts;

InitTotSamps:
    M2 = -1;
    modify(I2, M2);
    DM(I2, M1) = 16;
    AF=pass 0, AX0=DM(I2,M1);               /* rot freq */
    AY1 = 0x0000;
    AY0 = 44100;
    call USDivideNoRem;
    M2 = -3;
    modify(I2, M2);
    DM(I2, M0) = AY0;
    M2 = 3;
    modify(I2, M2);
    DM(p_TunedRotSynthGen) = I2;
    rts;
    
.ENDMOD;
    