/*****************************************************************************
*
*  ZeroSamps.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  function to zero out a pattern of data passed to the serial port output
*
*****************************************************************************/

.MODULE                                     modZeroSamples;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      ZeroSampsFX;

ZeroSampsFX:
    I2 = DM(p_ZeroSampsFX);
    AY0 = DM(I2, M1);                   /* get probability factor */
    
    /* get random number */
    AR = DM(I6, M7);
    AR = abs AR;
    
    NONE = AR - AY0;
    AR = DM(I7, M6);                    /* get sample */
    if LT jump MixZeroSampsOutput;
    
    DM(I7, M6) = AR;
    
    modify(I2, M1);
    DM(p_ZeroSampsFX) = I2;               /* update ptr */
    rts;
    
MixZeroSampsOutput:
    AX0 = 0x7fff;
    AY0 = DM(I2, M1);                       /* get mix */
    MY0 = AR;
    AR = AX0 - AY0;
    MR = AR * MY0 (SS);
    DM(I7, M6) = MR1;
    DM(p_ZeroSampsFX) = I2;               /* update ptr */
    
    rts;
    
.ENDMOD;
