/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "exp3_3.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitTrack00;
.ENTRY      InitTrack01;
.ENTRY      InitTrack02;
.ENTRY      InitTrack03;
.ENTRY      InitTrack04;
.ENTRY      InitTrack05;
.ENTRY      InitTrack06;
.ENTRY      InitTrack07;
.ENTRY      InitTrack08;
.ENTRY      InitTrack09;
.ENTRY      InitTrack10;
.ENTRY      InitTrack11;
.ENTRY      InitTrack12;
.ENTRY      InitTrack13;
.ENTRY      InitTrack14;
.ENTRY      InitTrack15;
.ENTRY      InitTrack16;
.ENTRY      InitTrack17;
.ENTRY      InitTrack18;
.ENTRY      InitTrack19;
.ENTRY      InitTrack20;
.ENTRY      InitTrack21;
.ENTRY      InitTrack22;
.ENTRY      InitTrack23;
.ENTRY      InitTrack24;
.ENTRY      InitTrack25;
.ENTRY      InitTrack26;
.ENTRY      InitTrack27;
.ENTRY      InitTrack28;
.ENTRY      InitTrack29;
.ENTRY      InitTrack30;
.ENTRY      InitTrack31;

/* bd0 */
InitTrack00:
    RESET_MEMENV2(0);
    
    AR = DM(I6, M7);
    MY0 = 0x0200;
    MR = AR * MY0 (SS);
    AR = MR1 + 0x4000;
    DM(a_ExpDecayEnv+(0*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;
    
    rts;

/* bd1 */    
InitTrack01:
    RESET_MEMENV2(1);
    
    AR = DM(I6, M7);
    MY0 = 0x0200;
    MR = AR * MY0 (SS);
    AR = MR1 + 0x4000;
    DM(a_ExpDecayEnv+(0*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;
    
    rts;

/* rhythmsaw */
InitTrack02:
    RESET_MEMENV3(0);
    rts;

/* hh0 - noise */
InitTrack03:
    rts;

/* hh0 - noise */
InitTrack04:
    AY0 = DM(v_NoiseFiltFreq);
    MY0 = DM(I6, M7);
    MX0 = 50;
    MR = MX0 * MY0 (UU);
    NONE = MR1 - AY0;
    if LE jump SetCutoffLow;
    
SetCutoffHigh:
    AR = 0x4000;
    DM(a_SVFFX+(0*SVFFX_VARS)+SVFFX_K3) = AR;
    DM(a_SVFFX+(0*SVFFX_VARS)+SVFFX_K4) = AR;
    DM(a_SVFFX+(1*SVFFX_VARS)+SVFFX_K3) = AR;
    DM(a_SVFFX+(1*SVFFX_VARS)+SVFFX_K4) = AR;
    rts;

SetCutoffLow:
    AR = 0x1000;
    DM(a_SVFFX+(0*SVFFX_VARS)+SVFFX_K3) = AR;
    DM(a_SVFFX+(0*SVFFX_VARS)+SVFFX_K4) = AR;
    DM(a_SVFFX+(1*SVFFX_VARS)+SVFFX_K3) = AR;
    DM(a_SVFFX+(1*SVFFX_VARS)+SVFFX_K4) = AR;
    rts;
    

/* hh1 */
InitTrack05:
    call FillKS0Buff;
    RESET_PHASE_LFO(12);
    AY0 = DM(v_ProbLowGenSHFX);
    MX0 = DM(I6, M7);
    MY0 = 50;
    MR = MX0 * MY0 (UU);
    NONE = MR1 - AY0;
    AY0 = 6;
    if LE jump SetGenSHFX;
    AY0 = 4;

SetGenSHFX:
    DM(a_LFO+(12*LFO_VARS)+LFO_BASE) = AY0;
    DM(a_LFO+(13*LFO_VARS)+LFO_BASE) = AY0;
    rts;

/* hh1 */    
InitTrack06:
    call FillKS1Buff;
    RESET_PHASE_LFO(13);
    rts;

/* hh2 */
InitTrack07:
    call FillKS2Buff;
    AR = DM(a_KSGen+(2*KSGEN_VARS+KSGEN_FREQ));
    AR = AR + 1;
    DM(a_KSGen+(2*KSGEN_VARS+KSGEN_FREQ)) = AR;
    AY0 = 0x6f;
    NONE = AR - AY0;
    if LT rts;
    AR = 0x3f;
    DM(a_KSGen+(2*KSGEN_VARS+KSGEN_FREQ)) = AR;
    rts;

/* hh2 */
InitTrack08:
    call FillKS3Buff;
    AR = DM(a_KSGen+(3*KSGEN_VARS+KSGEN_FREQ));
    AR = AR + 1;
    DM(a_KSGen+(3*KSGEN_VARS+KSGEN_FREQ)) = AR;
    AY0 = 0x6c;
    NONE = AR - AY0;
    if LT rts;
    AR = 0x3f;
    DM(a_KSGen+(3*KSGEN_VARS+KSGEN_FREQ)) = AR;
    rts;

/* bass */
InitTrack09:
    AR = DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ));
    AY0 = 65;
    NONE = AR - AY0;
    if EQ jump Freq41;

Freq65:    
    DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ)) = AY0;
    RESET_MEMENV3(3);
    RESET_MEMENV3(4);
    
    rts;
    
Freq41:
    AR = DM(v_LowOrHighBassNote);
    AR = tglbit 0 of AR;
    DM(v_LowOrHighBassNote) = AR;
    AR = pass AR;
    AY0 = 41;
    if EQ jump SetBassNote;
    AY0 = 49;
    
SetBassNote:
    DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ)) = AY0;
    rts;

/* lead0 */   
InitTrack10:
    RESET_MEMENV3(1);
    RESET_MEMENV3(2);
    
    AR = 0x07ff;
    MY0 = DM(I6, M7);
    MR = AR * MY0 (SS);
    AY0 = 0x4000;
    AR = MR1 + AY0;
    DM(a_ExpDecayEnv+(7*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;
    
    AR = DM(I6, M7);
    MY0 = 50;
    MR = AR * MY0 (UU);
    
    AY0 = DM(v_KeepLeadFreq0);
    AR = MR1 - AY0;
    if LE jump KeepLeadFreq0;
    AY0 = DM(v_IncLeadFreq0);
    AR = AR - AY0;
    if LE jump IncLeadFreq0;
    jump DecLeadFreq0;

DecLeadFreq0:
    AR = DM(p_LeadNotes0);
    AR = pass AR;
    if EQ jump KeepLeadFreq0;
    AR = AR - 1;
    DM(p_LeadNotes0) = AR;
    jump KeepLeadFreq0;
    
IncLeadFreq0:
    AR = DM(p_LeadNotes0);
    AR = AR + 1;
    AY0 = %a_LeadNotes;
    NONE = AR - AY0;
    if EQ AR = pass 0;
    DM(p_LeadNotes0) = AR;
    jump KeepLeadFreq0;
    
KeepLeadFreq0:
    AR = DM(p_LeadNotes0);
    AY0 = ^a_LeadNotes;
    AR = AR + AY0;
    I3 = AR;
    AR = DM(I3, M0);
    M2 = AR;
    I3 = ^a_MIDIFreq;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(a_WTGen2 + ((4*WTGEN2_VARS)+WTGEN2_FREQ)) = AR;
    
    rts;

/* lead1 */    
InitTrack11:
    AR = 0x07ff;
    MY0 = DM(I6, M7);
    MR = AR * MY0 (SS);
    AY0 = 0x4000;
    AR = MR1 + AY0;
    DM(a_ExpDecayEnv+(8*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;
    
    AR = DM(I6, M7);
    MY0 = 50;
    MR = AR * MY0 (UU);
    
    AY0 = DM(v_KeepLeadFreq1);
    AR = MR1 - AY0;
    if LE jump KeepLeadFreq1;
    AY0 = DM(v_IncLeadFreq1);
    AR = AR - AY0;
    if LE jump IncLeadFreq1;
    jump DecLeadFreq1;

DecLeadFreq1:
    AR = DM(p_LeadNotes1);
    AR = pass AR;
    if EQ jump KeepLeadFreq1;
    AR = AR - 1;
    DM(p_LeadNotes1) = AR;
    jump KeepLeadFreq1;
    
IncLeadFreq1:
    AR = DM(p_LeadNotes1);
    AR = AR + 1;
    AY0 = %a_LeadNotes;
    NONE = AR - AY0;
    if EQ AR = pass 0;
    DM(p_LeadNotes1) = AR;
    jump KeepLeadFreq1;
    
KeepLeadFreq1:
    AR = DM(p_LeadNotes1);
    AY0 = ^a_LeadNotes;
    AR = AR + AY0;
    I3 = AR;
    AR = DM(I3, M0);
    M2 = AR;
    I3 = ^a_MIDIFreq;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(a_WTGen2 + ((5*WTGEN2_VARS)+WTGEN2_FREQ)) = AR;
    rts;

/* lead2 */
InitTrack12:
    rts;

/* lead2 */
InitTrack13:
    AR = DM(I6, M7);
    AY0 = DM(v_PadMask);
    AR = AR and AY0;
    M2 = AR;
    I2 = ^a_PadNotes;
    modify(I2, M2);
    
    AR = DM(I2, M0);
    M2 = AR;
    I2 = ^a_MIDIFreq;
    modify(I2, M2);
    AR = DM(I2, M0);
    
    DM(a_LFO+(6*LFO_VARS)+LFO_BASE) = AR;
    SR = ashift AR by 1 (LO);
    DM(a_LFO+(7*LFO_VARS)+LFO_BASE) = SR0;
    
    rts;

/* fmrhythm */
InitTrack14:
    RESET_FM2OP0GEN(0);
    
    AR = 0x03ff;
    MY0 = DM(I6, M7);
    MR = AR * MY0 (SS);
    AY0 = 0x4000;
    AR = MR1 + AY0;
    DM(a_ExpDecayEnv+(11*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;    
    
    rts;
    
InitTrack15:
    RESET_FM2OP0GEN(1);
    
    AR = 0x03ff;
    MY0 = DM(I6, M7);
    MR = AR * MY0 (SS);
    AY0 = 0x4000;
    AR = MR1 + AY0;
    DM(a_ExpDecayEnv+(12*EXPDECAYENV_VARS)+EXPDECAYENV_PAN) = AR;    
    
    rts;
    
InitTrack16:
    rts;
    
InitTrack17:
    rts;
    
InitTrack18:
    rts;
    
InitTrack19:
    rts;
    
InitTrack20:
    rts;
    
InitTrack21:
    rts;
    
InitTrack22:
    rts;
    
InitTrack23:
    rts;
    
InitTrack24:
    rts;
    
InitTrack25:
    rts;
    
InitTrack26:
    rts;
    
InitTrack27:
    rts;
    
InitTrack28:
    rts;
    
InitTrack29:
    rts;
    
InitTrack30:
    rts;
    
InitTrack31:
    rts;
    
.ENDMOD;
