/******************************************************************************
*
*  templatedefs.h
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  defintions of lengths of arrays for the sequencer, along with karplus strong
*  and delay synth arrays.  all other #define values specific to this project
*  should also be placed in here.
*
******************************************************************************/

/*
 *  place project-specific #define values here
 */
 
#define EXP2_3BASERATE      21
#define MEASURE             21*64

#define T_BD0               0
#define T_BD1               1
#define T_RHYTHMSAW0        2
#define T_HH0L              3
#define T_HH0R              4
#define T_HH1L              5
#define T_HH1R              6
#define T_HH2L              7
#define T_HH2R              8
#define T_BASS0             9
#define T_LEAD0             10
#define T_LEAD1             11
#define T_PAD0L             12
#define T_PAD0R             13
#define T_FM0               14
#define T_FM1               15

/*
 *  length of karplus strong and DelaySyn buffers
 */

#define LENKSBUFF0          512
#define LENKSBUFF1          512
#define LENKSBUFF2          512
#define LENKSBUFF3          512
#define LENKSBUFF4          512
#define LENKSBUFF5          512
#define LENKSBUFF6          512
#define LENKSBUFF7          512

#define LENDSBUFF0          512
#define LENDSBUFF1          512
#define MAXCTRLTRACKS       8

/*
 *  track00
 */

#define LENTRACK00          128
#define NUMCTRLTRACK00      1

#define LENCTRLTRACK00_0    1
#define LENCTRLTRACK00_1    1
#define LENCTRLTRACK00_2    1
#define LENCTRLTRACK00_3    1
#define LENCTRLTRACK00_4    1
#define LENCTRLTRACK00_5    1
#define LENCTRLTRACK00_6    1
#define LENCTRLTRACK00_7    1

/*
 *  track01
 */

#define LENTRACK01          128
#define NUMCTRLTRACK01      1

#define LENCTRLTRACK01_0    1
#define LENCTRLTRACK01_1    1
#define LENCTRLTRACK01_2    1
#define LENCTRLTRACK01_3    1
#define LENCTRLTRACK01_4    1
#define LENCTRLTRACK01_5    1
#define LENCTRLTRACK01_6    1
#define LENCTRLTRACK01_7    1

/*
 *  track02
 */

#define LENTRACK02          128
#define NUMCTRLTRACK02      1

#define LENCTRLTRACK02_0    1
#define LENCTRLTRACK02_1    1
#define LENCTRLTRACK02_2    1
#define LENCTRLTRACK02_3    1
#define LENCTRLTRACK02_4    1
#define LENCTRLTRACK02_5    1
#define LENCTRLTRACK02_6    1
#define LENCTRLTRACK02_7    1

/*
 *  track03
 */

#define LENTRACK03          128
#define NUMCTRLTRACK03      1

#define LENCTRLTRACK03_0    1
#define LENCTRLTRACK03_1    1
#define LENCTRLTRACK03_2    1
#define LENCTRLTRACK03_3    1
#define LENCTRLTRACK03_4    1
#define LENCTRLTRACK03_5    1
#define LENCTRLTRACK03_6    1
#define LENCTRLTRACK03_7    1

/*
 *  track04
 */

#define LENTRACK04          128
#define NUMCTRLTRACK04      1

#define LENCTRLTRACK04_0    1
#define LENCTRLTRACK04_1    1
#define LENCTRLTRACK04_2    1
#define LENCTRLTRACK04_3    1
#define LENCTRLTRACK04_4    1
#define LENCTRLTRACK04_5    1
#define LENCTRLTRACK04_6    1
#define LENCTRLTRACK04_7    1

/*
 *  track05
 */

#define LENTRACK05          128
#define NUMCTRLTRACK05      1

#define LENCTRLTRACK05_0    1
#define LENCTRLTRACK05_1    1
#define LENCTRLTRACK05_2    1
#define LENCTRLTRACK05_3    1
#define LENCTRLTRACK05_4    1
#define LENCTRLTRACK05_5    1
#define LENCTRLTRACK05_6    1
#define LENCTRLTRACK05_7    1

/*
 *  track06
 */

#define LENTRACK06          128
#define NUMCTRLTRACK06      1

#define LENCTRLTRACK06_0    1
#define LENCTRLTRACK06_1    1
#define LENCTRLTRACK06_2    1
#define LENCTRLTRACK06_3    1
#define LENCTRLTRACK06_4    1
#define LENCTRLTRACK06_5    1
#define LENCTRLTRACK06_6    1
#define LENCTRLTRACK06_7    1

/*
 *  track07
 */

#define LENTRACK07          128
#define NUMCTRLTRACK07      1

#define LENCTRLTRACK07_0    1
#define LENCTRLTRACK07_1    1
#define LENCTRLTRACK07_2    1
#define LENCTRLTRACK07_3    1
#define LENCTRLTRACK07_4    1
#define LENCTRLTRACK07_5    1
#define LENCTRLTRACK07_6    1
#define LENCTRLTRACK07_7    1

/*
 *  track08
 */

#define LENTRACK08          128
#define NUMCTRLTRACK08      1

#define LENCTRLTRACK08_0    1
#define LENCTRLTRACK08_1    1
#define LENCTRLTRACK08_2    1
#define LENCTRLTRACK08_3    1
#define LENCTRLTRACK08_4    1
#define LENCTRLTRACK08_5    1
#define LENCTRLTRACK08_6    1
#define LENCTRLTRACK08_7    1

/*
 *  track09
 */

#define LENTRACK09          128
#define NUMCTRLTRACK09      1

#define LENCTRLTRACK09_0    1
#define LENCTRLTRACK09_1    1
#define LENCTRLTRACK09_2    1
#define LENCTRLTRACK09_3    1
#define LENCTRLTRACK09_4    1
#define LENCTRLTRACK09_5    1
#define LENCTRLTRACK09_6    1
#define LENCTRLTRACK09_7    1

/*
 *  track10
 */

#define LENTRACK10          128
#define NUMCTRLTRACK10      1

#define LENCTRLTRACK10_0    1
#define LENCTRLTRACK10_1    1
#define LENCTRLTRACK10_2    1
#define LENCTRLTRACK10_3    1
#define LENCTRLTRACK10_4    1
#define LENCTRLTRACK10_5    1
#define LENCTRLTRACK10_6    1
#define LENCTRLTRACK10_7    1

/*
 *  track11
 */

#define LENTRACK11          128
#define NUMCTRLTRACK11      1

#define LENCTRLTRACK11_0    1
#define LENCTRLTRACK11_1    1
#define LENCTRLTRACK11_2    1
#define LENCTRLTRACK11_3    1
#define LENCTRLTRACK11_4    1
#define LENCTRLTRACK11_5    1
#define LENCTRLTRACK11_6    1
#define LENCTRLTRACK11_7    1

/*
 *  track12
 */

#define LENTRACK12          128
#define NUMCTRLTRACK12      1

#define LENCTRLTRACK12_0    1
#define LENCTRLTRACK12_1    1
#define LENCTRLTRACK12_2    1
#define LENCTRLTRACK12_3    1
#define LENCTRLTRACK12_4    1
#define LENCTRLTRACK12_5    1
#define LENCTRLTRACK12_6    1
#define LENCTRLTRACK12_7    1

/*
 *  track13
 */

#define LENTRACK13          128
#define NUMCTRLTRACK13      1

#define LENCTRLTRACK13_0    1
#define LENCTRLTRACK13_1    1
#define LENCTRLTRACK13_2    1
#define LENCTRLTRACK13_3    1
#define LENCTRLTRACK13_4    1
#define LENCTRLTRACK13_5    1
#define LENCTRLTRACK13_6    1
#define LENCTRLTRACK13_7    1

/*
 *  track14
 */

#define LENTRACK14          128
#define NUMCTRLTRACK14      1

#define LENCTRLTRACK14_0    1
#define LENCTRLTRACK14_1    1
#define LENCTRLTRACK14_2    1
#define LENCTRLTRACK14_3    1
#define LENCTRLTRACK14_4    1
#define LENCTRLTRACK14_5    1
#define LENCTRLTRACK14_6    1
#define LENCTRLTRACK14_7    1

/*
 *  track15
 */

#define LENTRACK15          128
#define NUMCTRLTRACK15      1

#define LENCTRLTRACK15_0    1
#define LENCTRLTRACK15_1    1
#define LENCTRLTRACK15_2    1
#define LENCTRLTRACK15_3    1
#define LENCTRLTRACK15_4    1
#define LENCTRLTRACK15_5    1
#define LENCTRLTRACK15_6    1
#define LENCTRLTRACK15_7    1

/*
 *  track16
 */

#define LENTRACK16          128
#define NUMCTRLTRACK16      1

#define LENCTRLTRACK16_0    1
#define LENCTRLTRACK16_1    1
#define LENCTRLTRACK16_2    1
#define LENCTRLTRACK16_3    1
#define LENCTRLTRACK16_4    1
#define LENCTRLTRACK16_5    1
#define LENCTRLTRACK16_6    1
#define LENCTRLTRACK16_7    1

/*
 *  track17
 */

#define LENTRACK17          128
#define NUMCTRLTRACK17      1

#define LENCTRLTRACK17_0    1
#define LENCTRLTRACK17_1    1
#define LENCTRLTRACK17_2    1
#define LENCTRLTRACK17_3    1
#define LENCTRLTRACK17_4    1
#define LENCTRLTRACK17_5    1
#define LENCTRLTRACK17_6    1
#define LENCTRLTRACK17_7    1

/*
 *  track18
 */

#define LENTRACK18          128
#define NUMCTRLTRACK18      1

#define LENCTRLTRACK18_0    1
#define LENCTRLTRACK18_1    1
#define LENCTRLTRACK18_2    1
#define LENCTRLTRACK18_3    1
#define LENCTRLTRACK18_4    1
#define LENCTRLTRACK18_5    1
#define LENCTRLTRACK18_6    1
#define LENCTRLTRACK18_7    1

/*
 *  track19
 */

#define LENTRACK19          128
#define NUMCTRLTRACK19      1

#define LENCTRLTRACK19_0    1
#define LENCTRLTRACK19_1    1
#define LENCTRLTRACK19_2    1
#define LENCTRLTRACK19_3    1
#define LENCTRLTRACK19_4    1
#define LENCTRLTRACK19_5    1
#define LENCTRLTRACK19_6    1
#define LENCTRLTRACK19_7    1

/*
 *  track20
 */

#define LENTRACK20          1
#define NUMCTRLTRACK20      1

#define LENCTRLTRACK20_0    1
#define LENCTRLTRACK20_1    1
#define LENCTRLTRACK20_2    1
#define LENCTRLTRACK20_3    1
#define LENCTRLTRACK20_4    1
#define LENCTRLTRACK20_5    1
#define LENCTRLTRACK20_6    1
#define LENCTRLTRACK20_7    1

/*
 *  track21
 */

#define LENTRACK21          1
#define NUMCTRLTRACK21      1

#define LENCTRLTRACK21_0    1
#define LENCTRLTRACK21_1    1
#define LENCTRLTRACK21_2    1
#define LENCTRLTRACK21_3    1
#define LENCTRLTRACK21_4    1
#define LENCTRLTRACK21_5    1
#define LENCTRLTRACK21_6    1
#define LENCTRLTRACK21_7    1

/*
 *  track22
 */

#define LENTRACK22          1
#define NUMCTRLTRACK22      1

#define LENCTRLTRACK22_0    1
#define LENCTRLTRACK22_1    1
#define LENCTRLTRACK22_2    1
#define LENCTRLTRACK22_3    1
#define LENCTRLTRACK22_4    1
#define LENCTRLTRACK22_5    1
#define LENCTRLTRACK22_6    1
#define LENCTRLTRACK22_7    1

/*
 *  track23
 */

#define LENTRACK23          1
#define NUMCTRLTRACK23      1

#define LENCTRLTRACK23_0    1
#define LENCTRLTRACK23_1    1
#define LENCTRLTRACK23_2    1
#define LENCTRLTRACK23_3    1
#define LENCTRLTRACK23_4    1
#define LENCTRLTRACK23_5    1
#define LENCTRLTRACK23_6    1
#define LENCTRLTRACK23_7    1

/*
 *  track24
 */

#define LENTRACK24          1
#define NUMCTRLTRACK24      1

#define LENCTRLTRACK24_0    1
#define LENCTRLTRACK24_1    1
#define LENCTRLTRACK24_2    1
#define LENCTRLTRACK24_3    1
#define LENCTRLTRACK24_4    1
#define LENCTRLTRACK24_5    1
#define LENCTRLTRACK24_6    1
#define LENCTRLTRACK24_7    1

/*
 *  track25
 */

#define LENTRACK25          1
#define NUMCTRLTRACK25      1

#define LENCTRLTRACK25_0    1
#define LENCTRLTRACK25_1    1
#define LENCTRLTRACK25_2    1
#define LENCTRLTRACK25_3    1
#define LENCTRLTRACK25_4    1
#define LENCTRLTRACK25_5    1
#define LENCTRLTRACK25_6    1
#define LENCTRLTRACK25_7    1

/*
 *  track26
 */

#define LENTRACK26          1
#define NUMCTRLTRACK26      1

#define LENCTRLTRACK26_0    1
#define LENCTRLTRACK26_1    1
#define LENCTRLTRACK26_2    1
#define LENCTRLTRACK26_3    1
#define LENCTRLTRACK26_4    1
#define LENCTRLTRACK26_5    1
#define LENCTRLTRACK26_6    1
#define LENCTRLTRACK26_7    1

/*
 *  track27
 */

#define LENTRACK27          1
#define NUMCTRLTRACK27      1

#define LENCTRLTRACK27_0    1
#define LENCTRLTRACK27_1    1
#define LENCTRLTRACK27_2    1
#define LENCTRLTRACK27_3    1
#define LENCTRLTRACK27_4    1
#define LENCTRLTRACK27_5    1
#define LENCTRLTRACK27_6    1
#define LENCTRLTRACK27_7    1

/*
 *  track28
 */

#define LENTRACK28          1
#define NUMCTRLTRACK28      1

#define LENCTRLTRACK28_0    1
#define LENCTRLTRACK28_1    1
#define LENCTRLTRACK28_2    1
#define LENCTRLTRACK28_3    1
#define LENCTRLTRACK28_4    1
#define LENCTRLTRACK28_5    1
#define LENCTRLTRACK28_6    1
#define LENCTRLTRACK28_7    1

/*
 *  track29
 */

#define LENTRACK29          1
#define NUMCTRLTRACK29      1

#define LENCTRLTRACK29_0    1
#define LENCTRLTRACK29_1    1
#define LENCTRLTRACK29_2    1
#define LENCTRLTRACK29_3    1
#define LENCTRLTRACK29_4    1
#define LENCTRLTRACK29_5    1
#define LENCTRLTRACK29_6    1
#define LENCTRLTRACK29_7    1

/*
 *  track30
 */

#define LENTRACK30          1
#define NUMCTRLTRACK30      1

#define LENCTRLTRACK30_0    1
#define LENCTRLTRACK30_1    1
#define LENCTRLTRACK30_2    1
#define LENCTRLTRACK30_3    1
#define LENCTRLTRACK30_4    1
#define LENCTRLTRACK30_5    1
#define LENCTRLTRACK30_6    1
#define LENCTRLTRACK30_7    1

/*
 *  track31
 */

#define LENTRACK31          1
#define NUMCTRLTRACK31      1

#define LENCTRLTRACK31_0    1
#define LENCTRLTRACK31_1    1
#define LENCTRLTRACK31_2    1
#define LENCTRLTRACK31_3    1
#define LENCTRLTRACK31_4    1
#define LENCTRLTRACK31_5    1
#define LENCTRLTRACK31_6    1
#define LENCTRLTRACK31_7    1

