/******************************************************************************
*
*  GenFXIni.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  initialization of all generators, fx, envelopes and sequencer.  called at
*  the beginning of the song before audio output.  extensive post processing
*  and analysis occurs on this function, so follow the guidelines on usage as
*  outlined in the documentation.
*
******************************************************************************/

.MODULE                                     modGenFXIni_00;

/*
 *  include files for all functions
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "songnow.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitGMParams_00;
.ENTRY      EndInitGMParams_00;

InitGMParams_00:
    /* insert generators and fx initializations here */


    SETPTR(a_WTGen2);
    INIT_WTGEN2(0, ^a_WTSine);
    
    INIT_WTGEN2(400, ^a_WTSaw);
    INIT_WTGEN2(600, ^a_WTSaw);
    
    INIT_WTGEN2(0, ^a_WTSaw);
    INIT_WTGEN2(0, ^a_WTTri);
    
    INIT_WTGEN2(0, ^a_WTSaw);
    INIT_WTGEN2(0, ^a_WTTri);
    
    SETPTR(a_MultiGen);
    DM(I2, M1) = 2;
    DM(I2, M1) = ^WTGen2;
    DM(I2, M1) = 0x4000;
    DM(I2, M1) = ^WTGen2;
    DM(I2, M1) = 0x4000;
    
    DM(I2, M1) = 2;
    DM(I2, M1) = ^WTGen2;
    DM(I2, M1) = 0x4000;
    DM(I2, M1) = ^WTGen2;
    DM(I2, M1) = 0x4000;
    
    SETPTR(a_PrevCurrFiltFX);
    INIT_PREVCURRFILTFX(PREVCURRFILTFX_1, -5000);
    INIT_PREVCURRFILTFX(PREVCURRFILTFX_1, -3000);
    
    SETPTR(a_KSGen);
    INIT_KSGEN(0x0001, ^a_KSBuff0, 0x1ff, 0x0000, 0x3c00);
    INIT_KSGEN(0x0001, ^a_KSBuff1, 0x1ff, 0x0000, 0x3c00);
    
    INIT_KSGEN(0x0000, ^a_KSBuff2, 0x4f, 0x0000, 0x4e00);
    INIT_KSGEN(0x0000, ^a_KSBuff3, 0x4f, 0x0000, 0x4e00);
    
    INIT_KSGEN(0x0000, ^a_KSBuff4, 0xff, 0x0000, 0x5c00);
    INIT_KSGEN(0x0000, ^a_KSBuff5, 0xff, 0x0000, 0x5c00);
    
    SETPTR(a_SVFFX);
    INIT_SVFFX(0x7fff, 0x1000, 0x1000, SVFFX_BANDOUT);
    INIT_SVFFX(0x7fff, 0x1000, 0x1000, SVFFX_BANDOUT);
    INIT_SVFFX(0x7fff, 0x1000, 0x1000, SVFFX_BANDOUT);
    INIT_SVFFX(0x7fff, 0x1000, 0x1000, SVFFX_BANDOUT);
    
    SETPTR(a_LFO);
    INIT_LFO(24*1, 128*16, ^a_WTSine, 0x2000, 0x0000, ^a_KSGen+(4*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    INIT_LFO(24*1, 128*16, ^a_WTSine, 0x2000, 0x0000, ^a_KSGen+(5*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    
    INIT_LFO(24*6, 512, ^a_WTSine, 0x180, 0, ^a_WTGen2+(3*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO(24*8, 512, ^a_WTSine, 0x180, 0, ^a_WTGen2+(4*WTGEN2_VARS)+WTGEN2_FREQ);
    
    INIT_LFO(24*8, 512, ^a_WTSine, 0x200, 0, ^a_WTGen2+(5*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO(24*12, 512, ^a_WTSine, 0x200, 0, ^a_WTGen2+(6*WTGEN2_VARS)+WTGEN2_FREQ);
    
    INIT_LFO(24*32, 512, ^a_RandLUT, 0, 60, ^a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_MODENV_SCALAR);
    INIT_LFO(24*32, 512, ^a_RandLUT, 0, 240, ^a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_BASECARR);
    
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(0*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(0*SVFFX_VARS)+SVFFX_K4);
    
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(1*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(1*SVFFX_VARS)+SVFFX_K4);
    
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(2*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(2*SVFFX_VARS)+SVFFX_K4);
    
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(3*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO(24*4, 128*32, ^a_WTSine, 0x0000, 0x1000, ^a_SVFFX+(3*SVFFX_VARS)+SVFFX_K4);

    SETPTR(a_MemEnv3);
    INIT_MEMENV3(^a_LFO+(0*LFO_VARS)+LFO_MOD, 0x0000, 0x2000, 24*16, 0x1000, 1);
    INIT_MEMENV3(^a_LFO+(1*LFO_VARS)+LFO_MOD, 0x0000, 0x2000, 24*16, 0x1000, 1);
    
    INIT_MEMENV3(^a_GenSHFX+(0*GENSHFX_VARS)+GENSHFX_HOLDPER, 0, 8, 12+24, 6, 6);
    INIT_MEMENV3(^a_GenSHFX+(1*GENSHFX_VARS)+GENSHFX_HOLDPER, 0, 8, 12+24, 6, 6);
    
    INIT_MEMENV3(^a_LFO+(8*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(9*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(10*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(11*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    
    INIT_MEMENV3(^a_LFO+(12*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(13*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(14*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    INIT_MEMENV3(^a_LFO+(15*LFO_VARS)+LFO_MOD, 0x0000, 0x0000, 24*64*16, 0x0000, 1);
    
    !INIT_MEMENV3(^a_ExpDecayEnv+(5*EXPDECAYENV_VARS)+EXPDECAYENV_DECRATE, 0x7fb8, 0x7fb8, 1, 0x7f80, 24);
    !INIT_MEMENV3(^a_ExpDecayEnv+(6*EXPDECAYENV_VARS)+EXPDECAYENV_DECRATE, 0x7fb8, 0x7fb8, 1, 0x7f80, 24);
    

    SETPTR(a_FM2Op0Gen);
    INIT_FM2OP0GEN(55, ^a_WTSine, 0, 4, 0x7fff, 0x0020, 0x0000, 0, 0x0000, 165, 330, ^a_WTSine);
    INIT_FM2OP0GEN(30, ^a_WTSine, 0, 4, 0x7fff, 0x0020, 0x0000, 0, 0x0000, 75, 440, ^a_WTSine);
    
    INIT_FM2OP0GEN(120, ^a_WTSq, 0, 128, 0x0020, 0x0030, 0x0000, 0, 0x0000, 350, 0, ^a_WTSine);
    INIT_FM2OP0GEN(90, ^a_WTSq, 0, 128, 0x0020, 0x0030, 0x0000, 0, 0x0000, 525, 0, ^a_WTSine);
    
    INIT_FM2OP0GEN(30, ^a_WTSaw, 0, 128, 0x7fff, 0x0040, 0x0000, 0, 0x0000, 60, 240, ^a_WTTri);

    SETPTR(a_GenSHFX);
    INIT_GENSHFX(10);
    INIT_GENSHFX(10);
    INIT_GENSHFX(12);
    INIT_GENSHFX(12);
    
    SETPTR(a_ExpDecayEnv);
    INIT_EXPDECAYENV(4, 0x7ff0, 0x4000);
    INIT_EXPDECAYENV(32, 0x7ff0, 0x3000);
    INIT_EXPDECAYENV(32, 0x7ff0, 0x5000);
    INIT_EXPDECAYENV(32, 0x7ff0, 0x3000);
    INIT_EXPDECAYENV(32, 0x7ff0, 0x5000);
    
    INIT_EXPDECAYENV(16, 0x7fa8, 0x4800);
    INIT_EXPDECAYENV(16, 0x7fa8, 0x3800);
    
    INIT_EXPDECAYENV(14, 0x7fd0, 0x4000);
    
    INIT_EXPDECAYENV(6, 0x7ff0, 0x3000);
    INIT_EXPDECAYENV(6, 0x7ff0, 0x5000);

    SETPTR(a_ADSRPanEnv);
    INIT_ADSRPANENV(128, 0x0040, 0x7fff, 0x0000, 0, 0x0000, 0x2000);
    INIT_ADSRPANENV(128, 0x0040, 0x7fff, 0x0000, 0, 0x0000, 0x6000);
    
    INIT_ADSRPANENV(128, 0x7fff, 0x0010, 0x0018, 0, 0x0000, 0x3000);
    INIT_ADSRPANENV(128, 0x7fff, 0x0010, 0x0018, 0, 0x0000, 0x5000);
        
    INIT_ADSRPANENV(128, 0x000c, 0x000c, 0x0000, 0, 0x0000, 0x2000);
    INIT_ADSRPANENV(128, 0x000c, 0x000c, 0x0000, 0, 0x0000, 0x6000);

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ,
                 400, 50,
                 0x1000, 0x0c00, 0x0400,
                 1, 0x6800,
                 1, 0x7c00,
                 1, 0x7f00,
                 1, 0x7fc0);

    AR = ^a_LeadNotes0;
    DM(p_LeadNotes0) = AR;

    I2 = ^a_LeadNotes0;
    DM(I2, M1) = 440;
    DM(I2, M1) = 494;
    DM(I2, M1) = 523;
    DM(I2, M1) = 587;
    
    DM(v_IncFMFreq) = M0;
    AR = 400;
    DM(v_CurrFreqFM0) = AR;
    DM(v_CurrFreqFM1) = AR;
    
    AR = 18;
    DM(v_CurrGenKSSH) = AR;

/* blaTRACK(CLEAR, 0, 0,  a------- a------- a-----a- a-----a-  a------- a------- a-----a- --a---a-,
            CLEAR, 0, 1,  -------- b------- c-----c- b-------  -------- b------- c-----ch b---c-hh,
            CLEAR, 0, 2,  -------- b------- c-----c- b-------  -------- b------- c-----ch b---c-hh,
            CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            CLEAR, 0, 5,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            CLEAR, 0, 6,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            CLEAR, 0, 7,  g-g---g- g-g----- g---g--- --g-g-g-  --g---g- g-g----- g---g--- --g-g-,
            CLEAR, 0, 8,  g-g---g- g-g----- g---g--- --g-g-g-  --g---g- g-g----- g---g--- --g-,
            CLEAR, 0, 9,  -------- i------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 10, -------- i------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 11, j---l--- k---l--- k---l-j- j---l-k-  j---l--- k---l--- j---l--- k-j-l-j-,
            CLEAR, 0, 12, m-----m- ----m--- --m----- --------  m-----m- -------- --m----- m-------,
            CLEAR, 0, 13, ----m--- ------m- ------m- ----m---  ----m--- ------m- ------m- --------,
            CLEAR, 0, 14, -------- -------- n------- --------  -------- -------- -------- --------,
            CLEAR, 0, 15, -------- -------- -------- --------  o------- -------- -------- --------,
            a, 100, 0x3000,
            b, 100, 0x3000,
            c, 100, 0x1000,
            d, 100, 0x1000,
            e, 100, 0x0800,
            f, 100, 0x0c00,
            g, 100, 0x0a00,
            h, 100, 0x0800,
            i, 100, 0x0a00,
            j, 100, 0x0c00,
            k, 100, 0x0600,
            l, 100, 0x0300,
            m, 100, 0x0300,
            n, 100, 0x0a00,
            o, 100, 0x0a00,
            END); */

/*
 *  init sequencer array
 *  
 *  param0:  tic period
 *  param1:  swing period (num tics between slow/fast transition)
 *  param2:  swing amount
 *  param3:  sequencer length
 *  param4:  ptr to TrigInit function
 *  param5:  envelope type
 *  param6:  aux function ptr
 *
 */

    SETPTR(a_Seq);
    modify(I2, M1);                         /* numtrax set by CalcSeq2Tracks */
    INIT_SEQ(24, 16, 1, 64, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 64, ADSRENV);
    INIT_SEQ(24, 16, 1, 64, ADSRENV);
    INIT_SEQ(24, 16, 1, 48, EXPDECAYENV);
    
    INIT_SEQ(24, 16, 1, 48, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 128, ADSRENV);
    INIT_SEQ(24, 16, 1, 128, ADSRENV);
    INIT_SEQ(24, 16, 1, 64, EXPDECAYENV);
    
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    INIT_SEQ(24, 16, 1, 128, EXPDECAYENV);
    INIT_SEQ(96, 16, 1, 64, ADSRENV);
    INIT_SEQ(96, 16, 1, 64, ADSRENV);


    /* must be called after Seq2 init to set env and num tracks */
    call Seq2PostProc;
    
    /* set v_TicsPerMeasure to length of first sequence */
    SEQ_SET_MEASURE(0);

    AR = ^InitGMParams_00;
    AX0 = ^EndInitGMParams_00;
    call FillGenFXPtrInits;  
  
    /* init ^Env and set length of array of ptrs used in GenFXPtrInits */
    call GenFXIniPostProc;                  /* do not remove! */
    
EndInitGMParams_00:
    rts;

.ENDMOD;
