/******************************************************************************
*
*  SongCTRL.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  function for modifying parameters on a measure by measure basis.  execution
*  rate determined by v_TicsPerMeasure (set in GenFXIni.dsp by macros).
*
******************************************************************************/

.MODULE                                     modSongCTRL_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "songnow.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      SongCTRL_00;
.ENTRY      Measure_JT;
.ENTRY      EndMeasure_JT;

SongCTRL_00:
    AR = DM(v_TicCNTR);
    AR = AR + 1;
    DM(v_TicCNTR) = AR;
    AY0 = DM(v_TicsPerMeasure);
    AR = AR - AY0;
    if LT rts;
    
    DM(v_TicCNTR) = M0;

/*
 *  note!  this initialization used to be in InitFunc.dsp.  however, to make
 *  this function work with multiple tracks in a single executable, Measure_JT
 *  and EndMeasure_JT would need to be abstracted and inited in SongPtrs.dsp.
 *  to try and simplify and reduce the number of initializations that occur in
 *  that function, these variables were made local and it is continually
 *  re-inited here.  note that this code runs in the krate loop so performance
 *  is not a concern.
 */

SetMeasuresPerSong:
    AX0 = ^EndMeasure_JT;
    AY0 = ^Measure_JT;
    AR = AX0 - AY0;
    DM(v_MeasuresPerSong) = AR;
    
    I5 = ^Measure_JT;
    M5 = DM(v_CurrMeasure);
    modify(I5, M5);
    jump (I5);
    
/*
 *  insert JT of operations to perform at the start of every new measure
 */
    
Measure_JT:
    jump Measure0;
    jump DoNothing;
    jump Measure2;
    jump DoNothing;
    
    jump Measure4;
    jump DoNothing;
    jump Measure6;
    jump DoNothing;
    
    jump Measure8;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure12;
    jump DoNothing;
    jump Measure14;
    jump DoNothing;
    
    jump Measure16;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure20;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;

    jump Measure24;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure28;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure32;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure40;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure44;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure48;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure56;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure60;
    jump DoNothing;
    jump Measure62;
    jump DoNothing;
    
    jump Measure64;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
        
    jump Measure72;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
        
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure80;
    jump DoNothing;
    jump Measure82;
    jump DoNothing;
    
    jump Measure84;
    jump DoNothing;
    jump Measure86;
    jump DoNothing;
    
    jump Measure88;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure92;
    
EndMeasure_JT:

/*
 *  insert all multimeasure operations - for parameters that should be modified
 *  over multiple measures
 */

MultiMeasureCheck:

EndSongCheck:
    AR = DM(v_CurrMeasure);
    AR = AR + 1;
    DM(v_CurrMeasure) = AR;
    AY0 = DM(v_MeasuresPerSong);
    AR = AR - AY0;
    if LT rts;

/*
 *  SongCTRL list is complete.  jumping to EndSong will start the next song
 *  in a multisong environment.  resetting CurrMeasure starts the Measure_JT
 *  loop over again, causing the same song to play indefinitely
 */
    
    !jump EndSong;
    
    DM(v_CurrMeasure) = M0;
    rts;

MultiMeasureMod:
    AR = DM(v_CurrMeasure);   
    AY0 = SR0;       
    NONE = AR - AY0;         
    if LT jump EndMMM;
    AY0 = SR1;
    NONE = AR - AY0;
    if GT jump EndMMM;
    call (I5);
EndMMM:
    rts;

Measure0:
    
/* SETTRACK(CLEAR, 0, 0,  a------- a------- a-----a- ----a-a-  a------- a------- a-----a- --a---a-,
            a, 100, 0x3000,
            END); */

/* SETTRACK(CLEAR, 0, 9,  -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            i, 100, 0x0a00,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x7fff, MEASURE*16);
    SET_VOLENV(10, 0x0000, 0x7fff, MEASURE*16);

    jump MultiMeasureCheck;

Measure2:

/* SETTRACK(CLEAR, 0, 11, j---l--- k---l--- k---l-j- j---l-k-  j---l--- k---l--- j---l--- k-j-l-j-,
            j, 100, 0x1000,
            k, 100, 0x0800,
            l, 100, 0x0400,
            END); */
            
    SET_VOLENV(11, 0x6000, 0x6000, 1);
    

    jump MultiMeasureCheck;

Measure4:
/* SETTRACK(CLEAR, 0, 3,  ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-   ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-,
            CLEAR, 0, 4,  ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-   ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-,
            d, 100, 0x1400,
            e, 100, 0x0a00,
            END); */
    
    jump MultiMeasureCheck;

Measure6:
/* SETTRACK(CLEAR, 0, 3,  -------- -------- -------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 4,  -------- -------- -------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            END); */

    AR = 4;
    DM(a_LFO+(6*LFO_VARS)+LFO_MOD) = AR;
    AR = 16;
    DM(a_LFO+(7*LFO_VARS)+LFO_MOD) = AR;
    
    jump MultiMeasureCheck;

Measure8:
/* SETTRACK(CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            END); */

    SET_VOLENV(3, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(4, 0x0000, 0x7fff, MEASURE*4);

    jump MultiMeasureCheck;

Measure12:

/* SETTRACK(CLEAR, 0, 1,  -------- b------- -------- b-------  -------- b-----c- -------- b-------   -------- b------- -------- b-------  -------- b-----d- --c----- b-------,
            CLEAR, 0, 2,  -------- b------- -------- b-------  -------- b-----c- -------- b-------   -------- b------- -------- b-------  -------- b-----d- --c----- b-------,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800,
            h, 100, 0x0600,
            END); */

    jump MultiMeasureCheck;

Measure14:

/* SETTRACK(CLEAR, 0, 1,  -------- b---d--- c-----c- b-------  -------- b-----c- ------ch b---c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            CLEAR, 0, 2,  -------- b---d--- c-----c- b-------  -------- b-----c- ------ch b---c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800,
            h, 100, 0x0600,
            END); */

    jump MultiMeasureCheck;

Measure16:

/* SETTRACK(CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-f-d-f- f-e-d-f- f-f-dee- f-f-d-f-  f-f-d-f- f-f-d-f- f-f-d-f- f-f-d-e-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-f-d-f- f-e-d-f- f-f-dee- f-f-d-f-  f-f-d-f- f-f-d-f- f-f-d-f- f-f-d-e-,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            f, 100, 0x0200,
            END); */

    SET_VOLENV(11, 0x6000, 0x7fff, MEASURE*4);
    
    jump MultiMeasureCheck;

Measure20:

/* SETTRACK(CLEAR, 0, 1,  i-i-i-i- b-i-d-i- c-i-i-c- b-i-i-i-  i-i-i-i- b-i-i-c- i-i-i-ch b-i-c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            CLEAR, 0, 2,  i-i-i-i- b-i-d-i- c-i-i-c- b-i-i-i-  i-i-i-i- b-i-i-c- i-i-i-ch b-i-c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800
            h, 100, 0x0600,
            i, 100, 0x0200,
            END); */

    jump MultiMeasureCheck;

Measure24:

/* SETTRACK(CLEAR, 0, 1,  i-ijiji- b-ijv-i- c-iji-c- bkiji-i-  i-ijiji- b-iji-c- ikiji-ch b-i-c-hh   ----v--- b------- c-----c- b-------  -------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 2,  i-ijiji- b-ijv-i- c-iji-c- bkiji-i-  i-ijiji- b-iji-c- ikiji-ch b-i-c-hh   ----v--- b------- c-----c- b-------  -------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-fgdgf- f-egdgf- f-fgdee- f-fgdgf-  f-fgdgf- f-fgdgf- f-fgdgf- f-fgdge-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-fgdgf- f-egdgf- f-fgdee- f-fgdgf-  f-fgdgf- f-fgdgf- f-fgdgf- f-fgdge-,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            v, 100, 0x0800
            h, 100, 0x0600,
            i, 100, 0x0200,
            j, 70,  0x0150,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            f, 100, 0x0200,
            g, 70,  0x0100,
            k, 0,   0x0000,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x0000, 1);
    SET_VOLENV(10, 0x0000, 0x0000, 1);

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ,
                 430, 30,
                 0x0e00, 0x0c00, 0x0400,
                 1, 0x6400,
                 1, 0x7c00,
                 1, 0x7f20,
                 1, 0x7fe0);

    SET_VOLENV(0, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure28:    

/* SETTRACK(CLEAR, 0, 12, m------- -------- m------- --------  m------- -------- -------- m-------   m------- -------- m------- --------  m------- -------- ----m--- --n-m---,
            CLEAR, 0, 13, m------- -------- -------- m-------  m------- -------- m------- --------   m------- -------- -------- m-------  m------- -------- m------- n---m---,
            m, 100, 0x0300,
            n, 100, 0x0180,
            END); */

    SET_VOLENV(12, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(13, 0x0000, 0x7fff, MEASURE*4);

    jump MultiMeasureCheck;

Measure32:
/* SETTRACK(CLEAR, 0, 0,  a------- -------- a------- ------b-  -------- a------- ----b--- a-------,
            CLEAR, 0, 11, -------- k------- -------- k-------  ----l--- -------- j------- ----l---,
            CLEAR, 0, 14, -------- -------- n------- --------  -------- -------- -------- --------,
            CLEAR, 0, 15, -------- -------- -------- --------  o------- -------- -------- --------,
            a, 100, 0x1000,
            b, 100, 0x0800,
            j, 100, 0x1000,
            k, 100, 0x0c80,
            l, 100, 0x0700,
            n, 100, 0x0a00,
            o, 100, 0x0a00,
            END); */

    SET_VOLENV(0, 0x7fff, 0x7fff, 1);
            
    SET_VOLENV(14, 0x0000, 0x7fff, MEASURE*16);
    SET_VOLENV(15, 0x0000, 0x7fff, MEASURE*16);


/* SETTRACK(CLEAR, 0, 9,  -------- -------- i------- j-------  -------- -------- i------- ----j---   -------- -------- i------- --------  j------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- j-------  -------- -------- i------- ----j---   -------- -------- i------- --------  j------- -------- -------- --------,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(10, 0x0000, 0x7fff, MEASURE*4);    
   
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure40:

/* SETTRACK(CLEAR, 0, 0,  ----a--- a------- ----a--- a-----b-  a------- --a---a- ----b--- a---b---,
            CLEAR, 0, 11, j---l--- --k-l--- k-----j- ----l---  j---l-m- k---l--- j------- k---l-m-,
            a, 100, 0x3000,
            b, 75,  0x2000,
            j, 100, 0x1600,
            k, 100, 0x0f00,
            l, 75,  0x0a00,
            m, 50,  0x0600,
            END); */

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ,
                 400, 50,
                 0x1000, 0x0c00, 0x0400,
                 1, 0x6800,
                 1, 0x7c00,
                 1, 0x7f00,
                 1, 0x7fc0);            

    SET_VOLENV(0, 0x0000, 0x7fff, MEASURE*8);
    SET_VOLENV(11, 0x0000, 0x7fff, MEASURE*8);
    
    AX0 = 24*8;
    DM(a_LFO+(6*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(7*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure44:
/* SETTRACK(CLEAR, 0, 12, m---o--- ----o--- m-----o- -p------  m---o--- pp------ -------- m---o---   m---o--- --pp---- m-----pp --------  m-o----- ------pp ----m--- --n-m---,
            CLEAR, 0, 13, m-----o- --o----- ----o--- m-p-o---  m-----o- pp------ m---o--- --------   m------- o-pp---- -------- m---o---  m-----o- ----o--- m------- n---m---,
            m, 100, 0x0400,
            n, 100, 0x0300,
            o, 100, 0x0280,
            p, 100, 0x0200,
            END); */

    SET_VOLENV(12, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(13, 0x0000, 0x7fff, MEASURE*4);
    
    DM(v_IncFMFreq) = M1;

    jump MultiMeasureCheck;
    
Measure48:
/* SETTRACK(CLEAR, 0, 5,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            CLEAR, 0, 6,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            f, 100, 0x0c00,
            END); */


/* SETTRACK(CLEAR, 0, 9,  -------- -------- i------- j-------  i------- ----i--- -------- ----j---   -------- i------- j------- --------  i------- ----j--- i------- ----j---,
            CLEAR, 0, 10, -------- -------- i------- j-------  i------- ----i--- -------- ----j---   -------- i------- j------- --------  i------- ----j--- i------- ----j---,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    AX0 = 24*8;
    DM(a_LFO+(4*LFO_VARS)+LFO_HOLDPER) = AX0;
    AX0 = 24*6;
    DM(a_LFO+(5*LFO_VARS)+LFO_HOLDPER) = AX0;

    AX0 = 128*32;
    DM(a_LFO+(8*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(12*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_FREQ) = AX0;
    
    AR = 0x0c00;
    DM(a_MemEnv3+(4*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(4*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(5*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(5*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(6*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(6*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(7*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(7*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(8*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(8*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(9*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(9*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(10*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(10*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(11*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(11*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    RESET_MEMENV3(4);
    RESET_MEMENV3(5);
    RESET_MEMENV3(6);
    RESET_MEMENV3(7);
    
    RESET_MEMENV3(8);
    RESET_MEMENV3(9);
    RESET_MEMENV3(10);
    RESET_MEMENV3(11);

    jump MultiMeasureCheck;

Measure56:
/* SETTRACK(CLEAR, 0, 7,  g------- g---g--- g------- ----g---  g------- g------- g---g--- ----g---,
            CLEAR, 0, 8,  g------- g---g--- g------- ----g---  g------- g-------,
            g, 100, 0x0c00,
            END); */

    SET_VOLENV(0, 0x0000, 0x0000, 1);
    SET_VOLENV(1, 0x0000, 0x0000, 1);
    SET_VOLENV(2, 0x0000, 0x0000, 1);
    SET_VOLENV(3, 0x0000, 0x0000, 1);
    SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(11, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);

    SET_VOLENV(7, 0x0000, 0x3fff, MEASURE*4);
    SET_VOLENV(8, 0x0000, 0x3fff, MEASURE*4);
    
    jump MultiMeasureCheck;

Measure60:
/* SETTRACK(CLEAR, 0, 7,  g-----h- ----g--- ----h--- ----g---  g---g--- -h------ g-----h- ----g---,
            CLEAR, 0, 8,  g-----h- ----g--- ----h--- ----g---  g---g--- -h------,
            g, 100, 0x0c00,
            h, 100, 0x0800,
            END); */

    SET_VOLENV(7, 0x6000, 0x6000, 1);
    SET_VOLENV(8, 0x6000, 0x6000, 1);
    
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;


Measure62:
/* SETTRACK(CLEAR, 0, 7,  g-----h- ----g--- i---h--- ----g---  g---g--- -h------ g-----h- i---g---,
            CLEAR, 0, 8,  g-----h- ----g--- i---h--- ----g---  g---g--- -h------,
            g, 100, 0x0c00,
            h, 100, 0x0800,
            i, 100, 0x0500,
            j, 100, 0x0300,
            END); */

    SET_VOLENV(7, 0x6000, 0x6000, 1);
    SET_VOLENV(8, 0x6000, 0x6000, 1);
    
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(9,  0x4000, 0x0000, MEASURE*2);
    SET_VOLENV(10, 0x4000, 0x0000, MEASURE*2);
    SET_VOLENV(14, 0x0000, 0x0000, 1);
    SET_VOLENV(15, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure64:
/* SETTRACK(CLEAR, 0, 0,  ----b--- a---b--- ----a-b- ------b-  a-b----- --b---a- ----b--- a-----b-,
            CLEAR, 0, 11, j-k---k- j---l--- j-k---j- j---l---  j---l-mm ----l--- j---j--- j---lmmm,
            a, 100, 0x4000,
            b, 100, 0x2000,
            j, 100, 0x1600,
            k, 100, 0x0f00,
            l, 100, 0x0a00,
            m, 100, 0x0700,
            END); */


/* SETTRACK(CLEAR, 0, 9,  -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            i, 100, 0x0c00,
            END); */
            
    SET_VOLENV(9,  0x7fff, 0x7fff, 1);
    SET_VOLENV(10, 0x7fff, 0x7fff, 1);

    SET_VOLENV(0, 0x7fff, 0x7fff, 1);
    SET_VOLENV(1, 0x7fff, 0x7fff, 1);
    SET_VOLENV(2, 0x7fff, 0x7fff, 1);
    SET_VOLENV(3, 0x7fff, 0x7fff, 1);
    SET_VOLENV(4, 0x7fff, 0x7fff, 1);
    SET_VOLENV(5, 0x7fff, 0x7fff, 1);
    SET_VOLENV(6, 0x7fff, 0x7fff, 1);
    SET_VOLENV(7, 0x7fff, 0x7fff, 1);
    SET_VOLENV(8, 0x7fff, 0x7fff, 1);
    SET_VOLENV(9, 0x7fff, 0x7fff, 1);
    SET_VOLENV(10, 0x7fff, 0x7fff, 1);
    SET_VOLENV(11, 0x7fff, 0x7fff, 1);
    SET_VOLENV(12, 0x7fff, 0x7fff, 1);
    SET_VOLENV(13, 0x7fff, 0x7fff, 1);
    SET_VOLENV(14, 0x7fff, 0x7fff, 1);
    SET_VOLENV(15, 0x7fff, 0x7fff, 1);
    
    AX0 = 128*64;
    DM(a_LFO+(8*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(12*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_FREQ) = AX0;

    jump MultiMeasureCheck;

Measure72:

    !SET_VOLENV(1, 0x0000, 0x0000, 1);
    !SET_VOLENV(2, 0x0000, 0x0000, 1);
    !SET_VOLENV(3, 0x0000, 0x0000, 1);
    !SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);


/* SETTRACK(CLEAR, 0, 1,  --v----- b------- c-----c- b-----v-  --v----- b------- --c---ch --b---hh   ----v--- b------- c-----b- c-------  v------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 2,  --v----- b------- c-----c- b-----v-  --v----- b------- --c---ch --b---hh   ----v--- b------- c-----b- c-------  v------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 3,  ----d--- ----d--- ----d--- ----g-ee  f------- ----d--- ----d--- ----d-e-   f-----d- ----d--- ----d--- --g---ee  f------- ----d--- --g---g- ----d-e-,
            CLEAR, 0, 4,  ----d--- ----d--- ----d--- ----g-ee  f------- ----d--- ----d--- ----d-e-   f-----d- ----d--- ----d--- --g---ee  f------- ----d--- --g---g- ----d-e-,
            CLEAR, 0, 9,  ----i--- -------- i------- j-------  -------- i------- i------- ------j-   i------- ----j--- i------- --------  i------- -------- -------- j-------,
            CLEAR, 0, 10, ----i--- -------- i------- j-------  -------- i------- i------- ------j-   i------- ----j--- i------- --------  i------- -------- -------- j-------,
            b, 100, 0x1400,
            c, 100, 0x0800,
            h, 100, 0x0500,
            v, 100, 0x0300,
            d, 100, 0x1800,
            e, 100, 0x0800,
            f, 100, 0x1000,
            g, 100, 0x0400,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    AX0 = 24*1;
    DM(a_LFO+(8*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    AX0 = 24*2;
    DM(a_LFO+(12*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure80:
    SET_VOLENV(0, 0x0000, 0x0000, 1);

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(2*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    DM(a_FM2Op0Gen+(3*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;

    jump MultiMeasureCheck;

Measure82:

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(0*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    DM(a_FM2Op0Gen+(1*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;    
    
    SET_VOLENV(9, 0x2800, 0x2800, 1);
    SET_VOLENV(10, 0x2800, 0x2800, 1);

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(2*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    DM(a_FM2Op0Gen+(3*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;

Measure84:
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    
    SET_VOLENV(7, 0x0800, 0x0800, 1);
    SET_VOLENV(8, 0x0800, 0x0800, 1);
    
    SET_VOLENV(1, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(2, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(3, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(4, 0x7fff, 0x0000, MEASURE*4);
    
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(0*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    DM(a_FM2Op0Gen+(1*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;

Measure86:
    
    SET_VOLENV(11, 0x2800, 0x2800, 1);
    
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;
    
Measure88:
    SET_VOLENV(0, 0x0000, 0x0000, 1);
    SET_VOLENV(1, 0x0000, 0x0000, 1);
    SET_VOLENV(2, 0x0000, 0x0000, 1);
    SET_VOLENV(3, 0x0000, 0x0000, 1);
    SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(7, 0x0000, 0x0000, 1);
    SET_VOLENV(8, 0x0000, 0x0000, 1);
    SET_VOLENV(9, 0x0000, 0x0000, 1);
    SET_VOLENV(10, 0x0000, 0x0000, 1);
    SET_VOLENV(11, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);
    
    AX0 = 6;
    DM(a_LFO+(8*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    AX0 = 3;
    DM(a_LFO+(12*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure92:
    SET_VOLENV(14, 0x0000, 0x0000, 1);
    SET_VOLENV(15, 0x0000, 0x0000, 1);

    jump MultiMeasureCheck;
            
DoNothing:
    jump MultiMeasureCheck;

.ENDMOD;
