/******************************************************************************
*
*  SongCTRL.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  function for modifying parameters on a measure by measure basis.  execution
*  rate determined by v_TicsPerMeasure (set in GenFXIni.dsp by macros).
*
******************************************************************************/

.MODULE                                     modSongCTRL_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "songnow.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      SongCTRL_00;
.ENTRY      Measure_JT;
.ENTRY      EndMeasure_JT;

SongCTRL_00:
    AR = DM(v_TicCNTR);
    AR = AR + 1;
    DM(v_TicCNTR) = AR;
    AY0 = DM(v_TicsPerMeasure);
    AR = AR - AY0;
    if LT rts;
    
    DM(v_TicCNTR) = M0;

/*
 *  note!  this initialization used to be in InitFunc.dsp.  however, to make
 *  this function work with multiple tracks in a single executable, Measure_JT
 *  and EndMeasure_JT would need to be abstracted and inited in SongPtrs.dsp.
 *  to try and simplify and reduce the number of initializations that occur in
 *  that function, these variables were made local and it is continually
 *  re-inited here.  note that this code runs in the krate loop so performance
 *  is not a concern.
 */

SetMeasuresPerSong:
    AX0 = ^EndMeasure_JT;
    AY0 = ^Measure_JT;
    AR = AX0 - AY0;
    DM(v_MeasuresPerSong) = AR;
    
    I5 = ^Measure_JT;
    M5 = DM(v_CurrMeasure);
    modify(I5, M5);
    jump (I5);
    
/*
 *  insert JT of operations to perform at the start of every new measure
 */
    
Measure_JT:
    jump Measure0;
    jump DoNothing;
    jump Measure2;
    jump DoNothing;
    
    jump Measure4;
    jump DoNothing;
    jump Measure6;
    jump DoNothing;
    
    jump Measure8;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure12;
    jump DoNothing;
    jump Measure14;
    jump DoNothing;
    
    jump Measure16;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure20;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;

    jump Measure24;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure28;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure32;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure40;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure44;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure48;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure56;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure60;
    jump DoNothing;
    jump Measure62;
    jump DoNothing;
    
    jump Measure64;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
        
    jump Measure72;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
        
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure80;
    jump DoNothing;
    jump Measure82;
    jump DoNothing;
    
    jump Measure84;
    jump DoNothing;
    jump Measure86;
    jump DoNothing;
    
    jump Measure88;
    jump DoNothing;
    jump DoNothing;
    jump DoNothing;
    
    jump Measure92;
    
EndMeasure_JT:

/*
 *  insert all multimeasure operations - for parameters that should be modified
 *  over multiple measures
 */

MultiMeasureCheck:

EndSongCheck:
    AR = DM(v_CurrMeasure);
    AR = AR + 1;
    DM(v_CurrMeasure) = AR;
    AY0 = DM(v_MeasuresPerSong);
    AR = AR - AY0;
    if LT rts;

/*
 *  SongCTRL list is complete.  jumping to EndSong will start the next song
 *  in a multisong environment.  resetting CurrMeasure starts the Measure_JT
 *  loop over again, causing the same song to play indefinitely
 */
    
    !jump EndSong;
    
    DM(v_CurrMeasure) = M0;
    rts;

MultiMeasureMod:
    AR = DM(v_CurrMeasure);   
    AY0 = SR0;       
    NONE = AR - AY0;         
    if LT jump EndMMM;
    AY0 = SR1;
    NONE = AR - AY0;
    if GT jump EndMMM;
    call (I5);
EndMMM:
    rts;

Measure0:
    
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00230 until CE;
        DM(I2, M1) = 0;
CL00230:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x3000;
    DM(a_TrigTrack00+0+0) = AX0;
    DM(a_VolTrack00+0+0) = AX1;
    DM(a_TrigTrack00+0+8) = AX0;
    DM(a_VolTrack00+0+8) = AX1;
    DM(a_TrigTrack00+0+16) = AX0;
    DM(a_VolTrack00+0+16) = AX1;
    DM(a_TrigTrack00+0+22) = AX0;
    DM(a_VolTrack00+0+22) = AX1;
    DM(a_TrigTrack00+0+28) = AX0;
    DM(a_VolTrack00+0+28) = AX1;
    DM(a_TrigTrack00+0+30) = AX0;
    DM(a_VolTrack00+0+30) = AX1;
    DM(a_TrigTrack00+0+32) = AX0;
    DM(a_VolTrack00+0+32) = AX1;
    DM(a_TrigTrack00+0+40) = AX0;
    DM(a_VolTrack00+0+40) = AX1;
    DM(a_TrigTrack00+0+48) = AX0;
    DM(a_VolTrack00+0+48) = AX1;
    DM(a_TrigTrack00+0+54) = AX0;
    DM(a_VolTrack00+0+54) = AX1;
    DM(a_TrigTrack00+0+58) = AX0;
    DM(a_VolTrack00+0+58) = AX1;
    DM(a_TrigTrack00+0+62) = AX0;
    DM(a_VolTrack00+0+62) = AX1;

/* donotparse(CLEAR, 0, 0,  a------- a------- a-----a- ----a-a-  a------- a------- a-----a- --a---a-,
            a, 100, 0x3000,
            END); */

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09234 until CE;
        DM(I2, M1) = 0;
CL09234:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10234 until CE;
        DM(I2, M1) = 0;
CL10234:   DM(I3, M1) = 0;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack09+0+16) = AX0;
    DM(a_VolTrack09+0+16) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;

/* donotparse(CLEAR, 0, 9,  -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            i, 100, 0x0a00,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x7fff, MEASURE*16);
    SET_VOLENV(10, 0x0000, 0x7fff, MEASURE*16);

    jump MultiMeasureCheck;

Measure2:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11246 until CE;
        DM(I2, M1) = 0;
CL11246:   DM(I3, M1) = 0;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x1000;
    DM(a_TrigTrack11+0+0) = AX0;
    DM(a_VolTrack11+0+0) = AX1;
    DM(a_TrigTrack11+0+22) = AX0;
    DM(a_VolTrack11+0+22) = AX1;
    DM(a_TrigTrack11+0+24) = AX0;
    DM(a_VolTrack11+0+24) = AX1;
    DM(a_TrigTrack11+0+32) = AX0;
    DM(a_VolTrack11+0+32) = AX1;
    DM(a_TrigTrack11+0+48) = AX0;
    DM(a_VolTrack11+0+48) = AX1;
    DM(a_TrigTrack11+0+58) = AX0;
    DM(a_VolTrack11+0+58) = AX1;
    DM(a_TrigTrack11+0+62) = AX0;
    DM(a_VolTrack11+0+62) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack11+0+8) = AX0;
    DM(a_VolTrack11+0+8) = AX1;
    DM(a_TrigTrack11+0+16) = AX0;
    DM(a_VolTrack11+0+16) = AX1;
    DM(a_TrigTrack11+0+30) = AX0;
    DM(a_VolTrack11+0+30) = AX1;
    DM(a_TrigTrack11+0+40) = AX0;
    DM(a_VolTrack11+0+40) = AX1;
    DM(a_TrigTrack11+0+56) = AX0;
    DM(a_VolTrack11+0+56) = AX1;

    /* inits for l */
    AX0 = 100;
    AX1 = 0x0400;
    DM(a_TrigTrack11+0+4) = AX0;
    DM(a_VolTrack11+0+4) = AX1;
    DM(a_TrigTrack11+0+12) = AX0;
    DM(a_VolTrack11+0+12) = AX1;
    DM(a_TrigTrack11+0+20) = AX0;
    DM(a_VolTrack11+0+20) = AX1;
    DM(a_TrigTrack11+0+28) = AX0;
    DM(a_VolTrack11+0+28) = AX1;
    DM(a_TrigTrack11+0+36) = AX0;
    DM(a_VolTrack11+0+36) = AX1;
    DM(a_TrigTrack11+0+44) = AX0;
    DM(a_VolTrack11+0+44) = AX1;
    DM(a_TrigTrack11+0+52) = AX0;
    DM(a_VolTrack11+0+52) = AX1;
    DM(a_TrigTrack11+0+60) = AX0;
    DM(a_VolTrack11+0+60) = AX1;

/* donotparse(CLEAR, 0, 11, j---l--- k---l--- k---l-j- j---l-k-  j---l--- k---l--- j---l--- k-j-l-j-,
            j, 100, 0x1000,
            k, 100, 0x0800,
            l, 100, 0x0400,
            END); */
            
    SET_VOLENV(11, 0x6000, 0x6000, 1);
    

    jump MultiMeasureCheck;

Measure4:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03258 until CE;
        DM(I2, M1) = 0;
CL03258:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04258 until CE;
        DM(I2, M1) = 0;
CL04258:   DM(I3, M1) = 0;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x1400;
    DM(a_TrigTrack03+0+4) = AX0;
    DM(a_VolTrack03+0+4) = AX1;
    DM(a_TrigTrack04+0+4) = AX0;
    DM(a_VolTrack04+0+4) = AX1;
    DM(a_TrigTrack03+0+20) = AX0;
    DM(a_VolTrack03+0+20) = AX1;
    DM(a_TrigTrack04+0+20) = AX0;
    DM(a_VolTrack04+0+20) = AX1;
    DM(a_TrigTrack03+0+44) = AX0;
    DM(a_VolTrack03+0+44) = AX1;
    DM(a_TrigTrack04+0+44) = AX0;
    DM(a_VolTrack04+0+44) = AX1;
    DM(a_TrigTrack03+0+60) = AX0;
    DM(a_VolTrack03+0+60) = AX1;
    DM(a_TrigTrack04+0+60) = AX0;
    DM(a_VolTrack04+0+60) = AX1;
    DM(a_TrigTrack03+0+68) = AX0;
    DM(a_VolTrack03+0+68) = AX1;
    DM(a_TrigTrack04+0+68) = AX0;
    DM(a_VolTrack04+0+68) = AX1;
    DM(a_TrigTrack03+0+84) = AX0;
    DM(a_VolTrack03+0+84) = AX1;
    DM(a_TrigTrack04+0+84) = AX0;
    DM(a_VolTrack04+0+84) = AX1;
    DM(a_TrigTrack03+0+108) = AX0;
    DM(a_VolTrack03+0+108) = AX1;
    DM(a_TrigTrack04+0+108) = AX0;
    DM(a_VolTrack04+0+108) = AX1;
    DM(a_TrigTrack03+0+124) = AX0;
    DM(a_VolTrack03+0+124) = AX1;
    DM(a_TrigTrack04+0+124) = AX0;
    DM(a_VolTrack04+0+124) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack03+0+62) = AX0;
    DM(a_VolTrack03+0+62) = AX1;
    DM(a_TrigTrack04+0+62) = AX0;
    DM(a_VolTrack04+0+62) = AX1;
    DM(a_TrigTrack03+0+126) = AX0;
    DM(a_VolTrack03+0+126) = AX1;
    DM(a_TrigTrack04+0+126) = AX0;
    DM(a_VolTrack04+0+126) = AX1;

/* donotparse(CLEAR, 0, 3,  ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-   ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-,
            CLEAR, 0, 4,  ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-   ----d--- -------- ----d--- --------  -------- ----d--- -------- ----d-e-,
            d, 100, 0x1400,
            e, 100, 0x0a00,
            END); */
    
    jump MultiMeasureCheck;

Measure6:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03267 until CE;
        DM(I2, M1) = 0;
CL03267:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04267 until CE;
        DM(I2, M1) = 0;
CL04267:   DM(I3, M1) = 0;

/* donotparse(CLEAR, 0, 3,  -------- -------- -------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 4,  -------- -------- -------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            END); */

    AR = 4;
    DM(a_LFO+(6*LFO_VARS)+LFO_MOD) = AR;
    AR = 16;
    DM(a_LFO+(7*LFO_VARS)+LFO_MOD) = AR;
    
    jump MultiMeasureCheck;

Measure8:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03279 until CE;
        DM(I2, M1) = 0;
CL03279:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04279 until CE;
        DM(I2, M1) = 0;
CL04279:   DM(I3, M1) = 0;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x1800;
    DM(a_TrigTrack03+0+4) = AX0;
    DM(a_VolTrack03+0+4) = AX1;
    DM(a_TrigTrack04+0+4) = AX0;
    DM(a_VolTrack04+0+4) = AX1;
    DM(a_TrigTrack03+0+12) = AX0;
    DM(a_VolTrack03+0+12) = AX1;
    DM(a_TrigTrack04+0+12) = AX0;
    DM(a_VolTrack04+0+12) = AX1;
    DM(a_TrigTrack03+0+20) = AX0;
    DM(a_VolTrack03+0+20) = AX1;
    DM(a_TrigTrack04+0+20) = AX0;
    DM(a_VolTrack04+0+20) = AX1;
    DM(a_TrigTrack03+0+28) = AX0;
    DM(a_VolTrack03+0+28) = AX1;
    DM(a_TrigTrack04+0+28) = AX0;
    DM(a_VolTrack04+0+28) = AX1;
    DM(a_TrigTrack03+0+36) = AX0;
    DM(a_VolTrack03+0+36) = AX1;
    DM(a_TrigTrack04+0+36) = AX0;
    DM(a_VolTrack04+0+36) = AX1;
    DM(a_TrigTrack03+0+44) = AX0;
    DM(a_VolTrack03+0+44) = AX1;
    DM(a_TrigTrack04+0+44) = AX0;
    DM(a_VolTrack04+0+44) = AX1;
    DM(a_TrigTrack03+0+52) = AX0;
    DM(a_VolTrack03+0+52) = AX1;
    DM(a_TrigTrack04+0+52) = AX0;
    DM(a_VolTrack04+0+52) = AX1;
    DM(a_TrigTrack03+0+60) = AX0;
    DM(a_VolTrack03+0+60) = AX1;
    DM(a_TrigTrack04+0+60) = AX0;
    DM(a_VolTrack04+0+60) = AX1;
    DM(a_TrigTrack03+0+68) = AX0;
    DM(a_VolTrack03+0+68) = AX1;
    DM(a_TrigTrack04+0+68) = AX0;
    DM(a_VolTrack04+0+68) = AX1;
    DM(a_TrigTrack03+0+76) = AX0;
    DM(a_VolTrack03+0+76) = AX1;
    DM(a_TrigTrack04+0+76) = AX0;
    DM(a_VolTrack04+0+76) = AX1;
    DM(a_TrigTrack03+0+84) = AX0;
    DM(a_VolTrack03+0+84) = AX1;
    DM(a_TrigTrack04+0+84) = AX0;
    DM(a_VolTrack04+0+84) = AX1;
    DM(a_TrigTrack03+0+92) = AX0;
    DM(a_VolTrack03+0+92) = AX1;
    DM(a_TrigTrack04+0+92) = AX0;
    DM(a_VolTrack04+0+92) = AX1;
    DM(a_TrigTrack03+0+100) = AX0;
    DM(a_VolTrack03+0+100) = AX1;
    DM(a_TrigTrack04+0+100) = AX0;
    DM(a_VolTrack04+0+100) = AX1;
    DM(a_TrigTrack03+0+108) = AX0;
    DM(a_VolTrack03+0+108) = AX1;
    DM(a_TrigTrack04+0+108) = AX0;
    DM(a_VolTrack04+0+108) = AX1;
    DM(a_TrigTrack03+0+116) = AX0;
    DM(a_VolTrack03+0+116) = AX1;
    DM(a_TrigTrack04+0+116) = AX0;
    DM(a_VolTrack04+0+116) = AX1;
    DM(a_TrigTrack03+0+124) = AX0;
    DM(a_VolTrack03+0+124) = AX1;
    DM(a_TrigTrack04+0+124) = AX0;
    DM(a_VolTrack04+0+124) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack03+0+10) = AX0;
    DM(a_VolTrack03+0+10) = AX1;
    DM(a_TrigTrack04+0+10) = AX0;
    DM(a_VolTrack04+0+10) = AX1;
    DM(a_TrigTrack03+0+21) = AX0;
    DM(a_VolTrack03+0+21) = AX1;
    DM(a_TrigTrack04+0+21) = AX0;
    DM(a_VolTrack04+0+21) = AX1;
    DM(a_TrigTrack03+0+22) = AX0;
    DM(a_VolTrack03+0+22) = AX1;
    DM(a_TrigTrack04+0+22) = AX0;
    DM(a_VolTrack04+0+22) = AX1;
    DM(a_TrigTrack03+0+62) = AX0;
    DM(a_VolTrack03+0+62) = AX1;
    DM(a_TrigTrack04+0+62) = AX0;
    DM(a_VolTrack04+0+62) = AX1;
    DM(a_TrigTrack03+0+74) = AX0;
    DM(a_VolTrack03+0+74) = AX1;
    DM(a_TrigTrack04+0+74) = AX0;
    DM(a_VolTrack04+0+74) = AX1;
    DM(a_TrigTrack03+0+85) = AX0;
    DM(a_VolTrack03+0+85) = AX1;
    DM(a_TrigTrack04+0+85) = AX0;
    DM(a_VolTrack04+0+85) = AX1;
    DM(a_TrigTrack03+0+86) = AX0;
    DM(a_VolTrack03+0+86) = AX1;
    DM(a_TrigTrack04+0+86) = AX0;
    DM(a_VolTrack04+0+86) = AX1;
    DM(a_TrigTrack03+0+126) = AX0;
    DM(a_VolTrack03+0+126) = AX1;
    DM(a_TrigTrack04+0+126) = AX0;
    DM(a_VolTrack04+0+126) = AX1;

/* donotparse(CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            END); */

    SET_VOLENV(3, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(4, 0x0000, 0x7fff, MEASURE*4);

    jump MultiMeasureCheck;

Measure12:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01292 until CE;
        DM(I2, M1) = 0;
CL01292:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02292 until CE;
        DM(I2, M1) = 0;
CL02292:   DM(I3, M1) = 0;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2400;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack02+0+8) = AX0;
    DM(a_VolTrack02+0+8) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;
    DM(a_TrigTrack02+0+24) = AX0;
    DM(a_VolTrack02+0+24) = AX1;
    DM(a_TrigTrack01+0+40) = AX0;
    DM(a_VolTrack01+0+40) = AX1;
    DM(a_TrigTrack02+0+40) = AX0;
    DM(a_VolTrack02+0+40) = AX1;
    DM(a_TrigTrack01+0+56) = AX0;
    DM(a_VolTrack01+0+56) = AX1;
    DM(a_TrigTrack02+0+56) = AX0;
    DM(a_VolTrack02+0+56) = AX1;
    DM(a_TrigTrack01+0+72) = AX0;
    DM(a_VolTrack01+0+72) = AX1;
    DM(a_TrigTrack02+0+72) = AX0;
    DM(a_VolTrack02+0+72) = AX1;
    DM(a_TrigTrack01+0+88) = AX0;
    DM(a_VolTrack01+0+88) = AX1;
    DM(a_TrigTrack02+0+88) = AX0;
    DM(a_VolTrack02+0+88) = AX1;
    DM(a_TrigTrack01+0+104) = AX0;
    DM(a_VolTrack01+0+104) = AX1;
    DM(a_TrigTrack02+0+104) = AX0;
    DM(a_VolTrack02+0+104) = AX1;
    DM(a_TrigTrack01+0+120) = AX0;
    DM(a_VolTrack01+0+120) = AX1;
    DM(a_TrigTrack02+0+120) = AX0;
    DM(a_VolTrack02+0+120) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack01+0+46) = AX0;
    DM(a_VolTrack01+0+46) = AX1;
    DM(a_TrigTrack02+0+46) = AX0;
    DM(a_VolTrack02+0+46) = AX1;
    DM(a_TrigTrack01+0+114) = AX0;
    DM(a_VolTrack01+0+114) = AX1;
    DM(a_TrigTrack02+0+114) = AX0;
    DM(a_VolTrack02+0+114) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack01+0+110) = AX0;
    DM(a_VolTrack01+0+110) = AX1;
    DM(a_TrigTrack02+0+110) = AX0;
    DM(a_VolTrack02+0+110) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0600;

/* donotparse(CLEAR, 0, 1,  -------- b------- -------- b-------  -------- b-----c- -------- b-------   -------- b------- -------- b-------  -------- b-----d- --c----- b-------,
            CLEAR, 0, 2,  -------- b------- -------- b-------  -------- b-----c- -------- b-------   -------- b------- -------- b-------  -------- b-----d- --c----- b-------,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800,
            h, 100, 0x0600,
            END); */

    jump MultiMeasureCheck;

Measure14:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01304 until CE;
        DM(I2, M1) = 0;
CL01304:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02304 until CE;
        DM(I2, M1) = 0;
CL02304:   DM(I3, M1) = 0;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2400;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack02+0+8) = AX0;
    DM(a_VolTrack02+0+8) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;
    DM(a_TrigTrack02+0+24) = AX0;
    DM(a_VolTrack02+0+24) = AX1;
    DM(a_TrigTrack01+0+40) = AX0;
    DM(a_VolTrack01+0+40) = AX1;
    DM(a_TrigTrack02+0+40) = AX0;
    DM(a_VolTrack02+0+40) = AX1;
    DM(a_TrigTrack01+0+56) = AX0;
    DM(a_VolTrack01+0+56) = AX1;
    DM(a_TrigTrack02+0+56) = AX0;
    DM(a_VolTrack02+0+56) = AX1;
    DM(a_TrigTrack01+0+72) = AX0;
    DM(a_VolTrack01+0+72) = AX1;
    DM(a_TrigTrack02+0+72) = AX0;
    DM(a_VolTrack02+0+72) = AX1;
    DM(a_TrigTrack01+0+88) = AX0;
    DM(a_VolTrack01+0+88) = AX1;
    DM(a_TrigTrack02+0+88) = AX0;
    DM(a_VolTrack02+0+88) = AX1;
    DM(a_TrigTrack01+0+104) = AX0;
    DM(a_VolTrack01+0+104) = AX1;
    DM(a_TrigTrack02+0+104) = AX0;
    DM(a_VolTrack02+0+104) = AX1;
    DM(a_TrigTrack01+0+120) = AX0;
    DM(a_VolTrack01+0+120) = AX1;
    DM(a_TrigTrack02+0+120) = AX0;
    DM(a_VolTrack02+0+120) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack01+0+16) = AX0;
    DM(a_VolTrack01+0+16) = AX1;
    DM(a_TrigTrack02+0+16) = AX0;
    DM(a_VolTrack02+0+16) = AX1;
    DM(a_TrigTrack01+0+22) = AX0;
    DM(a_VolTrack01+0+22) = AX1;
    DM(a_TrigTrack02+0+22) = AX0;
    DM(a_VolTrack02+0+22) = AX1;
    DM(a_TrigTrack01+0+46) = AX0;
    DM(a_VolTrack01+0+46) = AX1;
    DM(a_TrigTrack02+0+46) = AX0;
    DM(a_VolTrack02+0+46) = AX1;
    DM(a_TrigTrack01+0+54) = AX0;
    DM(a_VolTrack01+0+54) = AX1;
    DM(a_TrigTrack02+0+54) = AX0;
    DM(a_VolTrack02+0+54) = AX1;
    DM(a_TrigTrack01+0+60) = AX0;
    DM(a_VolTrack01+0+60) = AX1;
    DM(a_TrigTrack02+0+60) = AX0;
    DM(a_VolTrack02+0+60) = AX1;
    DM(a_TrigTrack01+0+80) = AX0;
    DM(a_VolTrack01+0+80) = AX1;
    DM(a_TrigTrack02+0+80) = AX0;
    DM(a_VolTrack02+0+80) = AX1;
    DM(a_TrigTrack01+0+86) = AX0;
    DM(a_VolTrack01+0+86) = AX1;
    DM(a_TrigTrack02+0+86) = AX0;
    DM(a_VolTrack02+0+86) = AX1;
    DM(a_TrigTrack01+0+114) = AX0;
    DM(a_VolTrack01+0+114) = AX1;
    DM(a_TrigTrack02+0+114) = AX0;
    DM(a_VolTrack02+0+114) = AX1;
    DM(a_TrigTrack01+0+118) = AX0;
    DM(a_VolTrack01+0+118) = AX1;
    DM(a_TrigTrack02+0+118) = AX0;
    DM(a_VolTrack02+0+118) = AX1;
    DM(a_TrigTrack01+0+124) = AX0;
    DM(a_VolTrack01+0+124) = AX1;
    DM(a_TrigTrack02+0+124) = AX0;
    DM(a_VolTrack02+0+124) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack01+0+12) = AX0;
    DM(a_VolTrack01+0+12) = AX1;
    DM(a_TrigTrack02+0+12) = AX0;
    DM(a_VolTrack02+0+12) = AX1;
    DM(a_TrigTrack01+0+68) = AX0;
    DM(a_VolTrack01+0+68) = AX1;
    DM(a_TrigTrack02+0+68) = AX0;
    DM(a_VolTrack02+0+68) = AX1;
    DM(a_TrigTrack01+0+110) = AX0;
    DM(a_VolTrack01+0+110) = AX1;
    DM(a_TrigTrack02+0+110) = AX0;
    DM(a_VolTrack02+0+110) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0600;
    DM(a_TrigTrack01+0+55) = AX0;
    DM(a_VolTrack01+0+55) = AX1;
    DM(a_TrigTrack02+0+55) = AX0;
    DM(a_VolTrack02+0+55) = AX1;
    DM(a_TrigTrack01+0+62) = AX0;
    DM(a_VolTrack01+0+62) = AX1;
    DM(a_TrigTrack02+0+62) = AX0;
    DM(a_VolTrack02+0+62) = AX1;
    DM(a_TrigTrack01+0+63) = AX0;
    DM(a_VolTrack01+0+63) = AX1;
    DM(a_TrigTrack02+0+63) = AX0;
    DM(a_VolTrack02+0+63) = AX1;
    DM(a_TrigTrack01+0+119) = AX0;
    DM(a_VolTrack01+0+119) = AX1;
    DM(a_TrigTrack02+0+119) = AX0;
    DM(a_VolTrack02+0+119) = AX1;
    DM(a_TrigTrack01+0+126) = AX0;
    DM(a_VolTrack01+0+126) = AX1;
    DM(a_TrigTrack02+0+126) = AX0;
    DM(a_VolTrack02+0+126) = AX1;
    DM(a_TrigTrack01+0+127) = AX0;
    DM(a_VolTrack01+0+127) = AX1;
    DM(a_TrigTrack02+0+127) = AX0;
    DM(a_VolTrack02+0+127) = AX1;

/* donotparse(CLEAR, 0, 1,  -------- b---d--- c-----c- b-------  -------- b-----c- ------ch b---c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            CLEAR, 0, 2,  -------- b---d--- c-----c- b-------  -------- b-----c- ------ch b---c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800,
            h, 100, 0x0600,
            END); */

    jump MultiMeasureCheck;

Measure16:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03316 until CE;
        DM(I2, M1) = 0;
CL03316:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04316 until CE;
        DM(I2, M1) = 0;
CL04316:   DM(I3, M1) = 0;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x1800;
    DM(a_TrigTrack03+0+4) = AX0;
    DM(a_VolTrack03+0+4) = AX1;
    DM(a_TrigTrack04+0+4) = AX0;
    DM(a_VolTrack04+0+4) = AX1;
    DM(a_TrigTrack03+0+12) = AX0;
    DM(a_VolTrack03+0+12) = AX1;
    DM(a_TrigTrack04+0+12) = AX0;
    DM(a_VolTrack04+0+12) = AX1;
    DM(a_TrigTrack03+0+20) = AX0;
    DM(a_VolTrack03+0+20) = AX1;
    DM(a_TrigTrack04+0+20) = AX0;
    DM(a_VolTrack04+0+20) = AX1;
    DM(a_TrigTrack03+0+28) = AX0;
    DM(a_VolTrack03+0+28) = AX1;
    DM(a_TrigTrack04+0+28) = AX0;
    DM(a_VolTrack04+0+28) = AX1;
    DM(a_TrigTrack03+0+36) = AX0;
    DM(a_VolTrack03+0+36) = AX1;
    DM(a_TrigTrack04+0+36) = AX0;
    DM(a_VolTrack04+0+36) = AX1;
    DM(a_TrigTrack03+0+44) = AX0;
    DM(a_VolTrack03+0+44) = AX1;
    DM(a_TrigTrack04+0+44) = AX0;
    DM(a_VolTrack04+0+44) = AX1;
    DM(a_TrigTrack03+0+52) = AX0;
    DM(a_VolTrack03+0+52) = AX1;
    DM(a_TrigTrack04+0+52) = AX0;
    DM(a_VolTrack04+0+52) = AX1;
    DM(a_TrigTrack03+0+60) = AX0;
    DM(a_VolTrack03+0+60) = AX1;
    DM(a_TrigTrack04+0+60) = AX0;
    DM(a_VolTrack04+0+60) = AX1;
    DM(a_TrigTrack03+0+68) = AX0;
    DM(a_VolTrack03+0+68) = AX1;
    DM(a_TrigTrack04+0+68) = AX0;
    DM(a_VolTrack04+0+68) = AX1;
    DM(a_TrigTrack03+0+76) = AX0;
    DM(a_VolTrack03+0+76) = AX1;
    DM(a_TrigTrack04+0+76) = AX0;
    DM(a_VolTrack04+0+76) = AX1;
    DM(a_TrigTrack03+0+84) = AX0;
    DM(a_VolTrack03+0+84) = AX1;
    DM(a_TrigTrack04+0+84) = AX0;
    DM(a_VolTrack04+0+84) = AX1;
    DM(a_TrigTrack03+0+92) = AX0;
    DM(a_VolTrack03+0+92) = AX1;
    DM(a_TrigTrack04+0+92) = AX0;
    DM(a_VolTrack04+0+92) = AX1;
    DM(a_TrigTrack03+0+100) = AX0;
    DM(a_VolTrack03+0+100) = AX1;
    DM(a_TrigTrack04+0+100) = AX0;
    DM(a_VolTrack04+0+100) = AX1;
    DM(a_TrigTrack03+0+108) = AX0;
    DM(a_VolTrack03+0+108) = AX1;
    DM(a_TrigTrack04+0+108) = AX0;
    DM(a_VolTrack04+0+108) = AX1;
    DM(a_TrigTrack03+0+116) = AX0;
    DM(a_VolTrack03+0+116) = AX1;
    DM(a_TrigTrack04+0+116) = AX0;
    DM(a_VolTrack04+0+116) = AX1;
    DM(a_TrigTrack03+0+124) = AX0;
    DM(a_VolTrack03+0+124) = AX1;
    DM(a_TrigTrack04+0+124) = AX0;
    DM(a_VolTrack04+0+124) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack03+0+10) = AX0;
    DM(a_VolTrack03+0+10) = AX1;
    DM(a_TrigTrack04+0+10) = AX0;
    DM(a_VolTrack04+0+10) = AX1;
    DM(a_TrigTrack03+0+21) = AX0;
    DM(a_VolTrack03+0+21) = AX1;
    DM(a_TrigTrack04+0+21) = AX0;
    DM(a_VolTrack04+0+21) = AX1;
    DM(a_TrigTrack03+0+22) = AX0;
    DM(a_VolTrack03+0+22) = AX1;
    DM(a_TrigTrack04+0+22) = AX0;
    DM(a_VolTrack04+0+22) = AX1;
    DM(a_TrigTrack03+0+62) = AX0;
    DM(a_VolTrack03+0+62) = AX1;
    DM(a_TrigTrack04+0+62) = AX0;
    DM(a_VolTrack04+0+62) = AX1;
    DM(a_TrigTrack03+0+74) = AX0;
    DM(a_VolTrack03+0+74) = AX1;
    DM(a_TrigTrack04+0+74) = AX0;
    DM(a_VolTrack04+0+74) = AX1;
    DM(a_TrigTrack03+0+85) = AX0;
    DM(a_VolTrack03+0+85) = AX1;
    DM(a_TrigTrack04+0+85) = AX0;
    DM(a_VolTrack04+0+85) = AX1;
    DM(a_TrigTrack03+0+86) = AX0;
    DM(a_VolTrack03+0+86) = AX1;
    DM(a_TrigTrack04+0+86) = AX0;
    DM(a_VolTrack04+0+86) = AX1;
    DM(a_TrigTrack03+0+126) = AX0;
    DM(a_VolTrack03+0+126) = AX1;
    DM(a_TrigTrack04+0+126) = AX0;
    DM(a_VolTrack04+0+126) = AX1;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x0200;
    DM(a_TrigTrack03+0+64) = AX0;
    DM(a_VolTrack03+0+64) = AX1;
    DM(a_TrigTrack04+0+64) = AX0;
    DM(a_VolTrack04+0+64) = AX1;
    DM(a_TrigTrack03+0+66) = AX0;
    DM(a_VolTrack03+0+66) = AX1;
    DM(a_TrigTrack04+0+66) = AX0;
    DM(a_VolTrack04+0+66) = AX1;
    DM(a_TrigTrack03+0+70) = AX0;
    DM(a_VolTrack03+0+70) = AX1;
    DM(a_TrigTrack04+0+70) = AX0;
    DM(a_VolTrack04+0+70) = AX1;
    DM(a_TrigTrack03+0+72) = AX0;
    DM(a_VolTrack03+0+72) = AX1;
    DM(a_TrigTrack04+0+72) = AX0;
    DM(a_VolTrack04+0+72) = AX1;
    DM(a_TrigTrack03+0+78) = AX0;
    DM(a_VolTrack03+0+78) = AX1;
    DM(a_TrigTrack04+0+78) = AX0;
    DM(a_VolTrack04+0+78) = AX1;
    DM(a_TrigTrack03+0+80) = AX0;
    DM(a_VolTrack03+0+80) = AX1;
    DM(a_TrigTrack04+0+80) = AX0;
    DM(a_VolTrack04+0+80) = AX1;
    DM(a_TrigTrack03+0+82) = AX0;
    DM(a_VolTrack03+0+82) = AX1;
    DM(a_TrigTrack04+0+82) = AX0;
    DM(a_VolTrack04+0+82) = AX1;
    DM(a_TrigTrack03+0+88) = AX0;
    DM(a_VolTrack03+0+88) = AX1;
    DM(a_TrigTrack04+0+88) = AX0;
    DM(a_VolTrack04+0+88) = AX1;
    DM(a_TrigTrack03+0+90) = AX0;
    DM(a_VolTrack03+0+90) = AX1;
    DM(a_TrigTrack04+0+90) = AX0;
    DM(a_VolTrack04+0+90) = AX1;
    DM(a_TrigTrack03+0+94) = AX0;
    DM(a_VolTrack03+0+94) = AX1;
    DM(a_TrigTrack04+0+94) = AX0;
    DM(a_VolTrack04+0+94) = AX1;
    DM(a_TrigTrack03+0+96) = AX0;
    DM(a_VolTrack03+0+96) = AX1;
    DM(a_TrigTrack04+0+96) = AX0;
    DM(a_VolTrack04+0+96) = AX1;
    DM(a_TrigTrack03+0+98) = AX0;
    DM(a_VolTrack03+0+98) = AX1;
    DM(a_TrigTrack04+0+98) = AX0;
    DM(a_VolTrack04+0+98) = AX1;
    DM(a_TrigTrack03+0+102) = AX0;
    DM(a_VolTrack03+0+102) = AX1;
    DM(a_TrigTrack04+0+102) = AX0;
    DM(a_VolTrack04+0+102) = AX1;
    DM(a_TrigTrack03+0+104) = AX0;
    DM(a_VolTrack03+0+104) = AX1;
    DM(a_TrigTrack04+0+104) = AX0;
    DM(a_VolTrack04+0+104) = AX1;
    DM(a_TrigTrack03+0+106) = AX0;
    DM(a_VolTrack03+0+106) = AX1;
    DM(a_TrigTrack04+0+106) = AX0;
    DM(a_VolTrack04+0+106) = AX1;
    DM(a_TrigTrack03+0+110) = AX0;
    DM(a_VolTrack03+0+110) = AX1;
    DM(a_TrigTrack04+0+110) = AX0;
    DM(a_VolTrack04+0+110) = AX1;
    DM(a_TrigTrack03+0+112) = AX0;
    DM(a_VolTrack03+0+112) = AX1;
    DM(a_TrigTrack04+0+112) = AX0;
    DM(a_VolTrack04+0+112) = AX1;
    DM(a_TrigTrack03+0+114) = AX0;
    DM(a_VolTrack03+0+114) = AX1;
    DM(a_TrigTrack04+0+114) = AX0;
    DM(a_VolTrack04+0+114) = AX1;
    DM(a_TrigTrack03+0+118) = AX0;
    DM(a_VolTrack03+0+118) = AX1;
    DM(a_TrigTrack04+0+118) = AX0;
    DM(a_VolTrack04+0+118) = AX1;
    DM(a_TrigTrack03+0+120) = AX0;
    DM(a_VolTrack03+0+120) = AX1;
    DM(a_TrigTrack04+0+120) = AX0;
    DM(a_VolTrack04+0+120) = AX1;
    DM(a_TrigTrack03+0+122) = AX0;
    DM(a_VolTrack03+0+122) = AX1;
    DM(a_TrigTrack04+0+122) = AX0;
    DM(a_VolTrack04+0+122) = AX1;

/* donotparse(CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-f-d-f- f-e-d-f- f-f-dee- f-f-d-f-  f-f-d-f- f-f-d-f- f-f-d-f- f-f-d-e-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-f-d-f- f-e-d-f- f-f-dee- f-f-d-f-  f-f-d-f- f-f-d-f- f-f-d-f- f-f-d-e-,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            f, 100, 0x0200,
            END); */

    SET_VOLENV(11, 0x6000, 0x7fff, MEASURE*4);
    
    jump MultiMeasureCheck;

Measure20:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01329 until CE;
        DM(I2, M1) = 0;
CL01329:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02329 until CE;
        DM(I2, M1) = 0;
CL02329:   DM(I3, M1) = 0;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2400;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack02+0+8) = AX0;
    DM(a_VolTrack02+0+8) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;
    DM(a_TrigTrack02+0+24) = AX0;
    DM(a_VolTrack02+0+24) = AX1;
    DM(a_TrigTrack01+0+40) = AX0;
    DM(a_VolTrack01+0+40) = AX1;
    DM(a_TrigTrack02+0+40) = AX0;
    DM(a_VolTrack02+0+40) = AX1;
    DM(a_TrigTrack01+0+56) = AX0;
    DM(a_VolTrack01+0+56) = AX1;
    DM(a_TrigTrack02+0+56) = AX0;
    DM(a_VolTrack02+0+56) = AX1;
    DM(a_TrigTrack01+0+72) = AX0;
    DM(a_VolTrack01+0+72) = AX1;
    DM(a_TrigTrack02+0+72) = AX0;
    DM(a_VolTrack02+0+72) = AX1;
    DM(a_TrigTrack01+0+88) = AX0;
    DM(a_VolTrack01+0+88) = AX1;
    DM(a_TrigTrack02+0+88) = AX0;
    DM(a_VolTrack02+0+88) = AX1;
    DM(a_TrigTrack01+0+104) = AX0;
    DM(a_VolTrack01+0+104) = AX1;
    DM(a_TrigTrack02+0+104) = AX0;
    DM(a_VolTrack02+0+104) = AX1;
    DM(a_TrigTrack01+0+120) = AX0;
    DM(a_VolTrack01+0+120) = AX1;
    DM(a_TrigTrack02+0+120) = AX0;
    DM(a_VolTrack02+0+120) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack01+0+16) = AX0;
    DM(a_VolTrack01+0+16) = AX1;
    DM(a_TrigTrack02+0+16) = AX0;
    DM(a_VolTrack02+0+16) = AX1;
    DM(a_TrigTrack01+0+22) = AX0;
    DM(a_VolTrack01+0+22) = AX1;
    DM(a_TrigTrack02+0+22) = AX0;
    DM(a_VolTrack02+0+22) = AX1;
    DM(a_TrigTrack01+0+46) = AX0;
    DM(a_VolTrack01+0+46) = AX1;
    DM(a_TrigTrack02+0+46) = AX0;
    DM(a_VolTrack02+0+46) = AX1;
    DM(a_TrigTrack01+0+54) = AX0;
    DM(a_VolTrack01+0+54) = AX1;
    DM(a_TrigTrack02+0+54) = AX0;
    DM(a_VolTrack02+0+54) = AX1;
    DM(a_TrigTrack01+0+60) = AX0;
    DM(a_VolTrack01+0+60) = AX1;
    DM(a_TrigTrack02+0+60) = AX0;
    DM(a_VolTrack02+0+60) = AX1;
    DM(a_TrigTrack01+0+80) = AX0;
    DM(a_VolTrack01+0+80) = AX1;
    DM(a_TrigTrack02+0+80) = AX0;
    DM(a_VolTrack02+0+80) = AX1;
    DM(a_TrigTrack01+0+86) = AX0;
    DM(a_VolTrack01+0+86) = AX1;
    DM(a_TrigTrack02+0+86) = AX0;
    DM(a_VolTrack02+0+86) = AX1;
    DM(a_TrigTrack01+0+114) = AX0;
    DM(a_VolTrack01+0+114) = AX1;
    DM(a_TrigTrack02+0+114) = AX0;
    DM(a_VolTrack02+0+114) = AX1;
    DM(a_TrigTrack01+0+118) = AX0;
    DM(a_VolTrack01+0+118) = AX1;
    DM(a_TrigTrack02+0+118) = AX0;
    DM(a_VolTrack02+0+118) = AX1;
    DM(a_TrigTrack01+0+124) = AX0;
    DM(a_VolTrack01+0+124) = AX1;
    DM(a_TrigTrack02+0+124) = AX0;
    DM(a_VolTrack02+0+124) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack01+0+12) = AX0;
    DM(a_VolTrack01+0+12) = AX1;
    DM(a_TrigTrack02+0+12) = AX0;
    DM(a_VolTrack02+0+12) = AX1;
    DM(a_TrigTrack01+0+68) = AX0;
    DM(a_VolTrack01+0+68) = AX1;
    DM(a_TrigTrack02+0+68) = AX0;
    DM(a_VolTrack02+0+68) = AX1;
    DM(a_TrigTrack01+0+110) = AX0;
    DM(a_VolTrack01+0+110) = AX1;
    DM(a_TrigTrack02+0+110) = AX0;
    DM(a_VolTrack02+0+110) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0600;
    DM(a_TrigTrack01+0+55) = AX0;
    DM(a_VolTrack01+0+55) = AX1;
    DM(a_TrigTrack02+0+55) = AX0;
    DM(a_VolTrack02+0+55) = AX1;
    DM(a_TrigTrack01+0+62) = AX0;
    DM(a_VolTrack01+0+62) = AX1;
    DM(a_TrigTrack02+0+62) = AX0;
    DM(a_VolTrack02+0+62) = AX1;
    DM(a_TrigTrack01+0+63) = AX0;
    DM(a_VolTrack01+0+63) = AX1;
    DM(a_TrigTrack02+0+63) = AX0;
    DM(a_VolTrack02+0+63) = AX1;
    DM(a_TrigTrack01+0+119) = AX0;
    DM(a_VolTrack01+0+119) = AX1;
    DM(a_TrigTrack02+0+119) = AX0;
    DM(a_VolTrack02+0+119) = AX1;
    DM(a_TrigTrack01+0+126) = AX0;
    DM(a_VolTrack01+0+126) = AX1;
    DM(a_TrigTrack02+0+126) = AX0;
    DM(a_VolTrack02+0+126) = AX1;
    DM(a_TrigTrack01+0+127) = AX0;
    DM(a_VolTrack01+0+127) = AX1;
    DM(a_TrigTrack02+0+127) = AX0;
    DM(a_VolTrack02+0+127) = AX1;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0200;
    DM(a_TrigTrack01+0+0) = AX0;
    DM(a_VolTrack01+0+0) = AX1;
    DM(a_TrigTrack02+0+0) = AX0;
    DM(a_VolTrack02+0+0) = AX1;
    DM(a_TrigTrack01+0+2) = AX0;
    DM(a_VolTrack01+0+2) = AX1;
    DM(a_TrigTrack02+0+2) = AX0;
    DM(a_VolTrack02+0+2) = AX1;
    DM(a_TrigTrack01+0+4) = AX0;
    DM(a_VolTrack01+0+4) = AX1;
    DM(a_TrigTrack02+0+4) = AX0;
    DM(a_VolTrack02+0+4) = AX1;
    DM(a_TrigTrack01+0+6) = AX0;
    DM(a_VolTrack01+0+6) = AX1;
    DM(a_TrigTrack02+0+6) = AX0;
    DM(a_VolTrack02+0+6) = AX1;
    DM(a_TrigTrack01+0+10) = AX0;
    DM(a_VolTrack01+0+10) = AX1;
    DM(a_TrigTrack02+0+10) = AX0;
    DM(a_VolTrack02+0+10) = AX1;
    DM(a_TrigTrack01+0+14) = AX0;
    DM(a_VolTrack01+0+14) = AX1;
    DM(a_TrigTrack02+0+14) = AX0;
    DM(a_VolTrack02+0+14) = AX1;
    DM(a_TrigTrack01+0+18) = AX0;
    DM(a_VolTrack01+0+18) = AX1;
    DM(a_TrigTrack02+0+18) = AX0;
    DM(a_VolTrack02+0+18) = AX1;
    DM(a_TrigTrack01+0+20) = AX0;
    DM(a_VolTrack01+0+20) = AX1;
    DM(a_TrigTrack02+0+20) = AX0;
    DM(a_VolTrack02+0+20) = AX1;
    DM(a_TrigTrack01+0+26) = AX0;
    DM(a_VolTrack01+0+26) = AX1;
    DM(a_TrigTrack02+0+26) = AX0;
    DM(a_VolTrack02+0+26) = AX1;
    DM(a_TrigTrack01+0+28) = AX0;
    DM(a_VolTrack01+0+28) = AX1;
    DM(a_TrigTrack02+0+28) = AX0;
    DM(a_VolTrack02+0+28) = AX1;
    DM(a_TrigTrack01+0+30) = AX0;
    DM(a_VolTrack01+0+30) = AX1;
    DM(a_TrigTrack02+0+30) = AX0;
    DM(a_VolTrack02+0+30) = AX1;
    DM(a_TrigTrack01+0+32) = AX0;
    DM(a_VolTrack01+0+32) = AX1;
    DM(a_TrigTrack02+0+32) = AX0;
    DM(a_VolTrack02+0+32) = AX1;
    DM(a_TrigTrack01+0+34) = AX0;
    DM(a_VolTrack01+0+34) = AX1;
    DM(a_TrigTrack02+0+34) = AX0;
    DM(a_VolTrack02+0+34) = AX1;
    DM(a_TrigTrack01+0+36) = AX0;
    DM(a_VolTrack01+0+36) = AX1;
    DM(a_TrigTrack02+0+36) = AX0;
    DM(a_VolTrack02+0+36) = AX1;
    DM(a_TrigTrack01+0+38) = AX0;
    DM(a_VolTrack01+0+38) = AX1;
    DM(a_TrigTrack02+0+38) = AX0;
    DM(a_VolTrack02+0+38) = AX1;
    DM(a_TrigTrack01+0+42) = AX0;
    DM(a_VolTrack01+0+42) = AX1;
    DM(a_TrigTrack02+0+42) = AX0;
    DM(a_VolTrack02+0+42) = AX1;
    DM(a_TrigTrack01+0+44) = AX0;
    DM(a_VolTrack01+0+44) = AX1;
    DM(a_TrigTrack02+0+44) = AX0;
    DM(a_VolTrack02+0+44) = AX1;
    DM(a_TrigTrack01+0+48) = AX0;
    DM(a_VolTrack01+0+48) = AX1;
    DM(a_TrigTrack02+0+48) = AX0;
    DM(a_VolTrack02+0+48) = AX1;
    DM(a_TrigTrack01+0+50) = AX0;
    DM(a_VolTrack01+0+50) = AX1;
    DM(a_TrigTrack02+0+50) = AX0;
    DM(a_VolTrack02+0+50) = AX1;
    DM(a_TrigTrack01+0+52) = AX0;
    DM(a_VolTrack01+0+52) = AX1;
    DM(a_TrigTrack02+0+52) = AX0;
    DM(a_VolTrack02+0+52) = AX1;
    DM(a_TrigTrack01+0+58) = AX0;
    DM(a_VolTrack01+0+58) = AX1;
    DM(a_TrigTrack02+0+58) = AX0;
    DM(a_VolTrack02+0+58) = AX1;

/* donotparse(CLEAR, 0, 1,  i-i-i-i- b-i-d-i- c-i-i-c- b-i-i-i-  i-i-i-i- b-i-i-c- i-i-i-ch b-i-c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            CLEAR, 0, 2,  i-i-i-i- b-i-d-i- c-i-i-c- b-i-i-i-  i-i-i-i- b-i-i-c- i-i-i-ch b-i-c-hh   ----d--- b------- c-----c- b-------  -------- b-----d- --c---ch b---c-hh,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            d, 100, 0x0800
            h, 100, 0x0600,
            i, 100, 0x0200,
            END); */

    jump MultiMeasureCheck;

Measure24:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01342 until CE;
        DM(I2, M1) = 0;
CL01342:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02342 until CE;
        DM(I2, M1) = 0;
CL02342:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03342 until CE;
        DM(I2, M1) = 0;
CL03342:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04342 until CE;
        DM(I2, M1) = 0;
CL04342:   DM(I3, M1) = 0;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2400;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack02+0+8) = AX0;
    DM(a_VolTrack02+0+8) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;
    DM(a_TrigTrack02+0+24) = AX0;
    DM(a_VolTrack02+0+24) = AX1;
    DM(a_TrigTrack01+0+40) = AX0;
    DM(a_VolTrack01+0+40) = AX1;
    DM(a_TrigTrack02+0+40) = AX0;
    DM(a_VolTrack02+0+40) = AX1;
    DM(a_TrigTrack01+0+56) = AX0;
    DM(a_VolTrack01+0+56) = AX1;
    DM(a_TrigTrack02+0+56) = AX0;
    DM(a_VolTrack02+0+56) = AX1;
    DM(a_TrigTrack01+0+72) = AX0;
    DM(a_VolTrack01+0+72) = AX1;
    DM(a_TrigTrack02+0+72) = AX0;
    DM(a_VolTrack02+0+72) = AX1;
    DM(a_TrigTrack01+0+88) = AX0;
    DM(a_VolTrack01+0+88) = AX1;
    DM(a_TrigTrack02+0+88) = AX0;
    DM(a_VolTrack02+0+88) = AX1;
    DM(a_TrigTrack01+0+104) = AX0;
    DM(a_VolTrack01+0+104) = AX1;
    DM(a_TrigTrack02+0+104) = AX0;
    DM(a_VolTrack02+0+104) = AX1;
    DM(a_TrigTrack01+0+120) = AX0;
    DM(a_VolTrack01+0+120) = AX1;
    DM(a_TrigTrack02+0+120) = AX0;
    DM(a_VolTrack02+0+120) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack01+0+16) = AX0;
    DM(a_VolTrack01+0+16) = AX1;
    DM(a_TrigTrack02+0+16) = AX0;
    DM(a_VolTrack02+0+16) = AX1;
    DM(a_TrigTrack01+0+22) = AX0;
    DM(a_VolTrack01+0+22) = AX1;
    DM(a_TrigTrack02+0+22) = AX0;
    DM(a_VolTrack02+0+22) = AX1;
    DM(a_TrigTrack01+0+46) = AX0;
    DM(a_VolTrack01+0+46) = AX1;
    DM(a_TrigTrack02+0+46) = AX0;
    DM(a_VolTrack02+0+46) = AX1;
    DM(a_TrigTrack01+0+54) = AX0;
    DM(a_VolTrack01+0+54) = AX1;
    DM(a_TrigTrack02+0+54) = AX0;
    DM(a_VolTrack02+0+54) = AX1;
    DM(a_TrigTrack01+0+60) = AX0;
    DM(a_VolTrack01+0+60) = AX1;
    DM(a_TrigTrack02+0+60) = AX0;
    DM(a_VolTrack02+0+60) = AX1;
    DM(a_TrigTrack01+0+80) = AX0;
    DM(a_VolTrack01+0+80) = AX1;
    DM(a_TrigTrack02+0+80) = AX0;
    DM(a_VolTrack02+0+80) = AX1;
    DM(a_TrigTrack01+0+86) = AX0;
    DM(a_VolTrack01+0+86) = AX1;
    DM(a_TrigTrack02+0+86) = AX0;
    DM(a_VolTrack02+0+86) = AX1;
    DM(a_TrigTrack01+0+114) = AX0;
    DM(a_VolTrack01+0+114) = AX1;
    DM(a_TrigTrack02+0+114) = AX0;
    DM(a_VolTrack02+0+114) = AX1;
    DM(a_TrigTrack01+0+118) = AX0;
    DM(a_VolTrack01+0+118) = AX1;
    DM(a_TrigTrack02+0+118) = AX0;
    DM(a_VolTrack02+0+118) = AX1;
    DM(a_TrigTrack01+0+124) = AX0;
    DM(a_VolTrack01+0+124) = AX1;
    DM(a_TrigTrack02+0+124) = AX0;
    DM(a_VolTrack02+0+124) = AX1;

    /* inits for v */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack01+0+12) = AX0;
    DM(a_VolTrack01+0+12) = AX1;
    DM(a_TrigTrack02+0+12) = AX0;
    DM(a_VolTrack02+0+12) = AX1;
    DM(a_TrigTrack01+0+68) = AX0;
    DM(a_VolTrack01+0+68) = AX1;
    DM(a_TrigTrack02+0+68) = AX0;
    DM(a_VolTrack02+0+68) = AX1;
    DM(a_TrigTrack01+0+110) = AX0;
    DM(a_VolTrack01+0+110) = AX1;
    DM(a_TrigTrack02+0+110) = AX0;
    DM(a_VolTrack02+0+110) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0600;
    DM(a_TrigTrack01+0+55) = AX0;
    DM(a_VolTrack01+0+55) = AX1;
    DM(a_TrigTrack02+0+55) = AX0;
    DM(a_VolTrack02+0+55) = AX1;
    DM(a_TrigTrack01+0+62) = AX0;
    DM(a_VolTrack01+0+62) = AX1;
    DM(a_TrigTrack02+0+62) = AX0;
    DM(a_VolTrack02+0+62) = AX1;
    DM(a_TrigTrack01+0+63) = AX0;
    DM(a_VolTrack01+0+63) = AX1;
    DM(a_TrigTrack02+0+63) = AX0;
    DM(a_VolTrack02+0+63) = AX1;
    DM(a_TrigTrack01+0+119) = AX0;
    DM(a_VolTrack01+0+119) = AX1;
    DM(a_TrigTrack02+0+119) = AX0;
    DM(a_VolTrack02+0+119) = AX1;
    DM(a_TrigTrack01+0+126) = AX0;
    DM(a_VolTrack01+0+126) = AX1;
    DM(a_TrigTrack02+0+126) = AX0;
    DM(a_VolTrack02+0+126) = AX1;
    DM(a_TrigTrack01+0+127) = AX0;
    DM(a_VolTrack01+0+127) = AX1;
    DM(a_TrigTrack02+0+127) = AX0;
    DM(a_VolTrack02+0+127) = AX1;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0200;
    DM(a_TrigTrack01+0+0) = AX0;
    DM(a_VolTrack01+0+0) = AX1;
    DM(a_TrigTrack02+0+0) = AX0;
    DM(a_VolTrack02+0+0) = AX1;
    DM(a_TrigTrack01+0+2) = AX0;
    DM(a_VolTrack01+0+2) = AX1;
    DM(a_TrigTrack02+0+2) = AX0;
    DM(a_VolTrack02+0+2) = AX1;
    DM(a_TrigTrack01+0+4) = AX0;
    DM(a_VolTrack01+0+4) = AX1;
    DM(a_TrigTrack02+0+4) = AX0;
    DM(a_VolTrack02+0+4) = AX1;
    DM(a_TrigTrack01+0+6) = AX0;
    DM(a_VolTrack01+0+6) = AX1;
    DM(a_TrigTrack02+0+6) = AX0;
    DM(a_VolTrack02+0+6) = AX1;
    DM(a_TrigTrack01+0+10) = AX0;
    DM(a_VolTrack01+0+10) = AX1;
    DM(a_TrigTrack02+0+10) = AX0;
    DM(a_VolTrack02+0+10) = AX1;
    DM(a_TrigTrack01+0+14) = AX0;
    DM(a_VolTrack01+0+14) = AX1;
    DM(a_TrigTrack02+0+14) = AX0;
    DM(a_VolTrack02+0+14) = AX1;
    DM(a_TrigTrack01+0+18) = AX0;
    DM(a_VolTrack01+0+18) = AX1;
    DM(a_TrigTrack02+0+18) = AX0;
    DM(a_VolTrack02+0+18) = AX1;
    DM(a_TrigTrack01+0+20) = AX0;
    DM(a_VolTrack01+0+20) = AX1;
    DM(a_TrigTrack02+0+20) = AX0;
    DM(a_VolTrack02+0+20) = AX1;
    DM(a_TrigTrack01+0+26) = AX0;
    DM(a_VolTrack01+0+26) = AX1;
    DM(a_TrigTrack02+0+26) = AX0;
    DM(a_VolTrack02+0+26) = AX1;
    DM(a_TrigTrack01+0+28) = AX0;
    DM(a_VolTrack01+0+28) = AX1;
    DM(a_TrigTrack02+0+28) = AX0;
    DM(a_VolTrack02+0+28) = AX1;
    DM(a_TrigTrack01+0+30) = AX0;
    DM(a_VolTrack01+0+30) = AX1;
    DM(a_TrigTrack02+0+30) = AX0;
    DM(a_VolTrack02+0+30) = AX1;
    DM(a_TrigTrack01+0+32) = AX0;
    DM(a_VolTrack01+0+32) = AX1;
    DM(a_TrigTrack02+0+32) = AX0;
    DM(a_VolTrack02+0+32) = AX1;
    DM(a_TrigTrack01+0+34) = AX0;
    DM(a_VolTrack01+0+34) = AX1;
    DM(a_TrigTrack02+0+34) = AX0;
    DM(a_VolTrack02+0+34) = AX1;
    DM(a_TrigTrack01+0+36) = AX0;
    DM(a_VolTrack01+0+36) = AX1;
    DM(a_TrigTrack02+0+36) = AX0;
    DM(a_VolTrack02+0+36) = AX1;
    DM(a_TrigTrack01+0+38) = AX0;
    DM(a_VolTrack01+0+38) = AX1;
    DM(a_TrigTrack02+0+38) = AX0;
    DM(a_VolTrack02+0+38) = AX1;
    DM(a_TrigTrack01+0+42) = AX0;
    DM(a_VolTrack01+0+42) = AX1;
    DM(a_TrigTrack02+0+42) = AX0;
    DM(a_VolTrack02+0+42) = AX1;
    DM(a_TrigTrack01+0+44) = AX0;
    DM(a_VolTrack01+0+44) = AX1;
    DM(a_TrigTrack02+0+44) = AX0;
    DM(a_VolTrack02+0+44) = AX1;
    DM(a_TrigTrack01+0+48) = AX0;
    DM(a_VolTrack01+0+48) = AX1;
    DM(a_TrigTrack02+0+48) = AX0;
    DM(a_VolTrack02+0+48) = AX1;
    DM(a_TrigTrack01+0+50) = AX0;
    DM(a_VolTrack01+0+50) = AX1;
    DM(a_TrigTrack02+0+50) = AX0;
    DM(a_VolTrack02+0+50) = AX1;
    DM(a_TrigTrack01+0+52) = AX0;
    DM(a_VolTrack01+0+52) = AX1;
    DM(a_TrigTrack02+0+52) = AX0;
    DM(a_VolTrack02+0+52) = AX1;
    DM(a_TrigTrack01+0+58) = AX0;
    DM(a_VolTrack01+0+58) = AX1;
    DM(a_TrigTrack02+0+58) = AX0;
    DM(a_VolTrack02+0+58) = AX1;

    /* inits for j */
    AX0 = 70;
    AX1 = 0x0150;
    DM(a_TrigTrack01+0+3) = AX0;
    DM(a_VolTrack01+0+3) = AX1;
    DM(a_TrigTrack02+0+3) = AX0;
    DM(a_VolTrack02+0+3) = AX1;
    DM(a_TrigTrack01+0+5) = AX0;
    DM(a_VolTrack01+0+5) = AX1;
    DM(a_TrigTrack02+0+5) = AX0;
    DM(a_VolTrack02+0+5) = AX1;
    DM(a_TrigTrack01+0+11) = AX0;
    DM(a_VolTrack01+0+11) = AX1;
    DM(a_TrigTrack02+0+11) = AX0;
    DM(a_VolTrack02+0+11) = AX1;
    DM(a_TrigTrack01+0+19) = AX0;
    DM(a_VolTrack01+0+19) = AX1;
    DM(a_TrigTrack02+0+19) = AX0;
    DM(a_VolTrack02+0+19) = AX1;
    DM(a_TrigTrack01+0+27) = AX0;
    DM(a_VolTrack01+0+27) = AX1;
    DM(a_TrigTrack02+0+27) = AX0;
    DM(a_VolTrack02+0+27) = AX1;
    DM(a_TrigTrack01+0+35) = AX0;
    DM(a_VolTrack01+0+35) = AX1;
    DM(a_TrigTrack02+0+35) = AX0;
    DM(a_VolTrack02+0+35) = AX1;
    DM(a_TrigTrack01+0+37) = AX0;
    DM(a_VolTrack01+0+37) = AX1;
    DM(a_TrigTrack02+0+37) = AX0;
    DM(a_VolTrack02+0+37) = AX1;
    DM(a_TrigTrack01+0+43) = AX0;
    DM(a_VolTrack01+0+43) = AX1;
    DM(a_TrigTrack02+0+43) = AX0;
    DM(a_VolTrack02+0+43) = AX1;
    DM(a_TrigTrack01+0+51) = AX0;
    DM(a_VolTrack01+0+51) = AX1;
    DM(a_TrigTrack02+0+51) = AX0;
    DM(a_VolTrack02+0+51) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x1800;
    DM(a_TrigTrack03+0+4) = AX0;
    DM(a_VolTrack03+0+4) = AX1;
    DM(a_TrigTrack04+0+4) = AX0;
    DM(a_VolTrack04+0+4) = AX1;
    DM(a_TrigTrack03+0+12) = AX0;
    DM(a_VolTrack03+0+12) = AX1;
    DM(a_TrigTrack04+0+12) = AX0;
    DM(a_VolTrack04+0+12) = AX1;
    DM(a_TrigTrack03+0+20) = AX0;
    DM(a_VolTrack03+0+20) = AX1;
    DM(a_TrigTrack04+0+20) = AX0;
    DM(a_VolTrack04+0+20) = AX1;
    DM(a_TrigTrack03+0+28) = AX0;
    DM(a_VolTrack03+0+28) = AX1;
    DM(a_TrigTrack04+0+28) = AX0;
    DM(a_VolTrack04+0+28) = AX1;
    DM(a_TrigTrack03+0+36) = AX0;
    DM(a_VolTrack03+0+36) = AX1;
    DM(a_TrigTrack04+0+36) = AX0;
    DM(a_VolTrack04+0+36) = AX1;
    DM(a_TrigTrack03+0+44) = AX0;
    DM(a_VolTrack03+0+44) = AX1;
    DM(a_TrigTrack04+0+44) = AX0;
    DM(a_VolTrack04+0+44) = AX1;
    DM(a_TrigTrack03+0+52) = AX0;
    DM(a_VolTrack03+0+52) = AX1;
    DM(a_TrigTrack04+0+52) = AX0;
    DM(a_VolTrack04+0+52) = AX1;
    DM(a_TrigTrack03+0+60) = AX0;
    DM(a_VolTrack03+0+60) = AX1;
    DM(a_TrigTrack04+0+60) = AX0;
    DM(a_VolTrack04+0+60) = AX1;
    DM(a_TrigTrack03+0+68) = AX0;
    DM(a_VolTrack03+0+68) = AX1;
    DM(a_TrigTrack04+0+68) = AX0;
    DM(a_VolTrack04+0+68) = AX1;
    DM(a_TrigTrack03+0+76) = AX0;
    DM(a_VolTrack03+0+76) = AX1;
    DM(a_TrigTrack04+0+76) = AX0;
    DM(a_VolTrack04+0+76) = AX1;
    DM(a_TrigTrack03+0+84) = AX0;
    DM(a_VolTrack03+0+84) = AX1;
    DM(a_TrigTrack04+0+84) = AX0;
    DM(a_VolTrack04+0+84) = AX1;
    DM(a_TrigTrack03+0+92) = AX0;
    DM(a_VolTrack03+0+92) = AX1;
    DM(a_TrigTrack04+0+92) = AX0;
    DM(a_VolTrack04+0+92) = AX1;
    DM(a_TrigTrack03+0+100) = AX0;
    DM(a_VolTrack03+0+100) = AX1;
    DM(a_TrigTrack04+0+100) = AX0;
    DM(a_VolTrack04+0+100) = AX1;
    DM(a_TrigTrack03+0+108) = AX0;
    DM(a_VolTrack03+0+108) = AX1;
    DM(a_TrigTrack04+0+108) = AX0;
    DM(a_VolTrack04+0+108) = AX1;
    DM(a_TrigTrack03+0+116) = AX0;
    DM(a_VolTrack03+0+116) = AX1;
    DM(a_TrigTrack04+0+116) = AX0;
    DM(a_VolTrack04+0+116) = AX1;
    DM(a_TrigTrack03+0+124) = AX0;
    DM(a_VolTrack03+0+124) = AX1;
    DM(a_TrigTrack04+0+124) = AX0;
    DM(a_VolTrack04+0+124) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack03+0+10) = AX0;
    DM(a_VolTrack03+0+10) = AX1;
    DM(a_TrigTrack04+0+10) = AX0;
    DM(a_VolTrack04+0+10) = AX1;
    DM(a_TrigTrack03+0+21) = AX0;
    DM(a_VolTrack03+0+21) = AX1;
    DM(a_TrigTrack04+0+21) = AX0;
    DM(a_VolTrack04+0+21) = AX1;
    DM(a_TrigTrack03+0+22) = AX0;
    DM(a_VolTrack03+0+22) = AX1;
    DM(a_TrigTrack04+0+22) = AX0;
    DM(a_VolTrack04+0+22) = AX1;
    DM(a_TrigTrack03+0+62) = AX0;
    DM(a_VolTrack03+0+62) = AX1;
    DM(a_TrigTrack04+0+62) = AX0;
    DM(a_VolTrack04+0+62) = AX1;
    DM(a_TrigTrack03+0+74) = AX0;
    DM(a_VolTrack03+0+74) = AX1;
    DM(a_TrigTrack04+0+74) = AX0;
    DM(a_VolTrack04+0+74) = AX1;
    DM(a_TrigTrack03+0+85) = AX0;
    DM(a_VolTrack03+0+85) = AX1;
    DM(a_TrigTrack04+0+85) = AX0;
    DM(a_VolTrack04+0+85) = AX1;
    DM(a_TrigTrack03+0+86) = AX0;
    DM(a_VolTrack03+0+86) = AX1;
    DM(a_TrigTrack04+0+86) = AX0;
    DM(a_VolTrack04+0+86) = AX1;
    DM(a_TrigTrack03+0+126) = AX0;
    DM(a_VolTrack03+0+126) = AX1;
    DM(a_TrigTrack04+0+126) = AX0;
    DM(a_VolTrack04+0+126) = AX1;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x0200;
    DM(a_TrigTrack03+0+64) = AX0;
    DM(a_VolTrack03+0+64) = AX1;
    DM(a_TrigTrack04+0+64) = AX0;
    DM(a_VolTrack04+0+64) = AX1;
    DM(a_TrigTrack03+0+66) = AX0;
    DM(a_VolTrack03+0+66) = AX1;
    DM(a_TrigTrack04+0+66) = AX0;
    DM(a_VolTrack04+0+66) = AX1;
    DM(a_TrigTrack03+0+70) = AX0;
    DM(a_VolTrack03+0+70) = AX1;
    DM(a_TrigTrack04+0+70) = AX0;
    DM(a_VolTrack04+0+70) = AX1;
    DM(a_TrigTrack03+0+72) = AX0;
    DM(a_VolTrack03+0+72) = AX1;
    DM(a_TrigTrack04+0+72) = AX0;
    DM(a_VolTrack04+0+72) = AX1;
    DM(a_TrigTrack03+0+78) = AX0;
    DM(a_VolTrack03+0+78) = AX1;
    DM(a_TrigTrack04+0+78) = AX0;
    DM(a_VolTrack04+0+78) = AX1;
    DM(a_TrigTrack03+0+80) = AX0;
    DM(a_VolTrack03+0+80) = AX1;
    DM(a_TrigTrack04+0+80) = AX0;
    DM(a_VolTrack04+0+80) = AX1;
    DM(a_TrigTrack03+0+82) = AX0;
    DM(a_VolTrack03+0+82) = AX1;
    DM(a_TrigTrack04+0+82) = AX0;
    DM(a_VolTrack04+0+82) = AX1;
    DM(a_TrigTrack03+0+88) = AX0;
    DM(a_VolTrack03+0+88) = AX1;
    DM(a_TrigTrack04+0+88) = AX0;
    DM(a_VolTrack04+0+88) = AX1;
    DM(a_TrigTrack03+0+90) = AX0;
    DM(a_VolTrack03+0+90) = AX1;
    DM(a_TrigTrack04+0+90) = AX0;
    DM(a_VolTrack04+0+90) = AX1;
    DM(a_TrigTrack03+0+94) = AX0;
    DM(a_VolTrack03+0+94) = AX1;
    DM(a_TrigTrack04+0+94) = AX0;
    DM(a_VolTrack04+0+94) = AX1;
    DM(a_TrigTrack03+0+96) = AX0;
    DM(a_VolTrack03+0+96) = AX1;
    DM(a_TrigTrack04+0+96) = AX0;
    DM(a_VolTrack04+0+96) = AX1;
    DM(a_TrigTrack03+0+98) = AX0;
    DM(a_VolTrack03+0+98) = AX1;
    DM(a_TrigTrack04+0+98) = AX0;
    DM(a_VolTrack04+0+98) = AX1;
    DM(a_TrigTrack03+0+102) = AX0;
    DM(a_VolTrack03+0+102) = AX1;
    DM(a_TrigTrack04+0+102) = AX0;
    DM(a_VolTrack04+0+102) = AX1;
    DM(a_TrigTrack03+0+104) = AX0;
    DM(a_VolTrack03+0+104) = AX1;
    DM(a_TrigTrack04+0+104) = AX0;
    DM(a_VolTrack04+0+104) = AX1;
    DM(a_TrigTrack03+0+106) = AX0;
    DM(a_VolTrack03+0+106) = AX1;
    DM(a_TrigTrack04+0+106) = AX0;
    DM(a_VolTrack04+0+106) = AX1;
    DM(a_TrigTrack03+0+110) = AX0;
    DM(a_VolTrack03+0+110) = AX1;
    DM(a_TrigTrack04+0+110) = AX0;
    DM(a_VolTrack04+0+110) = AX1;
    DM(a_TrigTrack03+0+112) = AX0;
    DM(a_VolTrack03+0+112) = AX1;
    DM(a_TrigTrack04+0+112) = AX0;
    DM(a_VolTrack04+0+112) = AX1;
    DM(a_TrigTrack03+0+114) = AX0;
    DM(a_VolTrack03+0+114) = AX1;
    DM(a_TrigTrack04+0+114) = AX0;
    DM(a_VolTrack04+0+114) = AX1;
    DM(a_TrigTrack03+0+118) = AX0;
    DM(a_VolTrack03+0+118) = AX1;
    DM(a_TrigTrack04+0+118) = AX0;
    DM(a_VolTrack04+0+118) = AX1;
    DM(a_TrigTrack03+0+120) = AX0;
    DM(a_VolTrack03+0+120) = AX1;
    DM(a_TrigTrack04+0+120) = AX0;
    DM(a_VolTrack04+0+120) = AX1;
    DM(a_TrigTrack03+0+122) = AX0;
    DM(a_VolTrack03+0+122) = AX1;
    DM(a_TrigTrack04+0+122) = AX0;
    DM(a_VolTrack04+0+122) = AX1;

    /* inits for g */
    AX0 = 70;
    AX1 = 0x0100;
    DM(a_TrigTrack03+0+67) = AX0;
    DM(a_VolTrack03+0+67) = AX1;
    DM(a_TrigTrack04+0+67) = AX0;
    DM(a_VolTrack04+0+67) = AX1;
    DM(a_TrigTrack03+0+69) = AX0;
    DM(a_VolTrack03+0+69) = AX1;
    DM(a_TrigTrack04+0+69) = AX0;
    DM(a_VolTrack04+0+69) = AX1;
    DM(a_TrigTrack03+0+75) = AX0;
    DM(a_VolTrack03+0+75) = AX1;
    DM(a_TrigTrack04+0+75) = AX0;
    DM(a_VolTrack04+0+75) = AX1;
    DM(a_TrigTrack03+0+77) = AX0;
    DM(a_VolTrack03+0+77) = AX1;
    DM(a_TrigTrack04+0+77) = AX0;
    DM(a_VolTrack04+0+77) = AX1;
    DM(a_TrigTrack03+0+83) = AX0;
    DM(a_VolTrack03+0+83) = AX1;
    DM(a_TrigTrack04+0+83) = AX0;
    DM(a_VolTrack04+0+83) = AX1;
    DM(a_TrigTrack03+0+91) = AX0;
    DM(a_VolTrack03+0+91) = AX1;
    DM(a_TrigTrack04+0+91) = AX0;
    DM(a_VolTrack04+0+91) = AX1;
    DM(a_TrigTrack03+0+93) = AX0;
    DM(a_VolTrack03+0+93) = AX1;
    DM(a_TrigTrack04+0+93) = AX0;
    DM(a_VolTrack04+0+93) = AX1;
    DM(a_TrigTrack03+0+99) = AX0;
    DM(a_VolTrack03+0+99) = AX1;
    DM(a_TrigTrack04+0+99) = AX0;
    DM(a_VolTrack04+0+99) = AX1;
    DM(a_TrigTrack03+0+101) = AX0;
    DM(a_VolTrack03+0+101) = AX1;
    DM(a_TrigTrack04+0+101) = AX0;
    DM(a_VolTrack04+0+101) = AX1;
    DM(a_TrigTrack03+0+107) = AX0;
    DM(a_VolTrack03+0+107) = AX1;
    DM(a_TrigTrack04+0+107) = AX0;
    DM(a_VolTrack04+0+107) = AX1;
    DM(a_TrigTrack03+0+109) = AX0;
    DM(a_VolTrack03+0+109) = AX1;
    DM(a_TrigTrack04+0+109) = AX0;
    DM(a_VolTrack04+0+109) = AX1;
    DM(a_TrigTrack03+0+115) = AX0;
    DM(a_VolTrack03+0+115) = AX1;
    DM(a_TrigTrack04+0+115) = AX0;
    DM(a_VolTrack04+0+115) = AX1;
    DM(a_TrigTrack03+0+117) = AX0;
    DM(a_VolTrack03+0+117) = AX1;
    DM(a_TrigTrack04+0+117) = AX0;
    DM(a_VolTrack04+0+117) = AX1;
    DM(a_TrigTrack03+0+123) = AX0;
    DM(a_VolTrack03+0+123) = AX1;
    DM(a_TrigTrack04+0+123) = AX0;
    DM(a_VolTrack04+0+123) = AX1;
    DM(a_TrigTrack03+0+125) = AX0;
    DM(a_VolTrack03+0+125) = AX1;
    DM(a_TrigTrack04+0+125) = AX0;
    DM(a_VolTrack04+0+125) = AX1;

    /* inits for k */
    AX0 = 0;
    AX1 = 0x0000;
    DM(a_TrigTrack01+0+25) = AX0;
    DM(a_VolTrack01+0+25) = AX1;
    DM(a_TrigTrack02+0+25) = AX0;
    DM(a_VolTrack02+0+25) = AX1;
    DM(a_TrigTrack01+0+49) = AX0;
    DM(a_VolTrack01+0+49) = AX1;
    DM(a_TrigTrack02+0+49) = AX0;
    DM(a_VolTrack02+0+49) = AX1;

/* donotparse(CLEAR, 0, 1,  i-ijiji- b-ijv-i- c-iji-c- bkiji-i-  i-ijiji- b-iji-c- ikiji-ch b-i-c-hh   ----v--- b------- c-----c- b-------  -------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 2,  i-ijiji- b-ijv-i- c-iji-c- bkiji-i-  i-ijiji- b-iji-c- ikiji-ch b-i-c-hh   ----v--- b------- c-----c- b-------  -------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 3,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-fgdgf- f-egdgf- f-fgdee- f-fgdgf-  f-fgdgf- f-fgdgf- f-fgdgf- f-fgdge-,
            CLEAR, 0, 4,  ----d--- --e-d--- ----dee- ----d---  ----d--- ----d--- ----d--- ----d-e-   f-fgdgf- f-egdgf- f-fgdee- f-fgdgf-  f-fgdgf- f-fgdgf- f-fgdgf- f-fgdge-,
            b, 100, 0x2400,
            c, 100, 0x0c00,
            v, 100, 0x0800
            h, 100, 0x0600,
            i, 100, 0x0200,
            j, 70,  0x0150,
            d, 100, 0x1800,
            e, 100, 0x0c00,
            f, 100, 0x0200,
            g, 70,  0x0100,
            k, 0,   0x0000,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x0000, 1);
    SET_VOLENV(10, 0x0000, 0x0000, 1);

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ,
                 430, 30,
                 0x0e00, 0x0c00, 0x0400,
                 1, 0x6400,
                 1, 0x7c00,
                 1, 0x7f20,
                 1, 0x7fe0);

    SET_VOLENV(0, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure28:    

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack12;
    I3 = ^a_VolTrack12;
    CNTR = 128;
    do CL12377 until CE;
        DM(I2, M1) = 0;
CL12377:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack13;
    I3 = ^a_VolTrack13;
    CNTR = 128;
    do CL13377 until CE;
        DM(I2, M1) = 0;
CL13377:   DM(I3, M1) = 0;

    /* inits for m */
    AX0 = 100;
    AX1 = 0x0300;
    DM(a_TrigTrack12+0+0) = AX0;
    DM(a_VolTrack12+0+0) = AX1;
    DM(a_TrigTrack13+0+0) = AX0;
    DM(a_VolTrack13+0+0) = AX1;
    DM(a_TrigTrack12+0+16) = AX0;
    DM(a_VolTrack12+0+16) = AX1;
    DM(a_TrigTrack13+0+24) = AX0;
    DM(a_VolTrack13+0+24) = AX1;
    DM(a_TrigTrack12+0+32) = AX0;
    DM(a_VolTrack12+0+32) = AX1;
    DM(a_TrigTrack13+0+32) = AX0;
    DM(a_VolTrack13+0+32) = AX1;
    DM(a_TrigTrack13+0+48) = AX0;
    DM(a_VolTrack13+0+48) = AX1;
    DM(a_TrigTrack12+0+56) = AX0;
    DM(a_VolTrack12+0+56) = AX1;
    DM(a_TrigTrack12+0+64) = AX0;
    DM(a_VolTrack12+0+64) = AX1;
    DM(a_TrigTrack13+0+64) = AX0;
    DM(a_VolTrack13+0+64) = AX1;
    DM(a_TrigTrack12+0+80) = AX0;
    DM(a_VolTrack12+0+80) = AX1;
    DM(a_TrigTrack13+0+88) = AX0;
    DM(a_VolTrack13+0+88) = AX1;
    DM(a_TrigTrack12+0+96) = AX0;
    DM(a_VolTrack12+0+96) = AX1;
    DM(a_TrigTrack13+0+96) = AX0;
    DM(a_VolTrack13+0+96) = AX1;
    DM(a_TrigTrack13+0+112) = AX0;
    DM(a_VolTrack13+0+112) = AX1;
    DM(a_TrigTrack12+0+116) = AX0;
    DM(a_VolTrack12+0+116) = AX1;
    DM(a_TrigTrack12+0+124) = AX0;
    DM(a_VolTrack12+0+124) = AX1;
    DM(a_TrigTrack13+0+124) = AX0;
    DM(a_VolTrack13+0+124) = AX1;

    /* inits for n */
    AX0 = 100;
    AX1 = 0x0180;
    DM(a_TrigTrack13+0+120) = AX0;
    DM(a_VolTrack13+0+120) = AX1;
    DM(a_TrigTrack12+0+122) = AX0;
    DM(a_VolTrack12+0+122) = AX1;

/* donotparse(CLEAR, 0, 12, m------- -------- m------- --------  m------- -------- -------- m-------   m------- -------- m------- --------  m------- -------- ----m--- --n-m---,
            CLEAR, 0, 13, m------- -------- -------- m-------  m------- -------- m------- --------   m------- -------- -------- m-------  m------- -------- m------- n---m---,
            m, 100, 0x0300,
            n, 100, 0x0180,
            END); */

    SET_VOLENV(12, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(13, 0x0000, 0x7fff, MEASURE*4);

    jump MultiMeasureCheck;

Measure32:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00389 until CE;
        DM(I2, M1) = 0;
CL00389:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11389 until CE;
        DM(I2, M1) = 0;
CL11389:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack14;
    I3 = ^a_VolTrack14;
    CNTR = 128;
    do CL14389 until CE;
        DM(I2, M1) = 0;
CL14389:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack15;
    I3 = ^a_VolTrack15;
    CNTR = 128;
    do CL15389 until CE;
        DM(I2, M1) = 0;
CL15389:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x1000;
    DM(a_TrigTrack00+0+0) = AX0;
    DM(a_VolTrack00+0+0) = AX1;
    DM(a_TrigTrack00+0+16) = AX0;
    DM(a_VolTrack00+0+16) = AX1;
    DM(a_TrigTrack00+0+40) = AX0;
    DM(a_VolTrack00+0+40) = AX1;
    DM(a_TrigTrack00+0+56) = AX0;
    DM(a_VolTrack00+0+56) = AX1;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack00+0+30) = AX0;
    DM(a_VolTrack00+0+30) = AX1;
    DM(a_TrigTrack00+0+52) = AX0;
    DM(a_VolTrack00+0+52) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x1000;
    DM(a_TrigTrack11+0+48) = AX0;
    DM(a_VolTrack11+0+48) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x0c80;
    DM(a_TrigTrack11+0+8) = AX0;
    DM(a_VolTrack11+0+8) = AX1;
    DM(a_TrigTrack11+0+24) = AX0;
    DM(a_VolTrack11+0+24) = AX1;

    /* inits for l */
    AX0 = 100;
    AX1 = 0x0700;
    DM(a_TrigTrack11+0+36) = AX0;
    DM(a_VolTrack11+0+36) = AX1;
    DM(a_TrigTrack11+0+60) = AX0;
    DM(a_VolTrack11+0+60) = AX1;

    /* inits for n */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack14+0+16) = AX0;
    DM(a_VolTrack14+0+16) = AX1;

    /* inits for o */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack15+0+32) = AX0;
    DM(a_VolTrack15+0+32) = AX1;

/* donotparse(CLEAR, 0, 0,  a------- -------- a------- ------b-  -------- a------- ----b--- a-------,
            CLEAR, 0, 11, -------- k------- -------- k-------  ----l--- -------- j------- ----l---,
            CLEAR, 0, 14, -------- -------- n------- --------  -------- -------- -------- --------,
            CLEAR, 0, 15, -------- -------- -------- --------  o------- -------- -------- --------,
            a, 100, 0x1000,
            b, 100, 0x0800,
            j, 100, 0x1000,
            k, 100, 0x0c80,
            l, 100, 0x0700,
            n, 100, 0x0a00,
            o, 100, 0x0a00,
            END); */

    SET_VOLENV(0, 0x7fff, 0x7fff, 1);
            
    SET_VOLENV(14, 0x0000, 0x7fff, MEASURE*16);
    SET_VOLENV(15, 0x0000, 0x7fff, MEASURE*16);


/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09408 until CE;
        DM(I2, M1) = 0;
CL09408:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10408 until CE;
        DM(I2, M1) = 0;
CL10408:   DM(I3, M1) = 0;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack09+0+16) = AX0;
    DM(a_VolTrack09+0+16) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;
    DM(a_TrigTrack09+0+48) = AX0;
    DM(a_VolTrack09+0+48) = AX1;
    DM(a_TrigTrack10+0+48) = AX0;
    DM(a_VolTrack10+0+48) = AX1;
    DM(a_TrigTrack09+0+80) = AX0;
    DM(a_VolTrack09+0+80) = AX1;
    DM(a_TrigTrack10+0+80) = AX0;
    DM(a_VolTrack10+0+80) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x0000;
    DM(a_TrigTrack09+0+24) = AX0;
    DM(a_VolTrack09+0+24) = AX1;
    DM(a_TrigTrack10+0+24) = AX0;
    DM(a_VolTrack10+0+24) = AX1;
    DM(a_TrigTrack09+0+60) = AX0;
    DM(a_VolTrack09+0+60) = AX1;
    DM(a_TrigTrack10+0+60) = AX0;
    DM(a_VolTrack10+0+60) = AX1;
    DM(a_TrigTrack09+0+96) = AX0;
    DM(a_VolTrack09+0+96) = AX1;
    DM(a_TrigTrack10+0+96) = AX0;
    DM(a_VolTrack10+0+96) = AX1;

/* donotparse(CLEAR, 0, 9,  -------- -------- i------- j-------  -------- -------- i------- ----j---   -------- -------- i------- --------  j------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- j-------  -------- -------- i------- ----j---   -------- -------- i------- --------  j------- -------- -------- --------,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    SET_VOLENV(9,  0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(10, 0x0000, 0x7fff, MEASURE*4);    
   
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure40:

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00424 until CE;
        DM(I2, M1) = 0;
CL00424:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11424 until CE;
        DM(I2, M1) = 0;
CL11424:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x3000;
    DM(a_TrigTrack00+0+4) = AX0;
    DM(a_VolTrack00+0+4) = AX1;
    DM(a_TrigTrack00+0+8) = AX0;
    DM(a_VolTrack00+0+8) = AX1;
    DM(a_TrigTrack00+0+20) = AX0;
    DM(a_VolTrack00+0+20) = AX1;
    DM(a_TrigTrack00+0+24) = AX0;
    DM(a_VolTrack00+0+24) = AX1;
    DM(a_TrigTrack00+0+32) = AX0;
    DM(a_VolTrack00+0+32) = AX1;
    DM(a_TrigTrack00+0+42) = AX0;
    DM(a_VolTrack00+0+42) = AX1;
    DM(a_TrigTrack00+0+46) = AX0;
    DM(a_VolTrack00+0+46) = AX1;
    DM(a_TrigTrack00+0+56) = AX0;
    DM(a_VolTrack00+0+56) = AX1;

    /* inits for b */
    AX0 = 75;
    AX1 = 0x2000;
    DM(a_TrigTrack00+0+30) = AX0;
    DM(a_VolTrack00+0+30) = AX1;
    DM(a_TrigTrack00+0+52) = AX0;
    DM(a_VolTrack00+0+52) = AX1;
    DM(a_TrigTrack00+0+60) = AX0;
    DM(a_VolTrack00+0+60) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x1600;
    DM(a_TrigTrack11+0+0) = AX0;
    DM(a_VolTrack11+0+0) = AX1;
    DM(a_TrigTrack11+0+22) = AX0;
    DM(a_VolTrack11+0+22) = AX1;
    DM(a_TrigTrack11+0+32) = AX0;
    DM(a_VolTrack11+0+32) = AX1;
    DM(a_TrigTrack11+0+48) = AX0;
    DM(a_VolTrack11+0+48) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x0f00;
    DM(a_TrigTrack11+0+10) = AX0;
    DM(a_VolTrack11+0+10) = AX1;
    DM(a_TrigTrack11+0+16) = AX0;
    DM(a_VolTrack11+0+16) = AX1;
    DM(a_TrigTrack11+0+40) = AX0;
    DM(a_VolTrack11+0+40) = AX1;
    DM(a_TrigTrack11+0+56) = AX0;
    DM(a_VolTrack11+0+56) = AX1;

    /* inits for l */
    AX0 = 75;
    AX1 = 0x0a00;
    DM(a_TrigTrack11+0+4) = AX0;
    DM(a_VolTrack11+0+4) = AX1;
    DM(a_TrigTrack11+0+12) = AX0;
    DM(a_VolTrack11+0+12) = AX1;
    DM(a_TrigTrack11+0+28) = AX0;
    DM(a_VolTrack11+0+28) = AX1;
    DM(a_TrigTrack11+0+36) = AX0;
    DM(a_VolTrack11+0+36) = AX1;
    DM(a_TrigTrack11+0+44) = AX0;
    DM(a_VolTrack11+0+44) = AX1;
    DM(a_TrigTrack11+0+60) = AX0;
    DM(a_VolTrack11+0+60) = AX1;

    /* inits for m */
    AX0 = 50;
    AX1 = 0x0600;
    DM(a_TrigTrack11+0+38) = AX0;
    DM(a_VolTrack11+0+38) = AX1;
    DM(a_TrigTrack11+0+62) = AX0;
    DM(a_VolTrack11+0+62) = AX1;

/* donotparse(CLEAR, 0, 0,  ----a--- a------- ----a--- a-----b-  a------- --a---a- ----b--- a---b---,
            CLEAR, 0, 11, j---l--- --k-l--- k-----j- ----l---  j---l-m- k---l--- j------- k---l-m-,
            a, 100, 0x3000,
            b, 75,  0x2000,
            j, 100, 0x1600,
            k, 100, 0x0f00,
            l, 75,  0x0a00,
            m, 50,  0x0600,
            END); */

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ,
                 400, 50,
                 0x1000, 0x0c00, 0x0400,
                 1, 0x6800,
                 1, 0x7c00,
                 1, 0x7f00,
                 1, 0x7fc0);            

    SET_VOLENV(0, 0x0000, 0x7fff, MEASURE*8);
    SET_VOLENV(11, 0x0000, 0x7fff, MEASURE*8);
    
    AX0 = 24*8;
    DM(a_LFO+(6*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(7*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure44:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack12;
    I3 = ^a_VolTrack12;
    CNTR = 128;
    do CL12453 until CE;
        DM(I2, M1) = 0;
CL12453:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack13;
    I3 = ^a_VolTrack13;
    CNTR = 128;
    do CL13453 until CE;
        DM(I2, M1) = 0;
CL13453:   DM(I3, M1) = 0;

    /* inits for m */
    AX0 = 100;
    AX1 = 0x0400;
    DM(a_TrigTrack12+0+0) = AX0;
    DM(a_VolTrack12+0+0) = AX1;
    DM(a_TrigTrack13+0+0) = AX0;
    DM(a_VolTrack13+0+0) = AX1;
    DM(a_TrigTrack12+0+16) = AX0;
    DM(a_VolTrack12+0+16) = AX1;
    DM(a_TrigTrack13+0+24) = AX0;
    DM(a_VolTrack13+0+24) = AX1;
    DM(a_TrigTrack12+0+32) = AX0;
    DM(a_VolTrack12+0+32) = AX1;
    DM(a_TrigTrack13+0+32) = AX0;
    DM(a_VolTrack13+0+32) = AX1;
    DM(a_TrigTrack13+0+48) = AX0;
    DM(a_VolTrack13+0+48) = AX1;
    DM(a_TrigTrack12+0+56) = AX0;
    DM(a_VolTrack12+0+56) = AX1;
    DM(a_TrigTrack12+0+64) = AX0;
    DM(a_VolTrack12+0+64) = AX1;
    DM(a_TrigTrack13+0+64) = AX0;
    DM(a_VolTrack13+0+64) = AX1;
    DM(a_TrigTrack12+0+80) = AX0;
    DM(a_VolTrack12+0+80) = AX1;
    DM(a_TrigTrack13+0+88) = AX0;
    DM(a_VolTrack13+0+88) = AX1;
    DM(a_TrigTrack12+0+96) = AX0;
    DM(a_VolTrack12+0+96) = AX1;
    DM(a_TrigTrack13+0+96) = AX0;
    DM(a_VolTrack13+0+96) = AX1;
    DM(a_TrigTrack13+0+112) = AX0;
    DM(a_VolTrack13+0+112) = AX1;
    DM(a_TrigTrack12+0+116) = AX0;
    DM(a_VolTrack12+0+116) = AX1;
    DM(a_TrigTrack12+0+124) = AX0;
    DM(a_VolTrack12+0+124) = AX1;
    DM(a_TrigTrack13+0+124) = AX0;
    DM(a_VolTrack13+0+124) = AX1;

    /* inits for n */
    AX0 = 100;
    AX1 = 0x0300;
    DM(a_TrigTrack13+0+120) = AX0;
    DM(a_VolTrack13+0+120) = AX1;
    DM(a_TrigTrack12+0+122) = AX0;
    DM(a_VolTrack12+0+122) = AX1;

    /* inits for o */
    AX0 = 100;
    AX1 = 0x0280;
    DM(a_TrigTrack12+0+4) = AX0;
    DM(a_VolTrack12+0+4) = AX1;
    DM(a_TrigTrack13+0+6) = AX0;
    DM(a_VolTrack13+0+6) = AX1;
    DM(a_TrigTrack13+0+10) = AX0;
    DM(a_VolTrack13+0+10) = AX1;
    DM(a_TrigTrack12+0+12) = AX0;
    DM(a_VolTrack12+0+12) = AX1;
    DM(a_TrigTrack13+0+20) = AX0;
    DM(a_VolTrack13+0+20) = AX1;
    DM(a_TrigTrack12+0+22) = AX0;
    DM(a_VolTrack12+0+22) = AX1;
    DM(a_TrigTrack13+0+28) = AX0;
    DM(a_VolTrack13+0+28) = AX1;
    DM(a_TrigTrack12+0+36) = AX0;
    DM(a_VolTrack12+0+36) = AX1;
    DM(a_TrigTrack13+0+38) = AX0;
    DM(a_VolTrack13+0+38) = AX1;
    DM(a_TrigTrack13+0+52) = AX0;
    DM(a_VolTrack13+0+52) = AX1;
    DM(a_TrigTrack12+0+60) = AX0;
    DM(a_VolTrack12+0+60) = AX1;
    DM(a_TrigTrack12+0+68) = AX0;
    DM(a_VolTrack12+0+68) = AX1;
    DM(a_TrigTrack13+0+72) = AX0;
    DM(a_VolTrack13+0+72) = AX1;
    DM(a_TrigTrack13+0+92) = AX0;
    DM(a_VolTrack13+0+92) = AX1;
    DM(a_TrigTrack12+0+98) = AX0;
    DM(a_VolTrack12+0+98) = AX1;
    DM(a_TrigTrack13+0+102) = AX0;
    DM(a_VolTrack13+0+102) = AX1;
    DM(a_TrigTrack13+0+108) = AX0;
    DM(a_VolTrack13+0+108) = AX1;

    /* inits for p */
    AX0 = 100;
    AX1 = 0x0200;
    DM(a_TrigTrack12+0+25) = AX0;
    DM(a_VolTrack12+0+25) = AX1;
    DM(a_TrigTrack13+0+26) = AX0;
    DM(a_VolTrack13+0+26) = AX1;
    DM(a_TrigTrack12+0+40) = AX0;
    DM(a_VolTrack12+0+40) = AX1;
    DM(a_TrigTrack13+0+40) = AX0;
    DM(a_VolTrack13+0+40) = AX1;
    DM(a_TrigTrack12+0+41) = AX0;
    DM(a_VolTrack12+0+41) = AX1;
    DM(a_TrigTrack13+0+41) = AX0;
    DM(a_VolTrack13+0+41) = AX1;
    DM(a_TrigTrack12+0+74) = AX0;
    DM(a_VolTrack12+0+74) = AX1;
    DM(a_TrigTrack13+0+74) = AX0;
    DM(a_VolTrack13+0+74) = AX1;
    DM(a_TrigTrack12+0+75) = AX0;
    DM(a_VolTrack12+0+75) = AX1;
    DM(a_TrigTrack13+0+75) = AX0;
    DM(a_VolTrack13+0+75) = AX1;
    DM(a_TrigTrack12+0+86) = AX0;
    DM(a_VolTrack12+0+86) = AX1;
    DM(a_TrigTrack12+0+87) = AX0;
    DM(a_VolTrack12+0+87) = AX1;
    DM(a_TrigTrack12+0+110) = AX0;
    DM(a_VolTrack12+0+110) = AX1;
    DM(a_TrigTrack12+0+111) = AX0;
    DM(a_VolTrack12+0+111) = AX1;

/* donotparse(CLEAR, 0, 12, m---o--- ----o--- m-----o- -p------  m---o--- pp------ -------- m---o---   m---o--- --pp---- m-----pp --------  m-o----- ------pp ----m--- --n-m---,
            CLEAR, 0, 13, m-----o- --o----- ----o--- m-p-o---  m-----o- pp------ m---o--- --------   m------- o-pp---- -------- m---o---  m-----o- ----o--- m------- n---m---,
            m, 100, 0x0400,
            n, 100, 0x0300,
            o, 100, 0x0280,
            p, 100, 0x0200,
            END); */

    SET_VOLENV(12, 0x0000, 0x7fff, MEASURE*4);
    SET_VOLENV(13, 0x0000, 0x7fff, MEASURE*4);
    
    DM(v_IncFMFreq) = M1;

    jump MultiMeasureCheck;
    
Measure48:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack05;
    I3 = ^a_VolTrack05;
    CNTR = 128;
    do CL05469 until CE;
        DM(I2, M1) = 0;
CL05469:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack06;
    I3 = ^a_VolTrack06;
    CNTR = 128;
    do CL06469 until CE;
        DM(I2, M1) = 0;
CL06469:   DM(I3, M1) = 0;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack05+0+8) = AX0;
    DM(a_VolTrack05+0+8) = AX1;
    DM(a_TrigTrack06+0+8) = AX0;
    DM(a_VolTrack06+0+8) = AX1;
    DM(a_TrigTrack05+0+24) = AX0;
    DM(a_VolTrack05+0+24) = AX1;
    DM(a_TrigTrack06+0+24) = AX0;
    DM(a_VolTrack06+0+24) = AX1;
    DM(a_TrigTrack05+0+40) = AX0;
    DM(a_VolTrack05+0+40) = AX1;
    DM(a_TrigTrack06+0+40) = AX0;
    DM(a_VolTrack06+0+40) = AX1;
    DM(a_TrigTrack05+0+56) = AX0;
    DM(a_VolTrack05+0+56) = AX1;
    DM(a_TrigTrack06+0+56) = AX0;
    DM(a_VolTrack06+0+56) = AX1;
    DM(a_TrigTrack05+0+60) = AX0;
    DM(a_VolTrack05+0+60) = AX1;
    DM(a_TrigTrack06+0+60) = AX0;
    DM(a_VolTrack06+0+60) = AX1;

/* donotparse(CLEAR, 0, 5,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            CLEAR, 0, 6,  -------- f------- -------- f-------  -------- f------- -------- f---f---,
            f, 100, 0x0c00,
            END); */


/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09475 until CE;
        DM(I2, M1) = 0;
CL09475:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10475 until CE;
        DM(I2, M1) = 0;
CL10475:   DM(I3, M1) = 0;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack09+0+16) = AX0;
    DM(a_VolTrack09+0+16) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;
    DM(a_TrigTrack09+0+32) = AX0;
    DM(a_VolTrack09+0+32) = AX1;
    DM(a_TrigTrack10+0+32) = AX0;
    DM(a_VolTrack10+0+32) = AX1;
    DM(a_TrigTrack09+0+44) = AX0;
    DM(a_VolTrack09+0+44) = AX1;
    DM(a_TrigTrack10+0+44) = AX0;
    DM(a_VolTrack10+0+44) = AX1;
    DM(a_TrigTrack09+0+72) = AX0;
    DM(a_VolTrack09+0+72) = AX1;
    DM(a_TrigTrack10+0+72) = AX0;
    DM(a_VolTrack10+0+72) = AX1;
    DM(a_TrigTrack09+0+96) = AX0;
    DM(a_VolTrack09+0+96) = AX1;
    DM(a_TrigTrack10+0+96) = AX0;
    DM(a_VolTrack10+0+96) = AX1;
    DM(a_TrigTrack09+0+112) = AX0;
    DM(a_VolTrack09+0+112) = AX1;
    DM(a_TrigTrack10+0+112) = AX0;
    DM(a_VolTrack10+0+112) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x0000;
    DM(a_TrigTrack09+0+24) = AX0;
    DM(a_VolTrack09+0+24) = AX1;
    DM(a_TrigTrack10+0+24) = AX0;
    DM(a_VolTrack10+0+24) = AX1;
    DM(a_TrigTrack09+0+60) = AX0;
    DM(a_VolTrack09+0+60) = AX1;
    DM(a_TrigTrack10+0+60) = AX0;
    DM(a_VolTrack10+0+60) = AX1;
    DM(a_TrigTrack09+0+80) = AX0;
    DM(a_VolTrack09+0+80) = AX1;
    DM(a_TrigTrack10+0+80) = AX0;
    DM(a_VolTrack10+0+80) = AX1;
    DM(a_TrigTrack09+0+108) = AX0;
    DM(a_VolTrack09+0+108) = AX1;
    DM(a_TrigTrack10+0+108) = AX0;
    DM(a_VolTrack10+0+108) = AX1;
    DM(a_TrigTrack09+0+124) = AX0;
    DM(a_VolTrack09+0+124) = AX1;
    DM(a_TrigTrack10+0+124) = AX0;
    DM(a_VolTrack10+0+124) = AX1;

/* donotparse(CLEAR, 0, 9,  -------- -------- i------- j-------  i------- ----i--- -------- ----j---   -------- i------- j------- --------  i------- ----j--- i------- ----j---,
            CLEAR, 0, 10, -------- -------- i------- j-------  i------- ----i--- -------- ----j---   -------- i------- j------- --------  i------- ----j--- i------- ----j---,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    AX0 = 24*8;
    DM(a_LFO+(4*LFO_VARS)+LFO_HOLDPER) = AX0;
    AX0 = 24*6;
    DM(a_LFO+(5*LFO_VARS)+LFO_HOLDPER) = AX0;

    AX0 = 128*32;
    DM(a_LFO+(8*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(12*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_FREQ) = AX0;
    
    AR = 0x0c00;
    DM(a_MemEnv3+(4*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(4*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(5*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(5*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(6*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(6*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(7*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(7*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(8*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(8*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(9*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(9*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(10*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(10*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    DM(a_MemEnv3+(11*MEMENV3_VARS)+MEMENV3_EA) = AR;
    DM(a_MemEnv3+(11*MEMENV3_VARS)+MEMENV3_ED) = AR;
    
    RESET_MEMENV3(4);
    RESET_MEMENV3(5);
    RESET_MEMENV3(6);
    RESET_MEMENV3(7);
    
    RESET_MEMENV3(8);
    RESET_MEMENV3(9);
    RESET_MEMENV3(10);
    RESET_MEMENV3(11);

    jump MultiMeasureCheck;

Measure56:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack07;
    I3 = ^a_VolTrack07;
    CNTR = 128;
    do CL07534 until CE;
        DM(I2, M1) = 0;
CL07534:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack08;
    I3 = ^a_VolTrack08;
    CNTR = 128;
    do CL08534 until CE;
        DM(I2, M1) = 0;
CL08534:   DM(I3, M1) = 0;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack07+0+0) = AX0;
    DM(a_VolTrack07+0+0) = AX1;
    DM(a_TrigTrack08+0+0) = AX0;
    DM(a_VolTrack08+0+0) = AX1;
    DM(a_TrigTrack07+0+8) = AX0;
    DM(a_VolTrack07+0+8) = AX1;
    DM(a_TrigTrack08+0+8) = AX0;
    DM(a_VolTrack08+0+8) = AX1;
    DM(a_TrigTrack07+0+12) = AX0;
    DM(a_VolTrack07+0+12) = AX1;
    DM(a_TrigTrack08+0+12) = AX0;
    DM(a_VolTrack08+0+12) = AX1;
    DM(a_TrigTrack07+0+16) = AX0;
    DM(a_VolTrack07+0+16) = AX1;
    DM(a_TrigTrack08+0+16) = AX0;
    DM(a_VolTrack08+0+16) = AX1;
    DM(a_TrigTrack07+0+28) = AX0;
    DM(a_VolTrack07+0+28) = AX1;
    DM(a_TrigTrack08+0+28) = AX0;
    DM(a_VolTrack08+0+28) = AX1;
    DM(a_TrigTrack07+0+32) = AX0;
    DM(a_VolTrack07+0+32) = AX1;
    DM(a_TrigTrack08+0+32) = AX0;
    DM(a_VolTrack08+0+32) = AX1;
    DM(a_TrigTrack07+0+40) = AX0;
    DM(a_VolTrack07+0+40) = AX1;
    DM(a_TrigTrack08+0+40) = AX0;
    DM(a_VolTrack08+0+40) = AX1;
    DM(a_TrigTrack07+0+48) = AX0;
    DM(a_VolTrack07+0+48) = AX1;
    DM(a_TrigTrack08+0+48) = AX0;
    DM(a_VolTrack08+0+48) = AX1;
    DM(a_TrigTrack07+0+52) = AX0;
    DM(a_VolTrack07+0+52) = AX1;
    DM(a_TrigTrack08+0+52) = AX0;
    DM(a_VolTrack08+0+52) = AX1;
    DM(a_TrigTrack07+0+60) = AX0;
    DM(a_VolTrack07+0+60) = AX1;
    DM(a_TrigTrack08+0+60) = AX0;
    DM(a_VolTrack08+0+60) = AX1;

/* donotparse(CLEAR, 0, 7,  g------- g---g--- g------- ----g---  g------- g------- g---g--- ----g---,
            CLEAR, 0, 8,  g------- g---g--- g------- ----g---  g------- g-------,
            g, 100, 0x0c00,
            END); */

    SET_VOLENV(0, 0x0000, 0x0000, 1);
    SET_VOLENV(1, 0x0000, 0x0000, 1);
    SET_VOLENV(2, 0x0000, 0x0000, 1);
    SET_VOLENV(3, 0x0000, 0x0000, 1);
    SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(11, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);

    SET_VOLENV(7, 0x0000, 0x3fff, MEASURE*4);
    SET_VOLENV(8, 0x0000, 0x3fff, MEASURE*4);
    
    jump MultiMeasureCheck;

Measure60:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack07;
    I3 = ^a_VolTrack07;
    CNTR = 128;
    do CL07554 until CE;
        DM(I2, M1) = 0;
CL07554:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack08;
    I3 = ^a_VolTrack08;
    CNTR = 128;
    do CL08554 until CE;
        DM(I2, M1) = 0;
CL08554:   DM(I3, M1) = 0;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack07+0+0) = AX0;
    DM(a_VolTrack07+0+0) = AX1;
    DM(a_TrigTrack08+0+0) = AX0;
    DM(a_VolTrack08+0+0) = AX1;
    DM(a_TrigTrack07+0+12) = AX0;
    DM(a_VolTrack07+0+12) = AX1;
    DM(a_TrigTrack08+0+12) = AX0;
    DM(a_VolTrack08+0+12) = AX1;
    DM(a_TrigTrack07+0+28) = AX0;
    DM(a_VolTrack07+0+28) = AX1;
    DM(a_TrigTrack08+0+28) = AX0;
    DM(a_VolTrack08+0+28) = AX1;
    DM(a_TrigTrack07+0+32) = AX0;
    DM(a_VolTrack07+0+32) = AX1;
    DM(a_TrigTrack08+0+32) = AX0;
    DM(a_VolTrack08+0+32) = AX1;
    DM(a_TrigTrack07+0+36) = AX0;
    DM(a_VolTrack07+0+36) = AX1;
    DM(a_TrigTrack08+0+36) = AX0;
    DM(a_VolTrack08+0+36) = AX1;
    DM(a_TrigTrack07+0+48) = AX0;
    DM(a_VolTrack07+0+48) = AX1;
    DM(a_TrigTrack08+0+48) = AX0;
    DM(a_VolTrack08+0+48) = AX1;
    DM(a_TrigTrack07+0+60) = AX0;
    DM(a_VolTrack07+0+60) = AX1;
    DM(a_TrigTrack08+0+60) = AX0;
    DM(a_VolTrack08+0+60) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack07+0+6) = AX0;
    DM(a_VolTrack07+0+6) = AX1;
    DM(a_TrigTrack08+0+6) = AX0;
    DM(a_VolTrack08+0+6) = AX1;
    DM(a_TrigTrack07+0+20) = AX0;
    DM(a_VolTrack07+0+20) = AX1;
    DM(a_TrigTrack08+0+20) = AX0;
    DM(a_VolTrack08+0+20) = AX1;
    DM(a_TrigTrack07+0+41) = AX0;
    DM(a_VolTrack07+0+41) = AX1;
    DM(a_TrigTrack08+0+41) = AX0;
    DM(a_VolTrack08+0+41) = AX1;
    DM(a_TrigTrack07+0+54) = AX0;
    DM(a_VolTrack07+0+54) = AX1;
    DM(a_TrigTrack08+0+54) = AX0;
    DM(a_VolTrack08+0+54) = AX1;

/* donotparse(CLEAR, 0, 7,  g-----h- ----g--- ----h--- ----g---  g---g--- -h------ g-----h- ----g---,
            CLEAR, 0, 8,  g-----h- ----g--- ----h--- ----g---  g---g--- -h------,
            g, 100, 0x0c00,
            h, 100, 0x0800,
            END); */

    SET_VOLENV(7, 0x6000, 0x6000, 1);
    SET_VOLENV(8, 0x6000, 0x6000, 1);
    
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;


Measure62:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack07;
    I3 = ^a_VolTrack07;
    CNTR = 128;
    do CL07570 until CE;
        DM(I2, M1) = 0;
CL07570:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack08;
    I3 = ^a_VolTrack08;
    CNTR = 128;
    do CL08570 until CE;
        DM(I2, M1) = 0;
CL08570:   DM(I3, M1) = 0;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack07+0+0) = AX0;
    DM(a_VolTrack07+0+0) = AX1;
    DM(a_TrigTrack08+0+0) = AX0;
    DM(a_VolTrack08+0+0) = AX1;
    DM(a_TrigTrack07+0+12) = AX0;
    DM(a_VolTrack07+0+12) = AX1;
    DM(a_TrigTrack08+0+12) = AX0;
    DM(a_VolTrack08+0+12) = AX1;
    DM(a_TrigTrack07+0+28) = AX0;
    DM(a_VolTrack07+0+28) = AX1;
    DM(a_TrigTrack08+0+28) = AX0;
    DM(a_VolTrack08+0+28) = AX1;
    DM(a_TrigTrack07+0+32) = AX0;
    DM(a_VolTrack07+0+32) = AX1;
    DM(a_TrigTrack08+0+32) = AX0;
    DM(a_VolTrack08+0+32) = AX1;
    DM(a_TrigTrack07+0+36) = AX0;
    DM(a_VolTrack07+0+36) = AX1;
    DM(a_TrigTrack08+0+36) = AX0;
    DM(a_VolTrack08+0+36) = AX1;
    DM(a_TrigTrack07+0+48) = AX0;
    DM(a_VolTrack07+0+48) = AX1;
    DM(a_TrigTrack08+0+48) = AX0;
    DM(a_VolTrack08+0+48) = AX1;
    DM(a_TrigTrack07+0+60) = AX0;
    DM(a_VolTrack07+0+60) = AX1;
    DM(a_TrigTrack08+0+60) = AX0;
    DM(a_VolTrack08+0+60) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack07+0+6) = AX0;
    DM(a_VolTrack07+0+6) = AX1;
    DM(a_TrigTrack08+0+6) = AX0;
    DM(a_VolTrack08+0+6) = AX1;
    DM(a_TrigTrack07+0+20) = AX0;
    DM(a_VolTrack07+0+20) = AX1;
    DM(a_TrigTrack08+0+20) = AX0;
    DM(a_VolTrack08+0+20) = AX1;
    DM(a_TrigTrack07+0+41) = AX0;
    DM(a_VolTrack07+0+41) = AX1;
    DM(a_TrigTrack08+0+41) = AX0;
    DM(a_VolTrack08+0+41) = AX1;
    DM(a_TrigTrack07+0+54) = AX0;
    DM(a_VolTrack07+0+54) = AX1;
    DM(a_TrigTrack08+0+54) = AX0;
    DM(a_VolTrack08+0+54) = AX1;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0500;
    DM(a_TrigTrack07+0+16) = AX0;
    DM(a_VolTrack07+0+16) = AX1;
    DM(a_TrigTrack08+0+16) = AX0;
    DM(a_VolTrack08+0+16) = AX1;
    DM(a_TrigTrack07+0+56) = AX0;
    DM(a_VolTrack07+0+56) = AX1;
    DM(a_TrigTrack08+0+56) = AX0;
    DM(a_VolTrack08+0+56) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x0300;

/* donotparse(CLEAR, 0, 7,  g-----h- ----g--- i---h--- ----g---  g---g--- -h------ g-----h- i---g---,
            CLEAR, 0, 8,  g-----h- ----g--- i---h--- ----g---  g---g--- -h------,
            g, 100, 0x0c00,
            h, 100, 0x0800,
            i, 100, 0x0500,
            j, 100, 0x0300,
            END); */

    SET_VOLENV(7, 0x6000, 0x6000, 1);
    SET_VOLENV(8, 0x6000, 0x6000, 1);
    
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(9,  0x4000, 0x0000, MEASURE*2);
    SET_VOLENV(10, 0x4000, 0x0000, MEASURE*2);
    SET_VOLENV(14, 0x0000, 0x0000, 1);
    SET_VOLENV(15, 0x0000, 0x0000, 1);
    
    jump MultiMeasureCheck;

Measure64:
/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00591 until CE;
        DM(I2, M1) = 0;
CL00591:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11591 until CE;
        DM(I2, M1) = 0;
CL11591:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x4000;
    DM(a_TrigTrack00+0+8) = AX0;
    DM(a_VolTrack00+0+8) = AX1;
    DM(a_TrigTrack00+0+20) = AX0;
    DM(a_VolTrack00+0+20) = AX1;
    DM(a_TrigTrack00+0+32) = AX0;
    DM(a_VolTrack00+0+32) = AX1;
    DM(a_TrigTrack00+0+46) = AX0;
    DM(a_VolTrack00+0+46) = AX1;
    DM(a_TrigTrack00+0+56) = AX0;
    DM(a_VolTrack00+0+56) = AX1;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x2000;
    DM(a_TrigTrack00+0+4) = AX0;
    DM(a_VolTrack00+0+4) = AX1;
    DM(a_TrigTrack00+0+12) = AX0;
    DM(a_VolTrack00+0+12) = AX1;
    DM(a_TrigTrack00+0+22) = AX0;
    DM(a_VolTrack00+0+22) = AX1;
    DM(a_TrigTrack00+0+30) = AX0;
    DM(a_VolTrack00+0+30) = AX1;
    DM(a_TrigTrack00+0+34) = AX0;
    DM(a_VolTrack00+0+34) = AX1;
    DM(a_TrigTrack00+0+42) = AX0;
    DM(a_VolTrack00+0+42) = AX1;
    DM(a_TrigTrack00+0+52) = AX0;
    DM(a_VolTrack00+0+52) = AX1;
    DM(a_TrigTrack00+0+62) = AX0;
    DM(a_VolTrack00+0+62) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x1600;
    DM(a_TrigTrack11+0+0) = AX0;
    DM(a_VolTrack11+0+0) = AX1;
    DM(a_TrigTrack11+0+8) = AX0;
    DM(a_VolTrack11+0+8) = AX1;
    DM(a_TrigTrack11+0+16) = AX0;
    DM(a_VolTrack11+0+16) = AX1;
    DM(a_TrigTrack11+0+22) = AX0;
    DM(a_VolTrack11+0+22) = AX1;
    DM(a_TrigTrack11+0+24) = AX0;
    DM(a_VolTrack11+0+24) = AX1;
    DM(a_TrigTrack11+0+32) = AX0;
    DM(a_VolTrack11+0+32) = AX1;
    DM(a_TrigTrack11+0+48) = AX0;
    DM(a_VolTrack11+0+48) = AX1;
    DM(a_TrigTrack11+0+52) = AX0;
    DM(a_VolTrack11+0+52) = AX1;
    DM(a_TrigTrack11+0+56) = AX0;
    DM(a_VolTrack11+0+56) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x0f00;
    DM(a_TrigTrack11+0+2) = AX0;
    DM(a_VolTrack11+0+2) = AX1;
    DM(a_TrigTrack11+0+6) = AX0;
    DM(a_VolTrack11+0+6) = AX1;
    DM(a_TrigTrack11+0+18) = AX0;
    DM(a_VolTrack11+0+18) = AX1;

    /* inits for l */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack11+0+12) = AX0;
    DM(a_VolTrack11+0+12) = AX1;
    DM(a_TrigTrack11+0+28) = AX0;
    DM(a_VolTrack11+0+28) = AX1;
    DM(a_TrigTrack11+0+36) = AX0;
    DM(a_VolTrack11+0+36) = AX1;
    DM(a_TrigTrack11+0+44) = AX0;
    DM(a_VolTrack11+0+44) = AX1;
    DM(a_TrigTrack11+0+60) = AX0;
    DM(a_VolTrack11+0+60) = AX1;

    /* inits for m */
    AX0 = 100;
    AX1 = 0x0700;
    DM(a_TrigTrack11+0+38) = AX0;
    DM(a_VolTrack11+0+38) = AX1;
    DM(a_TrigTrack11+0+39) = AX0;
    DM(a_VolTrack11+0+39) = AX1;
    DM(a_TrigTrack11+0+61) = AX0;
    DM(a_VolTrack11+0+61) = AX1;
    DM(a_TrigTrack11+0+62) = AX0;
    DM(a_VolTrack11+0+62) = AX1;
    DM(a_TrigTrack11+0+63) = AX0;
    DM(a_VolTrack11+0+63) = AX1;

/* donotparse(CLEAR, 0, 0,  ----b--- a---b--- ----a-b- ------b-  a-b----- --b---a- ----b--- a-----b-,
            CLEAR, 0, 11, j-k---k- j---l--- j-k---j- j---l---  j---l-mm ----l--- j---j--- j---lmmm,
            a, 100, 0x4000,
            b, 100, 0x2000,
            j, 100, 0x1600,
            k, 100, 0x0f00,
            l, 100, 0x0a00,
            m, 100, 0x0700,
            END); */


/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09602 until CE;
        DM(I2, M1) = 0;
CL09602:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10602 until CE;
        DM(I2, M1) = 0;
CL10602:   DM(I3, M1) = 0;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack09+0+16) = AX0;
    DM(a_VolTrack09+0+16) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;

/* donotparse(CLEAR, 0, 9,  -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            CLEAR, 0, 10, -------- -------- i------- --------  -------- -------- -------- --------   -------- -------- -------- --------  -------- -------- -------- --------,
            i, 100, 0x0c00,
            END); */
            
    SET_VOLENV(9,  0x7fff, 0x7fff, 1);
    SET_VOLENV(10, 0x7fff, 0x7fff, 1);

    SET_VOLENV(0, 0x7fff, 0x7fff, 1);
    SET_VOLENV(1, 0x7fff, 0x7fff, 1);
    SET_VOLENV(2, 0x7fff, 0x7fff, 1);
    SET_VOLENV(3, 0x7fff, 0x7fff, 1);
    SET_VOLENV(4, 0x7fff, 0x7fff, 1);
    SET_VOLENV(5, 0x7fff, 0x7fff, 1);
    SET_VOLENV(6, 0x7fff, 0x7fff, 1);
    SET_VOLENV(7, 0x7fff, 0x7fff, 1);
    SET_VOLENV(8, 0x7fff, 0x7fff, 1);
    SET_VOLENV(9, 0x7fff, 0x7fff, 1);
    SET_VOLENV(10, 0x7fff, 0x7fff, 1);
    SET_VOLENV(11, 0x7fff, 0x7fff, 1);
    SET_VOLENV(12, 0x7fff, 0x7fff, 1);
    SET_VOLENV(13, 0x7fff, 0x7fff, 1);
    SET_VOLENV(14, 0x7fff, 0x7fff, 1);
    SET_VOLENV(15, 0x7fff, 0x7fff, 1);
    
    AX0 = 128*64;
    DM(a_LFO+(8*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(12*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_FREQ) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_FREQ) = AX0;

    jump MultiMeasureCheck;

Measure72:

    !SET_VOLENV(1, 0x0000, 0x0000, 1);
    !SET_VOLENV(2, 0x0000, 0x0000, 1);
    !SET_VOLENV(3, 0x0000, 0x0000, 1);
    !SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);


/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01651 until CE;
        DM(I2, M1) = 0;
CL01651:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02651 until CE;
        DM(I2, M1) = 0;
CL02651:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03651 until CE;
        DM(I2, M1) = 0;
CL03651:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04651 until CE;
        DM(I2, M1) = 0;
CL04651:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack09;
    I3 = ^a_VolTrack09;
    CNTR = 128;
    do CL09651 until CE;
        DM(I2, M1) = 0;
CL09651:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10651 until CE;
        DM(I2, M1) = 0;
CL10651:   DM(I3, M1) = 0;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x1400;
    DM(a_TrigTrack01+0+8) = AX0;
    DM(a_VolTrack01+0+8) = AX1;
    DM(a_TrigTrack02+0+8) = AX0;
    DM(a_VolTrack02+0+8) = AX1;
    DM(a_TrigTrack01+0+24) = AX0;
    DM(a_VolTrack01+0+24) = AX1;
    DM(a_TrigTrack02+0+24) = AX0;
    DM(a_VolTrack02+0+24) = AX1;
    DM(a_TrigTrack01+0+40) = AX0;
    DM(a_VolTrack01+0+40) = AX1;
    DM(a_TrigTrack02+0+40) = AX0;
    DM(a_VolTrack02+0+40) = AX1;
    DM(a_TrigTrack01+0+58) = AX0;
    DM(a_VolTrack01+0+58) = AX1;
    DM(a_TrigTrack02+0+58) = AX0;
    DM(a_VolTrack02+0+58) = AX1;
    DM(a_TrigTrack01+0+72) = AX0;
    DM(a_VolTrack01+0+72) = AX1;
    DM(a_TrigTrack02+0+72) = AX0;
    DM(a_VolTrack02+0+72) = AX1;
    DM(a_TrigTrack01+0+86) = AX0;
    DM(a_VolTrack01+0+86) = AX1;
    DM(a_TrigTrack02+0+86) = AX0;
    DM(a_VolTrack02+0+86) = AX1;
    DM(a_TrigTrack01+0+104) = AX0;
    DM(a_VolTrack01+0+104) = AX1;
    DM(a_TrigTrack02+0+104) = AX0;
    DM(a_VolTrack02+0+104) = AX1;
    DM(a_TrigTrack01+0+120) = AX0;
    DM(a_VolTrack01+0+120) = AX1;
    DM(a_TrigTrack02+0+120) = AX0;
    DM(a_VolTrack02+0+120) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack01+0+16) = AX0;
    DM(a_VolTrack01+0+16) = AX1;
    DM(a_TrigTrack02+0+16) = AX0;
    DM(a_VolTrack02+0+16) = AX1;
    DM(a_TrigTrack01+0+22) = AX0;
    DM(a_VolTrack01+0+22) = AX1;
    DM(a_TrigTrack02+0+22) = AX0;
    DM(a_VolTrack02+0+22) = AX1;
    DM(a_TrigTrack01+0+50) = AX0;
    DM(a_VolTrack01+0+50) = AX1;
    DM(a_TrigTrack02+0+50) = AX0;
    DM(a_VolTrack02+0+50) = AX1;
    DM(a_TrigTrack01+0+54) = AX0;
    DM(a_VolTrack01+0+54) = AX1;
    DM(a_TrigTrack02+0+54) = AX0;
    DM(a_VolTrack02+0+54) = AX1;
    DM(a_TrigTrack01+0+80) = AX0;
    DM(a_VolTrack01+0+80) = AX1;
    DM(a_TrigTrack02+0+80) = AX0;
    DM(a_VolTrack02+0+80) = AX1;
    DM(a_TrigTrack01+0+88) = AX0;
    DM(a_VolTrack01+0+88) = AX1;
    DM(a_TrigTrack02+0+88) = AX0;
    DM(a_VolTrack02+0+88) = AX1;
    DM(a_TrigTrack01+0+114) = AX0;
    DM(a_VolTrack01+0+114) = AX1;
    DM(a_TrigTrack02+0+114) = AX0;
    DM(a_VolTrack02+0+114) = AX1;
    DM(a_TrigTrack01+0+118) = AX0;
    DM(a_VolTrack01+0+118) = AX1;
    DM(a_TrigTrack02+0+118) = AX0;
    DM(a_VolTrack02+0+118) = AX1;
    DM(a_TrigTrack01+0+124) = AX0;
    DM(a_VolTrack01+0+124) = AX1;
    DM(a_TrigTrack02+0+124) = AX0;
    DM(a_VolTrack02+0+124) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x0500;
    DM(a_TrigTrack01+0+55) = AX0;
    DM(a_VolTrack01+0+55) = AX1;
    DM(a_TrigTrack02+0+55) = AX0;
    DM(a_VolTrack02+0+55) = AX1;
    DM(a_TrigTrack01+0+62) = AX0;
    DM(a_VolTrack01+0+62) = AX1;
    DM(a_TrigTrack02+0+62) = AX0;
    DM(a_VolTrack02+0+62) = AX1;
    DM(a_TrigTrack01+0+63) = AX0;
    DM(a_VolTrack01+0+63) = AX1;
    DM(a_TrigTrack02+0+63) = AX0;
    DM(a_VolTrack02+0+63) = AX1;
    DM(a_TrigTrack01+0+119) = AX0;
    DM(a_VolTrack01+0+119) = AX1;
    DM(a_TrigTrack02+0+119) = AX0;
    DM(a_VolTrack02+0+119) = AX1;
    DM(a_TrigTrack01+0+126) = AX0;
    DM(a_VolTrack01+0+126) = AX1;
    DM(a_TrigTrack02+0+126) = AX0;
    DM(a_VolTrack02+0+126) = AX1;
    DM(a_TrigTrack01+0+127) = AX0;
    DM(a_VolTrack01+0+127) = AX1;
    DM(a_TrigTrack02+0+127) = AX0;
    DM(a_VolTrack02+0+127) = AX1;

    /* inits for v */
    AX0 = 100;
    AX1 = 0x0300;
    DM(a_TrigTrack01+0+2) = AX0;
    DM(a_VolTrack01+0+2) = AX1;
    DM(a_TrigTrack02+0+2) = AX0;
    DM(a_VolTrack02+0+2) = AX1;
    DM(a_TrigTrack01+0+30) = AX0;
    DM(a_VolTrack01+0+30) = AX1;
    DM(a_TrigTrack02+0+30) = AX0;
    DM(a_VolTrack02+0+30) = AX1;
    DM(a_TrigTrack01+0+34) = AX0;
    DM(a_VolTrack01+0+34) = AX1;
    DM(a_TrigTrack02+0+34) = AX0;
    DM(a_VolTrack02+0+34) = AX1;
    DM(a_TrigTrack01+0+68) = AX0;
    DM(a_VolTrack01+0+68) = AX1;
    DM(a_TrigTrack02+0+68) = AX0;
    DM(a_VolTrack02+0+68) = AX1;
    DM(a_TrigTrack01+0+96) = AX0;
    DM(a_VolTrack01+0+96) = AX1;
    DM(a_TrigTrack02+0+96) = AX0;
    DM(a_VolTrack02+0+96) = AX1;
    DM(a_TrigTrack01+0+110) = AX0;
    DM(a_VolTrack01+0+110) = AX1;
    DM(a_TrigTrack02+0+110) = AX0;
    DM(a_VolTrack02+0+110) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x1800;
    DM(a_TrigTrack03+0+4) = AX0;
    DM(a_VolTrack03+0+4) = AX1;
    DM(a_TrigTrack04+0+4) = AX0;
    DM(a_VolTrack04+0+4) = AX1;
    DM(a_TrigTrack03+0+12) = AX0;
    DM(a_VolTrack03+0+12) = AX1;
    DM(a_TrigTrack04+0+12) = AX0;
    DM(a_VolTrack04+0+12) = AX1;
    DM(a_TrigTrack03+0+20) = AX0;
    DM(a_VolTrack03+0+20) = AX1;
    DM(a_TrigTrack04+0+20) = AX0;
    DM(a_VolTrack04+0+20) = AX1;
    DM(a_TrigTrack03+0+44) = AX0;
    DM(a_VolTrack03+0+44) = AX1;
    DM(a_TrigTrack04+0+44) = AX0;
    DM(a_VolTrack04+0+44) = AX1;
    DM(a_TrigTrack03+0+52) = AX0;
    DM(a_VolTrack03+0+52) = AX1;
    DM(a_TrigTrack04+0+52) = AX0;
    DM(a_VolTrack04+0+52) = AX1;
    DM(a_TrigTrack03+0+60) = AX0;
    DM(a_VolTrack03+0+60) = AX1;
    DM(a_TrigTrack04+0+60) = AX0;
    DM(a_VolTrack04+0+60) = AX1;
    DM(a_TrigTrack03+0+70) = AX0;
    DM(a_VolTrack03+0+70) = AX1;
    DM(a_TrigTrack04+0+70) = AX0;
    DM(a_VolTrack04+0+70) = AX1;
    DM(a_TrigTrack03+0+76) = AX0;
    DM(a_VolTrack03+0+76) = AX1;
    DM(a_TrigTrack04+0+76) = AX0;
    DM(a_VolTrack04+0+76) = AX1;
    DM(a_TrigTrack03+0+84) = AX0;
    DM(a_VolTrack03+0+84) = AX1;
    DM(a_TrigTrack04+0+84) = AX0;
    DM(a_VolTrack04+0+84) = AX1;
    DM(a_TrigTrack03+0+108) = AX0;
    DM(a_VolTrack03+0+108) = AX1;
    DM(a_TrigTrack04+0+108) = AX0;
    DM(a_VolTrack04+0+108) = AX1;
    DM(a_TrigTrack03+0+124) = AX0;
    DM(a_VolTrack03+0+124) = AX1;
    DM(a_TrigTrack04+0+124) = AX0;
    DM(a_VolTrack04+0+124) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0800;
    DM(a_TrigTrack03+0+30) = AX0;
    DM(a_VolTrack03+0+30) = AX1;
    DM(a_TrigTrack04+0+30) = AX0;
    DM(a_VolTrack04+0+30) = AX1;
    DM(a_TrigTrack03+0+31) = AX0;
    DM(a_VolTrack03+0+31) = AX1;
    DM(a_TrigTrack04+0+31) = AX0;
    DM(a_VolTrack04+0+31) = AX1;
    DM(a_TrigTrack03+0+62) = AX0;
    DM(a_VolTrack03+0+62) = AX1;
    DM(a_TrigTrack04+0+62) = AX0;
    DM(a_VolTrack04+0+62) = AX1;
    DM(a_TrigTrack03+0+94) = AX0;
    DM(a_VolTrack03+0+94) = AX1;
    DM(a_TrigTrack04+0+94) = AX0;
    DM(a_VolTrack04+0+94) = AX1;
    DM(a_TrigTrack03+0+95) = AX0;
    DM(a_VolTrack03+0+95) = AX1;
    DM(a_TrigTrack04+0+95) = AX0;
    DM(a_VolTrack04+0+95) = AX1;
    DM(a_TrigTrack03+0+126) = AX0;
    DM(a_VolTrack03+0+126) = AX1;
    DM(a_TrigTrack04+0+126) = AX0;
    DM(a_VolTrack04+0+126) = AX1;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x1000;
    DM(a_TrigTrack03+0+32) = AX0;
    DM(a_VolTrack03+0+32) = AX1;
    DM(a_TrigTrack04+0+32) = AX0;
    DM(a_VolTrack04+0+32) = AX1;
    DM(a_TrigTrack03+0+64) = AX0;
    DM(a_VolTrack03+0+64) = AX1;
    DM(a_TrigTrack04+0+64) = AX0;
    DM(a_VolTrack04+0+64) = AX1;
    DM(a_TrigTrack03+0+96) = AX0;
    DM(a_VolTrack03+0+96) = AX1;
    DM(a_TrigTrack04+0+96) = AX0;
    DM(a_VolTrack04+0+96) = AX1;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x0400;
    DM(a_TrigTrack03+0+28) = AX0;
    DM(a_VolTrack03+0+28) = AX1;
    DM(a_TrigTrack04+0+28) = AX0;
    DM(a_VolTrack04+0+28) = AX1;
    DM(a_TrigTrack03+0+90) = AX0;
    DM(a_VolTrack03+0+90) = AX1;
    DM(a_TrigTrack04+0+90) = AX0;
    DM(a_VolTrack04+0+90) = AX1;
    DM(a_TrigTrack03+0+114) = AX0;
    DM(a_VolTrack03+0+114) = AX1;
    DM(a_TrigTrack04+0+114) = AX0;
    DM(a_VolTrack04+0+114) = AX1;
    DM(a_TrigTrack03+0+118) = AX0;
    DM(a_VolTrack03+0+118) = AX1;
    DM(a_TrigTrack04+0+118) = AX0;
    DM(a_VolTrack04+0+118) = AX1;

    /* inits for i */
    AX0 = 100;
    AX1 = 0x0a00;
    DM(a_TrigTrack09+0+4) = AX0;
    DM(a_VolTrack09+0+4) = AX1;
    DM(a_TrigTrack10+0+4) = AX0;
    DM(a_VolTrack10+0+4) = AX1;
    DM(a_TrigTrack09+0+16) = AX0;
    DM(a_VolTrack09+0+16) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;
    DM(a_TrigTrack09+0+40) = AX0;
    DM(a_VolTrack09+0+40) = AX1;
    DM(a_TrigTrack10+0+40) = AX0;
    DM(a_VolTrack10+0+40) = AX1;
    DM(a_TrigTrack09+0+48) = AX0;
    DM(a_VolTrack09+0+48) = AX1;
    DM(a_TrigTrack10+0+48) = AX0;
    DM(a_VolTrack10+0+48) = AX1;
    DM(a_TrigTrack09+0+64) = AX0;
    DM(a_VolTrack09+0+64) = AX1;
    DM(a_TrigTrack10+0+64) = AX0;
    DM(a_VolTrack10+0+64) = AX1;
    DM(a_TrigTrack09+0+80) = AX0;
    DM(a_VolTrack09+0+80) = AX1;
    DM(a_TrigTrack10+0+80) = AX0;
    DM(a_VolTrack10+0+80) = AX1;
    DM(a_TrigTrack09+0+96) = AX0;
    DM(a_VolTrack09+0+96) = AX1;
    DM(a_TrigTrack10+0+96) = AX0;
    DM(a_VolTrack10+0+96) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x0000;
    DM(a_TrigTrack09+0+24) = AX0;
    DM(a_VolTrack09+0+24) = AX1;
    DM(a_TrigTrack10+0+24) = AX0;
    DM(a_VolTrack10+0+24) = AX1;
    DM(a_TrigTrack09+0+62) = AX0;
    DM(a_VolTrack09+0+62) = AX1;
    DM(a_TrigTrack10+0+62) = AX0;
    DM(a_VolTrack10+0+62) = AX1;
    DM(a_TrigTrack09+0+76) = AX0;
    DM(a_VolTrack09+0+76) = AX1;
    DM(a_TrigTrack10+0+76) = AX0;
    DM(a_VolTrack10+0+76) = AX1;
    DM(a_TrigTrack09+0+120) = AX0;
    DM(a_VolTrack09+0+120) = AX1;
    DM(a_TrigTrack10+0+120) = AX0;
    DM(a_VolTrack10+0+120) = AX1;

/* donotparse(CLEAR, 0, 1,  --v----- b------- c-----c- b-----v-  --v----- b------- --c---ch --b---hh   ----v--- b------- c-----b- c-------  v------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 2,  --v----- b------- c-----c- b-----v-  --v----- b------- --c---ch --b---hh   ----v--- b------- c-----b- c-------  v------- b-----v- --c---ch b---c-hh,
            CLEAR, 0, 3,  ----d--- ----d--- ----d--- ----g-ee  f------- ----d--- ----d--- ----d-e-   f-----d- ----d--- ----d--- --g---ee  f------- ----d--- --g---g- ----d-e-,
            CLEAR, 0, 4,  ----d--- ----d--- ----d--- ----g-ee  f------- ----d--- ----d--- ----d-e-   f-----d- ----d--- ----d--- --g---ee  f------- ----d--- --g---g- ----d-e-,
            CLEAR, 0, 9,  ----i--- -------- i------- j-------  -------- i------- i------- ------j-   i------- ----j--- i------- --------  i------- -------- -------- j-------,
            CLEAR, 0, 10, ----i--- -------- i------- j-------  -------- i------- i------- ------j-   i------- ----j--- i------- --------  i------- -------- -------- j-------,
            b, 100, 0x1400,
            c, 100, 0x0800,
            h, 100, 0x0500,
            v, 100, 0x0300,
            d, 100, 0x1800,
            e, 100, 0x0800,
            f, 100, 0x1000,
            g, 100, 0x0400,
            i, 100, 0x0a00,
            j, 100, 0x0000,
            END); */
            
    AX0 = 24*1;
    DM(a_LFO+(8*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    AX0 = 24*2;
    DM(a_LFO+(12*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure80:
    SET_VOLENV(0, 0x0000, 0x0000, 1);

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(2*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    DM(a_FM2Op0Gen+(3*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;

    jump MultiMeasureCheck;

Measure82:

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(0*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    DM(a_FM2Op0Gen+(1*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;    
    
    SET_VOLENV(9, 0x2800, 0x2800, 1);
    SET_VOLENV(10, 0x2800, 0x2800, 1);

    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(2*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    DM(a_FM2Op0Gen+(3*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;

Measure84:
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_MODLUT) = AR;
    
    SET_VOLENV(7, 0x0800, 0x0800, 1);
    SET_VOLENV(8, 0x0800, 0x0800, 1);
    
    SET_VOLENV(1, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(2, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(3, 0x7fff, 0x0000, MEASURE*4);
    SET_VOLENV(4, 0x7fff, 0x0000, MEASURE*4);
    
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(0*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    DM(a_FM2Op0Gen+(1*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;

Measure86:
    
    SET_VOLENV(11, 0x2800, 0x2800, 1);
    
    AR = ^a_RandLUT;
    DM(a_FM2Op0Gen+(4*FM2OP0GEN_VARS)+FM2OP0GEN_CARRLUT) = AR;
    
    jump MultiMeasureCheck;
    
Measure88:
    SET_VOLENV(0, 0x0000, 0x0000, 1);
    SET_VOLENV(1, 0x0000, 0x0000, 1);
    SET_VOLENV(2, 0x0000, 0x0000, 1);
    SET_VOLENV(3, 0x0000, 0x0000, 1);
    SET_VOLENV(4, 0x0000, 0x0000, 1);
    SET_VOLENV(5, 0x0000, 0x0000, 1);
    SET_VOLENV(6, 0x0000, 0x0000, 1);
    SET_VOLENV(7, 0x0000, 0x0000, 1);
    SET_VOLENV(8, 0x0000, 0x0000, 1);
    SET_VOLENV(9, 0x0000, 0x0000, 1);
    SET_VOLENV(10, 0x0000, 0x0000, 1);
    SET_VOLENV(11, 0x0000, 0x0000, 1);
    SET_VOLENV(12, 0x0000, 0x0000, 1);
    SET_VOLENV(13, 0x0000, 0x0000, 1);
    
    AX0 = 6;
    DM(a_LFO+(8*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(9*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(10*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(11*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    AX0 = 3;
    DM(a_LFO+(12*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(13*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(14*LFO_VARS)+LFO_HOLDPER) = AX0;
    DM(a_LFO+(15*LFO_VARS)+LFO_HOLDPER) = AX0;
    
    jump MultiMeasureCheck;

Measure92:
    SET_VOLENV(14, 0x0000, 0x0000, 1);
    SET_VOLENV(15, 0x0000, 0x0000, 1);

    jump MultiMeasureCheck;
            
DoNothing:
    jump MultiMeasureCheck;

.ENDMOD;
