#!/usr/bin/perl

##
 #  allmacroinits[0]:  macro to search for, also in place holder replacement
 #  allmacroinits[1]:  array inserted in to SETPTR
 #  allmacroinits[2]:  boolean, was this macro found?
 #  allmacroinits[3]:  counter, number of inits of particular type
 ##

@allmacroinits = (
        "INIT_ALGOSINEGEN",         "a_AlgoSineGen",            0,      0,
        "INIT_ALGOSINEGEN_MF",      "a_AlgoSineGen",            0,      0,
        "INIT_ALGOSINESATGEN",      "a_AlgoSineSatGen",         0,      0,
        "INIT_ALGOSINESATGEN_MF",   "a_AlgoSineSatGen",         0,      0,
        "INIT_ADSRPANENV",          "a_ADSRPanEnv",             0,      0,
        "INIT_BITMASKFX",           "a_BitMaskFX",              0,      0,
        "INIT_CLAMPFX",             "a_ClampFX",                0,      0,
        "INIT_COPIEDGEN",           "a_CopiedGen",              0,      0,
        "INIT_EXP1GEN",             "a_Exp1Gen",                0,      0,
        "INIT_EXPDECAYENV",         "a_ExpDecayEnv",            0,      0,
        "INIT_EXPIMPULSEGEN",       "a_ExpImpulseGen",          0,      0,
        "INIT_FM2OP0GEN",           "a_FM2Op0Gen",              0,      0,
        "INIT_GENSHFX",             "a_GenSHFX",                0,      0,
        "INIT_HPWTGEN2",            "a_HPWTGen2",               0,      0,
        "INIT_KILLTIMEFX",          "a_KillTimeFX",             0,      0,
        "INIT_KSGEN",               "a_KSGen",                  0,      0,
        "INIT_KSGEN_MF",            "a_KSGen",                  0,      0,
        "INIT_LFO3",                "a_LFO3",                   0,      0,
        "INIT_MEMENV1",             "a_MemEnv1",                0,      0,
        "INIT_MEMENV2",             "a_MemEnv2",                0,      0,
        "INIT_MEMENV3",             "a_MemEnv3",                0,      0,
        "INIT_OSCCOMBGEN",          "a_OscCombGen",             0,      0,
        "INIT_PERNOISEGEN",         "a_PerNoiseGen",            0,      0,
        "INIT_PREVCURRFILTFX",      "a_PrevCurrFiltFX",         0,      0,
        "INIT_PROBKSGEN",           "a_ProbKSGen",              0,      0,
        "INIT_PROBKSGEN_MF",        "a_ProbKSGen",              0,      0,
        "INIT_PROBSYNTHGEN",        "a_ProbSynthGen",           0,      0,
        "INIT_RECTIFYFX",           "a_RectifyFX",              0,      0,
        "INIT_ROTSYNTHGEN",         "a_RotSynthGen",            0,      0,
        "INIT_SVFFX",               "a_SVFFX",                  0,      0,
        "INIT_TUNEDROTSYNTHGEN",    "a_TunedRotSynthGen",       0,      0,
        "INIT_WAVESHAPEFX",         "a_WaveShapeFX",            0,      0,
        "INIT_WTGEN",               "a_WTGen",                  0,      0,
        "INIT_WTGEN_MF",            "a_WTGen",                  0,      0,
        "INIT_WTGEN2",              "a_WTGen2",                 0,      0,
        "INIT_WTGEN2_MF",           "a_WTGen2",                 0,      0,
        "INIT_WTGENSYNCFX",         "a_WTGenSyncFX",            0,      0,
        "INIT_ZEROSAMPSFX",         "a_ZeroSampFX",             0,      0);

$KSBuffcntr = 0;

# at this point cloneproj already called
$presetprojfile = "..\\"."$ARGV[0]".".proj";
die "\n  presetproj [preset project file] \n" if !defined($ARGV[0]);

# open .proj file (if it exists)
open (PROJFILE, "$presetprojfile")
    or die "\n  $presetprojfile doesn't exist!\n";

open(PRESETFILE, "sdk.preset");

# open files that will be modified
open(GENFXFILE, "..\\"."$ARGV[0]"."\\GenFX_00.dsp");
open(GENFXINIFILE, "..\\"."$ARGV[0]"."\\GenFXIni_00.dsp");
open(TRIGINITFILE, "..\\"."$ARGV[0]"."\\TrigInit_00.dsp");
open(VARHDRFILE, "..\\"."$ARGV[0]"."\\hdr\\"."$ARGV[0]"."vars.h");

@projfile = <PROJFILE>;
@presetfile = <PRESETFILE>;

@genfxfile = <GENFXFILE>;
@genfxinifile = <GENFXINIFILE>;
@triginitfile = <TRIGINITFILE>;
@varhdrfile = <VARHDRFILE>;

open(TMPGENFXINIFILE, ">", "..\\"."$ARGV[0]"."\\genfxini.tmp");
open(TMPGENFXFILE, ">", "..\\"."$ARGV[0]"."\\genfx.tmp");
open(TMPTRIGINITFILE, ">", "..\\"."$ARGV[0]"."\\triginit.tmp");
open(TMPVARHDRFILE, ">", "..\\"."$ARGV[0]\\"."hdr\\"."varhdr.tmp");

$i=0;
$tmpcount = 0;

# read .proj file, parse into 6 element list
foreach $projline (@projfile)
{
    @projparams = parse_csv($projline);
    if($tmpcount>1)
    {
        $inst_track[$i] = trimspace($projparams[0]);
        $tilabel_track[$i] = "init_"."$inst_track[$i]"."_$i";
        $pan_track[$i] = trimspace($projparams[1]);
        $swingper_track[$i] = trimspace($projparams[2]);
        $swingamount_track[$i] = trimspace($projparams[3]);
        $tics_track[$i] = trimspace($projparams[4]);
        $seqlen_track[$i] = trimspace($projparams[5]);
        $i++;
    }
    $tmpcount++;
}

$numtracks = $i;
$line = 0;

foreach $presetline (@presetfile)
{
    # find a preset in sdk.preset
    #if($presetline =~ /preset/)
    if($presetfile[$line] =~ /preset/)
    {
        # try and match preset name with instrument type from .sid file
        $line++;
        $presetname = trimspace($presetfile[$line]);
        $tmpline = $line;
        for($j=0; $j<$numtracks; $j++)
        {
            # if preset matches requested instrument, grab preset code
            if ($presetname eq $inst_track[$j])
            {
                $line = $tmpline;           # rewind $line to check curr preset
                $presetinitlines = 0;
                $line++;
                $line++;
                # get presetinit code
                while (trimspace($presetfile[$line]) ne "presetcall")
                {
                    $presetinit[$presetinitlines][$j] = trimspace($presetfile[$line]);
                    # get envelope type for sequencer init macro
                    if($presetinit[$presetinitlines][$j] =~ /ADSRPANENV/)
                    {
                        $envtype_track[$j] = "ADSRENV";
                    }
                    if($presetinit[$presetinitlines][$j] =~ /EXPDECAYENV/)
                    {
                        $envtype_track[$j] = "EXPDECAYENV";
                    }
                    $line++;
                    $presetinitlines++;
                }
                $initlines[$j] = $presetinitlines;
                $line++;                    # skip presetcall
                $presetcalllines = 0;
                
                # get presetcall code
                while (trimspace($presetfile[$line]) ne "presetretrig")
                {
                    $presetcall[$presetcalllines][$j] = trimspace($presetfile[$line]);
                    $line++;
                    $presetcalllines++;
                }
                $line++;                    # skip presetretrig
                $calllines[$j] = $presetcalllines;
                $presetretriglines = 0;
                
                # get presetretrig code
                while (trimspace($presetfile[$line]) ne "endpreset")
                {
                    $presetretrig[$presetretriglines][$j] = trimspace($presetfile[$line]);
                    $line++;
                    $presetretriglines++;
                }
                $retriglines[$j] = $presetretriglines;
            }
        }        
    }
    $line++;
}

# scan code in presetinit and presetretrig, replace symbolic values
for($i=0; $i<$numtracks; $i++)
{
    for($j=0; $j<$initlines[$i]; $j++)
    {
        $presetinit[$j][$i] = &replaceinstanceholders($presetinit[$j][$i]);
    }
}
    
for($j=3; $j<(scalar @allmacroinits); $j+=4)
{
    $allmacroinits[$j] = 0;
}

for($i=0; $i<$numtracks; $i++)
{
    for($j=0; $j<$retriglines[$i]; $j++)
    {
        $presetretrig[$j][$i] = &replaceinstanceholders($presetretrig[$j][$i]);
    }
}

# create 4 new files
&makegenfxinicode;
&makegenfxcode;
&maketriginitcode;
&makevarhdrcode;

close(TMPGENFXINIFILE);
close(TMPGENFXFILE);
close(TMPTRIGINITFILE);
close(TMPVARHDRFILE);

##
 #  parse_csv:  parse line of data, write to array of arrays
 ##

sub parse_csv
{
    my $text = shift;
    my @new = ();
    push(@new, $+) while $text =~ m{
        # the first part groups the phrase inside the quotes
        "([^\"\\]*(?:\\.[^\"\\]*)*)",?
            |   ([^,]+),?
            |   ,
        }gx;
    push(@new, undef) if substr($text, -1, 1) eq ',';
    return @new;
}

##
 #  trimspace:  trim preceding/following spaces around array
 ##

sub trimspace
{
    my @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}

##
 #  makegenfxinicode:  read macros in presetinit and generate appropriate inits
 ##

sub makegenfxinicode
{
    foreach $genfxiniline (@genfxinifile)
    {
        if($genfxiniline =~ /insert generators and fx initializations here/)
        {
            print TMPGENFXINIFILE "$genfxiniline";
            local $i, $j, $k;
            for($k=0; $k<$numtracks; $k++) {
                for($i=0; $i<$presetinitlines; $i++)
                {
                    # find all gen/fx/ME used in presets
                    &scanonepresetinit($presetinit[$i][$k]);
                }
            }
            
            for($i=2; $i<(scalar @allmacroinits); $i+=4)
            {
                # check if gen init needed
                if($allmacroinits[$i] == 1)
                {
                    print TMPGENFXINIFILE "    SETPTR($allmacroinits[$i-1]);\n";
                    for($k=0; $k<$numtracks; $k++)
                    {
                        for($j=0; $j<$presetinitlines; $j++)
                        {
                            if($presetinit[$j][$k] =~ /$allmacroinits[$i-2]\(/)
                            {
                                print TMPGENFXINIFILE "    $presetinit[$j][$k]\n";
                            }
                        }
                    }
               print TMPGENFXINIFILE "\n";
               }
           }
        }
        elsif($genfxiniline =~ /numtrax set by CalcSeq2Tracks/)
        {
            print TMPGENFXINIFILE "$genfxiniline";
            for($k=0; $k<$numtracks; $k++)
            {
                print TMPGENFXINIFILE "    INIT_SEQ2($tics_track[$k], $swingper_track[$k], $swingamount_track[$k], $seqlen_track[$k], ^$tilabel_track[$k], $envtype_track[$k], ^DummyRet);\n";
            }
        }
        else
        {
            print TMPGENFXINIFILE "$genfxiniline";
        }
    }
}

##
 # scanonepresetinit:  check for usage of macro, if true set bit in
 #                     allmacroinits to indicated SETPTR needed
 ##
 
sub scanonepresetinit
{    
    local $i;
    for($i=0; $i<(scalar @allmacroinits); $i+=4)
    {
        $comptmp = $allmacroinits[$i];
        #print "comparing $_[0] to $comptmp\n";
        if($_[0] =~ /$comptmp\(/)
        {
            $allmacroinits[$i+2] = 1;
        }
    }
}

##
 # replaceinstanceholders:  find _blah_ in macro inits from .preset file,
 #                          substitute with appropriate numbers
 ##
 
sub replaceinstanceholders
{
    local $a;
    for($a=0; $a<(scalar @allmacroinits); $a+=4)
    {
        $tmpholder = substr($allmacroinits[$a], 5);
        $tmpholder = "_".$tmpholder."num_";
        if($_[0] =~ /$tmpholder/)
        {
            $_[0] =~ s/$tmpholder/$allmacroinits[$a+3]/g;
            $allmacroinits[$a+3]++;
        }
        if($_[0] =~ /_PAN_/)
        {
            $_[0] =~ s/_PAN_/$pan_track[$i]/g;      # i from parent code
        }
        if($_[0] =~ /a_KSBuff_KSBuffnum_/)
        {
            $_[0] =~ s/a_KSBuff_KSBuffnum_/a_KSBuff$KSBuffcntr/g;
            $KSBuffcntr++;
        }
    }
return $_[0];
}

##
 #  makegenfxcode:  construct new GenFX file, taking code directly from .preset
 #                  file and placing it in GenFX.dsp

sub makegenfxcode
{
    local $i, $j;
    foreach $genfxline (@genfxfile)
    {
        # if at start of GenFX file, insert all function calls
        if($genfxline =~ /insert generators and fx here/)
        {
            print TMPGENFXFILE "$genfxline";
            for($i=0; $i<$numtracks; $i++)
            {
                for($j=0; $j<$calllines[$i]; $j++)
                {
                    print TMPGENFXFILE "    $presetcall[$j][$i]\n";
                }
                print TMPGENFXFILE "\n";
            }
        }
        else
        {
            print TMPGENFXFILE "$genfxline";
        }
    }
}

##
 #  maketriginitcode:  take post-processed code from .preset presetretrig and
 #                     write to TrigInit.dsp
 ##
            
sub maketriginitcode
{
    local $i, $j;
    foreach $triginitline (@triginitfile)
    {
        if($triginitline =~ /TrigInit_00:/)
        {
            for($i=0; $i<$numtracks; $i++)
            {
                print TMPTRIGINITFILE ".ENTRY       $tilabel_track[$i];\n";
            }
            print TMPTRIGINITFILE "\n";
            print TMPTRIGINITFILE "$triginitline";
            print TMPTRIGINITFILE "\n";
            
            for($i=0; $i<$numtracks; $i++)
            {
                print TMPTRIGINITFILE "$tilabel_track[$i]:\n";
                for($j=0; $j<$retriglines[$i]; $j++)
                {
                    print TMPTRIGINITFILE "    $presetretrig[$j][$i]\n";
                }
                print TMPTRIGINITFILE "\n";
            }
        }
        else
        {
            print TMPTRIGINITFILE "$triginitline";
        }
    }
}

##
 # makevarhdrcode:  must include all TrigInit lables in here
 ##

sub makevarhdrcode
{
    local $i;
    $stopcopyout = 0;
    foreach $varhdrline (@varhdrfile)
    {
        if($varhdrline =~ /place .external declarations in here to avoid compilation errors/)
        {
            
            print TMPVARHDRFILE "$varhdrline";
            print TMPVARHDRFILE " */\n";
            print TMPVARHDRFILE "\n";
            for($i=0; $i<$numtracks; $i++)
            {
                print TMPVARHDRFILE ".EXTERNAL    $tilabel_track[$i];\n";
            }
            print TMPVARHDRFILE "\n";
            print TMPVARHDRFILE "#endif\n";
            $stopcopyout = 1;
        }
        else
        {
            if($stopcopyout == 0)
            {
                print TMPVARHDRFILE "$varhdrline";
            }
        }
    }
}
    